# Changelog

## 2025.5.1 (14 May 2025) Release

Notable changes:

-   Release version that includes changes through the [2025.4.104](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20254104-9-may-2025-prerelease) prerelease build.
-   Bug fix: Crash when activating Pylance in untrusted workspace [pylance-release#7214](https://github.com/microsoft/pylance-release/issues/7214)

## 2025.4.104 (9 May 2025) PreRelease

Notable changes:

-   Bug fix: Recent problem with mangled syntax highlighting (2025.4.103) [pylance-release#7190](https://github.com/microsoft/pylance-release/issues/7190)

## 2025.4.103 (6 May 2025) PreRelease

Notable changes:

-   Bug fix: Kernel selection events don't fire if the Python Environment manager is installed [pylance-release#7175](https://github.com/microsoft/pylance-release/issues/7175)
-   Enhancement: Move symbol to new file. Missing typing.Self imports [pylance-release#7138](https://github.com/microsoft/pylance-release/issues/7138)
-   Bug fix: Move symbol to new file. Incorrect import statement generated in new file [pylance-release#7137](https://github.com/microsoft/pylance-release/issues/7137)

## 2025.4.102 (30 April 2025) PreRelease

Notable changes:

-   Bug fix: Auto Import fails on symbols starting with Umlaut [pylance-release#7146](https://github.com/microsoft/pylance-release/issues/7146)
-   Bug fix: Forever "... files and ... cells to analyze" [pylance-release#7087](https://github.com/microsoft/pylance-release/issues/7087)

## 2025.4.101 (23 April 2025) PreRelease

Notable changes:

-   Bug fix: `code actions with copilot` not working when copilot chat is not signed in [pylance-release#7142](https://github.com/microsoft/pylance-release/issues/7142)
-   Bug fix: Wrong french translation [pylance-release#6758](https://github.com/microsoft/pylance-release/issues/6758)
-   Enhancement: Auto format strings doesn't work for `r` strings [pylance-release#5703](https://github.com/microsoft/pylance-release/issues/5703)

Pylance's copy of Pyright has been updated from 1.1.399 to 1.1.400.

-   See Pyright's release notes for details: [1.1.400](https://github.com/microsoft/pyright/releases/tag/1.1.400)

## 2025.4.100 (9 April 2025) PreRelease

Notable changes:

-   Enhancement: Invoke color picker with shortcut [pylance-release#6761](https://github.com/microsoft/pylance-release/issues/6761)
-   Bug fix: Pylance crashes when there is a star import from a local module in `__builtins__.pyi` [pylance-release#7095](https://github.com/microsoft/pylance-release/issues/7095)

Pylance's copy of Pyright has been updated from 1.1.398 to 1.1.399.

-   See Pyright's release notes for details: [1.1.399](https://github.com/microsoft/pyright/releases/tag/1.1.399)

## 2025.4.1 (2 April 2025) Release

Notable changes:

-   Release version that includes changes through the [2025.3.105](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20253105-31-march-2025-prerelease) prerelease build.

## 2025.3.105 (31 March 2025) PreRelease

Notable changes:

-   Bug fix: Virtual workspaces seem to have limited setting set (like the browser version) [pylance-release#5394](https://github.com/microsoft/pylance-release/issues/5394)

## 2025.3.104 (27 March 2025) PreRelease

Notable changes:

-   Bug fix: Support custom schema with '.py' extension [pylance-release#7055](https://github.com/microsoft/pylance-release/issues/7055)
-   Bug fix: Unstable import resolution in jupyter notebook [pylance-release#7045](https://github.com/microsoft/pylance-release/issues/7045)
-   Enhancement: Allow setting --max-old-space-size when using python.analysis.nodeExecutable [pylance-release#5820](https://github.com/microsoft/pylance-release/issues/5820)
-   Bug fix: variable is reported as not accessed when it's used only in f-strings and the string is a function param [pylance-release#7054](https://github.com/microsoft/pylance-release/issues/7054)

Pylance's copy of Pyright has been updated from 1.1.397 to 1.1.398.

-   See Pyright's release notes for details: [1.1.398](https://github.com/microsoft/pyright/releases/tag/1.1.398)

## 2025.3.103 (20 March 2025) PreRelease

Pylance's copy of Pyright has been updated from 1.1.396 to 1.1.397.

-   See Pyright's release notes for details: [1.1.397](https://github.com/microsoft/pyright/releases/tag/1.1.397)

## 2025.3.2 (13 March 2025) Release

Notable changes:

-   Bug fix: Fix crash when pylance is used with old copilot extension.

## 2025.3.102 (13 March 2025) PreRelease

Notable changes:

-   Bug fix: Fix crash when pylance is used with old copilot extension.

## 2025.3.101 (12 March 2025) PreRelease

Notable changes:

-   Bug fix: Hitting enter after the first part of a multiline string generates invalid quotes [pylance-release#6961](https://github.com/microsoft/pylance-release/issues/6961)
-   Bug fix: [Bug] Function parentheses autocomplete does not recognize existing parentheses [pylance-release#3032](https://github.com/microsoft/pylance-release/issues/3032)
-   Bug fix: Inaccurate translation of "Auto-Import Completions" in zh-cn [pylance-release#6781](https://github.com/microsoft/pylance-release/issues/6781)

## 2025.3.100 (6 March 2025) PreRelease

Notable changes:

-   Testing release pipeline.

## 2025.3.1 (5 March 2025) Release

Notable changes:

-   Release version that includes changes through the [2025.2.103](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20252103-3-march-2025-prerelease) prerelease build.
-   Enhancement: Add \ when adding line breaks in strings in the middle of assignments [pylance-release#7002](https://github.com/microsoft/pylance-release/issues/7002)

## 2025.2.103 (3 March 2025) PreRelease

Pylance's copy of Pyright has been updated from 1.1.395 to 1.1.396.

-   See Pyright's release notes for details: [1.1.396](https://github.com/microsoft/pyright/releases/tag/1.1.396)

## 2025.2.102 (27 February 2025) PreRelease

Notable changes:

-   Bug fix: Crash in pylance when using 'editable' install setting [pylance-release#6987](https://github.com/microsoft/pylance-release/issues/6987)
-   Bug fix: `reportAttributeAccessIssue` on Hugging Face `transformers` top-level attributes only in Pre-Release [pylance-release#6966](https://github.com/microsoft/pylance-release/issues/6966)

Pylance's copy of Pyright has been updated from 1.1.394 to 1.1.395.

-   See Pyright's release notes for details: [1.1.395](https://github.com/microsoft/pyright/releases/tag/1.1.395)

## 2025.2.101 (20 February 2025) PreRelease

Notable changes:

-   Bug fix: ERROR: Pylance failed to parse docstring at index 1 [pylance-release#6952](https://github.com/microsoft/pylance-release/issues/6952)
-   Bug fix: Pylance failed to parse docstring [pylance-release#6951](https://github.com/microsoft/pylance-release/issues/6951)
-   Bug fix: Unparseable docstrings should fall back to the old docstring parser [pylance-release#6494](https://github.com/microsoft/pylance-release/issues/6494)

## 2025.2.100 (13 February 2025) PreRelease

Notable changes:

-   Bug fix: Semantic Highlighting: Variables of instances with **call** method get semantic token "function" since version 2025.2.1 [pylance-release#6924](https://github.com/microsoft/pylance-release/issues/6924)
-   Bug fix: Semantic Highlighting: How to correctly typehint method decorator which changes argument/return types, making it still recognized as a method [pylance-release#6921](https://github.com/microsoft/pylance-release/issues/6921)
-   Enhancement: Automatically add " when breaking long strings [pylance-release#6805](https://github.com/microsoft/pylance-release/issues/6805)
-   Bug fix: Get pull diagnostics working = Diagnostics from open files sometime not cleared up when file is closed. [pylance-release#5402](https://github.com/microsoft/pylance-release/issues/5402)
-   Bug fix: Semantic Highlighting for Class Method created by assigning method is wrongly coloured as `property` [pylance-release#5111](https://github.com/microsoft/pylance-release/issues/5111)
-   Bug fix: Could not rename all references when using new Generic syntax [pylance-release#6893](https://github.com/microsoft/pylance-release/issues/6893)

Pylance's copy of Pyright has been updated from 1.1.393 to 1.1.394.

-   See Pyright's release notes for details: [1.1.394](https://github.com/microsoft/pyright/releases/tag/1.1.394)

## 2025.2.1 (5 February 2025) Release

Notable changes:

-   Release version that includes changes through the [2025.1.102](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20251102-29-january-2025-prerelease) prerelease build.

## 2025.1.102 (29 January 2025) PreRelease

Pylance's copy of Pyright has been updated from 1.1.392 to 1.1.393.

-   See Pyright's release notes for details: [1.1.393](https://github.com/microsoft/pyright/releases/tag/1.1.393)

## 2025.1.101 (22 January 2025) PreRelease

Notable changes:

-   Bug fix: go to implementation should find implementation of all sub types transitively. [pylance-release#6775](https://github.com/microsoft/pylance-release/issues/6775)

## 2025.1.100 (15 January 2025) PreRelease

Notable changes:

-   Bug fix: importing class from wrong module [pylance-release#6843](https://github.com/microsoft/pylance-release/issues/6843)
-   Bug fix: "generateDocstring" in AI code action doesn't automatically pop [pylance-release#6766](https://github.com/microsoft/pylance-release/issues/6766)
-   Bug fix: NewType is not indexed [pylance-release#6601](https://github.com/microsoft/pylance-release/issues/6601)
-   Enhancement: Add semantic token modifiers to callable variables. [pylance-release#5841](https://github.com/microsoft/pylance-release/issues/5841)
-   Enhancement: Syntax highlighting for PEP 695: Type Parameter Syntax [pylance-release#5541](https://github.com/microsoft/pylance-release/issues/5541)
-   Enhancement: Improve semantic highlighting of `TypeAlias` [pylance-release#3100](https://github.com/microsoft/pylance-release/issues/3100)
-   Bug fix: Final annotation is not recognized across notebook cells [pylance-release#6455](https://github.com/microsoft/pylance-release/issues/6455)

Pylance's copy of Pyright has been updated from 1.1.390 to 1.1.392.

-   See Pyright's release notes for details: [1.1.391](https://github.com/microsoft/pyright/releases/tag/1.1.391), [1.1.392](https://github.com/microsoft/pyright/releases/tag/1.1.392)

## 2024.12.100 (16 December 2024) PreRelease

Notable changes:

-   Bug fix: Return type of generated docstrings is Any when it should not be [pylance-release#6745](https://github.com/microsoft/pylance-release/issues/6745)
-   Bug fix: Generated docstrings return type could be narrowed [pylance-release#6704](https://github.com/microsoft/pylance-release/issues/6704)
-   Bug fix: Make pass through settings descriptions to adopt inline code [pylance-release#6757](https://github.com/microsoft/pylance-release/issues/6757)
-   Enhancement: Support go-to-implementation [pylance-release#4329](https://github.com/microsoft/pylance-release/issues/4329)

Pylance's copy of Pyright has been updated from 1.1.389 to 1.1.390.

-   See Pyright's release notes for details: [1.1.390](https://github.com/microsoft/pyright/releases/tag/1.1.390)

## 2024.12.1 (5 December 2024) Release

Notable changes:

-   Release version that includes changes through the [2024.11.102](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#202411102-26-november-2024-prerelease) prerelease build.

## 2024.11.102 (26 November 2024) PreRelease

Notable changes:

-   Enhancement: Updated pandas stubs

## 2024.11.101 (19 November 2024) PreRelease

Notable changes:

-   Bug fix: Generated docstring does not include `:rtype` when return type annotation is present [pylance-release#6470](https://github.com/microsoft/pylance-release/issues/6470)
-   Bug fix: `inlineChat.viewInChat` command from notebook will cause pylance to crash [pylance-release#6454](https://github.com/microsoft/pylance-release/issues/6454)
-   Enhancement: Offer different pylance modes to enable light vs full IntelliSense experience [pylance-release#5434](https://github.com/microsoft/pylance-release/issues/5434)

Pylance's copy of Pyright has been updated from 1.1.388 to 1.1.389.

-   See Pyright's release notes for details: [1.1.389](https://github.com/microsoft/pyright/releases/tag/1.1.389)

## 2024.11.100 (6 November 2024) PreRelease

Notable changes:

-   Enhancement: Docstring templating [pylance-release#5944](https://github.com/microsoft/pylance-release/issues/5944)
-   Enhancement: Remove return type from **init** override member completion [pylance-release#5367](https://github.com/microsoft/pylance-release/issues/5367)
-   Enhancement: semantic highlight and hints for a TypedDict's get function. [pylance-release#4098](https://github.com/microsoft/pylance-release/issues/4098)

Pylance's copy of Pyright has been updated from 1.1.386 to 1.1.388.

-   See Pyright's release notes for details: [1.1.387](https://github.com/microsoft/pyright/releases/tag/1.1.387), [1.1.388](https://github.com/microsoft/pyright/releases/tag/1.1.388)

## 2024.11.3 (21 November 2024) Release

Notable changes:

-   Bug fix: make sure webpack can import all packages.

## 2024.11.2 (13 November 2024) Release

Notable changes:

-   Bug fix: Remove unicode character class entries in regex's for pylance-server package.

## 2024.11.1 (4 November 2024) Release

Notable changes:

-   Release version that includes changes through the [2024.10.104](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#202410104-31-october-2024-prerelease) prerelease build.

## 2024.10.104 (31 October 2024) PreRelease

Notable changes:

-   Bug fix: Regression: pre-release fails to parse `pyproject.toml` with comments [pylance-release#6621](https://github.com/microsoft/pylance-release/issues/6621)

## 2024.10.103 (28 October 2024) PreRelease

Notable changes:

-   Bug fix: Docstring parsing is causing completions to be slow

## 2024.10.102 (24 October 2024) PreRelease

Notable changes:

-   Enhancement: Added "python.analysis.displayEnglishDiagnostics" to disable localized translations of technical error messages or terms [pylance-release#6265](https://github.com/microsoft/pylance-release/issues/6265)
-   Enhancement: Add a "fold all docstrings" command [pylance-release#4677](https://github.com/microsoft/pylance-release/issues/4677)

Pylance's copy of Pyright has been updated from 1.1.385 to 1.1.386.

-   See Pyright's release notes for details: [1.1.386](https://github.com/microsoft/pyright/releases/tag/1.1.386)

## 2024.10.101 (17 October 2024) PreRelease

Notable changes:

Pylance's copy of Pyright has been updated from 1.1.384 to 1.1.385.

-   See Pyright's release notes for details: [1.1.385](https://github.com/microsoft/pyright/releases/tag/1.1.385)

## 2024.10.100 (10 October 2024) PreRelease

Notable changes:

-   Bug fix: Multiline parameter docstrings are truncated when parsed [pylance-release#6524](https://github.com/microsoft/pylance-release/issues/6524)
-   Bug fix: python.analysis.typeEvaluation.xxx is not marked in `settings.json` when `pyrightconfig.json` exists [pylance-release#6498](https://github.com/microsoft/pylance-release/issues/6498)
-   Bug fix: Don't show settingsNotOverridable if vscode settings file has a larger scope than the current project [pylance-release#6428](https://github.com/microsoft/pylance-release/issues/6428)
-   Enhancement: typeCheckingMode button only toggles between `off` and `basic` [pylance-release#6080](https://github.com/microsoft/pylance-release/issues/6080)
-   Bug fix: Dataclass fields that use `converter` don't have expected semantic tokens [pylance-release#6525](https://github.com/microsoft/pylance-release/issues/6525)

Pylance's copy of Pyright has been updated from 1.1.382 to 1.1.384.

-   See Pyright's release notes for details: [1.1.383](https://github.com/microsoft/pyright/releases/tag/1.1.383), [1.1.384](https://github.com/microsoft/pyright/releases/tag/1.1.384)

## 2024.10.1 (7 October 2024) Release

Notable changes:

-   Release version that includes changes through the [2024.9.104](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20249104-3-october-2024-prerelease) prerelease build.

## 2024.9.104 (3 October 2024) PreRelease

Notable changes:

-   Bug fix: Crash telemetry fix

## 2024.9.103 (2 October 2024) PreRelease

Notable changes:

-   Bug fix: pylance crash when notebook is opened while interactive window is opened. [pylance-release#6502](https://github.com/microsoft/pylance-release/issues/6502)
-   Bug fix: File analysis runs indefinitely after upgrading to v2024.9.1 [pylance-release#6386](https://github.com/microsoft/pylance-release/issues/6386)
-   Bug fix: pylance can't restart: Error: LanguageStatusItem with id 'python.analysis.typeCheckingMode' ALREADY exists [pylance-release#6378](https://github.com/microsoft/pylance-release/issues/6378)

## 2024.9.102 (26 September 2024) PreRelease

Notable changes:

-   Bug fix: Generic type aliases show two inlay hints [pylance-release#6427](https://github.com/microsoft/pylance-release/issues/6427)
-   Bug fix: Pyright/Pylance inconsistency: Unknown import symbol sklearn [pylance-release#6410](https://github.com/microsoft/pylance-release/issues/6410)
-   Enhancement: Importing from tests prefers deeper imports over package entry-point [pylance-release#5650](https://github.com/microsoft/pylance-release/issues/5650)
-   Bug fix: Autoimport from module, not directly from file [pylance-release#4065](https://github.com/microsoft/pylance-release/issues/4065)
-   Enhancement: "Quick Fix" doesn't suggest `__init__.py` imports [pylance-release#5231](https://github.com/microsoft/pylance-release/issues/5231)

Pylance's copy of Pyright has been updated from 1.1.381 to 1.1.382.

-   See Pyright's release notes for details: [1.1.382](https://github.com/microsoft/pyright/releases/tag/1.1.382)

## 2024.9.101 (18 September 2024) PreRelease

Notable changes:

-   Bug fix: `NoReturn` behaving unexpectedly after using the decorator with added type annotation [pylance-release#6391](https://github.com/microsoft/pylance-release/issues/6391)
-   Bug fix: Recent pylance is striking out `Union` imports as deprecated [pylance-release#6390](https://github.com/microsoft/pylance-release/issues/6390)

Pylance's copy of Pyright has been updated from 1.1.380 to 1.1.381.

-   See Pyright's release notes for details: [1.1.381](https://github.com/microsoft/pyright/releases/tag/1.1.381)

## 2024.9.100 (12 September 2024) PreRelease

Notable changes:

-   Bug fix: Pylance crashes when using the interactive window [pylance-release#6357](https://github.com/microsoft/pylance-release/issues/6357)
-   Bug fix: No Syntax Highlighting on v2024.14.0 [pylance-release#6358](https://github.com/microsoft/pylance-release/issues/6358)
-   Enhancement: Goto def on inlay hints doesn't distinguish sub types [pylance-release#6346](https://github.com/microsoft/pylance-release/issues/6346)
-   Bug fix: Warnings are not shown for non-overridable settings when a config file is present in a multi-root workspace scenario [pylance-release#6338](https://github.com/microsoft/pylance-release/issues/6338)
-   Bug fix: Pylance with a multi-root workspace [pylance-release#6318](https://github.com/microsoft/pylance-release/issues/6318)
-   Bug fix: Some localized strings have over-localized Python keywords [pylance-release#6035](https://github.com/microsoft/pylance-release/issues/6035)
-   Bug fix: Pylance slows down when using the vulkan library [pylance-release#6351](https://github.com/microsoft/pylance-release/issues/6351)

Pylance's copy of Pyright has been updated from 1.1.378 to 1.1.380.

-   See Pyright's release notes for details: [1.1.379](https://github.com/microsoft/pyright/releases/tag/1.1.379), [1.1.380](https://github.com/microsoft/pyright/releases/tag/1.1.380)

## 2024.9.2 (20 September 2024) Release

Notable changes:

-   Bug fix: Pylance crashes when using the interactive window [pylance-release#6357](https://github.com/microsoft/pylance-release/issues/6357)

## 2024.9.1 (9 September 2024) Release

Notable changes:

-   Release version that includes changes through the [2024.8.104](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20248104-28-august-2024-prerelease) prerelease build.

## 2024.8.104 (28 August 2024) PreRelease

Notable changes:

-   Bug fix: "python.analysis.diagnosticMode" should be allowed even when "pyproject.toml" exists [pylance-release#6314](https://github.com/microsoft/pylance-release/issues/6314)

Pylance's copy of Pyright has been updated from 1.1.377 to 1.1.378.

-   See Pyright's release notes for details: [1.1.378](https://github.com/microsoft/pyright/releases/tag/1.1.378)

## 2024.8.103 (27 August 2024) PreRelease

Functionally identical to 2024.8.102.

## 2024.8.102 (27 August 2024) PreRelease

Notable changes:

-   Bug fix: Error thrown from py lang server from a jupyter notebook on insiders.vscode.dev [pylance-release#6307](https://github.com/microsoft/pylance-release/issues/6307)
-   Bug fix: Pylance's auto-completion does not work properly in Jupyter [pylance-release#6294](https://github.com/microsoft/pylance-release/issues/6294)
-   Bug fix: Tooltip not being rendered with python.analysis.supportRestructuredText turned on. [pylance-release#6284](https://github.com/microsoft/pylance-release/issues/6284)
-   Bug fix: pylance crashing with cannot read properties of undefined (wsl) [pylance-release#6263](https://github.com/microsoft/pylance-release/issues/6263)

Pylance's copy of Pyright has been updated from 1.1.375 to 1.1.377.

-   See Pyright's release notes for details: [1.1.376](https://github.com/microsoft/pyright/releases/tag/1.1.376), [1.1.377](https://github.com/microsoft/pyright/releases/tag/1.1.377)

## 2024.8.101 (12 August 2024) PreRelease

Notable changes:

-   Bug fix: Pylance ins`t accessing fixture from main conftest [pylance-release#6249](https://github.com/microsoft/pylance-release/issues/6249)
-   Bug fix: Notification of breaking api change with v1.92 release of VS Code [pylance-release#6115](https://github.com/microsoft/pylance-release/issues/6115)
-   Enhancement: Feature request: Support 'go to def' and interacting with inlay hint components [pylance-release#5210](https://github.com/microsoft/pylance-release/issues/5210)
-   Bug fix: TypeError: Cannot read properties of undefined (reading 'fileInfo') [pylance-release#6234](https://github.com/microsoft/pylance-release/issues/6234)

## 2024.8.100 (9 August 2024) PreRelease

Notable changes:

-   Bug fix: Failed to parse (some) docstrings that contain Markdown code since 2024.6.100 [pylance-release#6225](https://github.com/microsoft/pylance-release/issues/6225)
-   Bug fix: Sphinx Style Docstring Incorrectly Rendering Nested Parameters Lists [pylance-release#6224](https://github.com/microsoft/pylance-release/issues/6224)
-   Bug fix: Inline suggestions not working if bracket not closed [pylance-release#6188](https://github.com/microsoft/pylance-release/issues/6188)

Pylance's copy of Pyright has been updated from 1.1.373 to 1.1.375.

-   See Pyright's release notes for details: [1.1.374](https://github.com/microsoft/pyright/releases/tag/1.1.374), [1.1.375](https://github.com/microsoft/pyright/releases/tag/1.1.375)

## 2024.8.2 (26 August 2024) Release

Notable changes:

-   Bug fix: TypeError: Cannot read properties of undefined (reading 'fileInfo') [pylance-release#6234](https://github.com/microsoft/pylance-release/issues/6234)

## 2024.8.1 (5 August 2024) Release

Notable changes:

-   Release version that includes changes through the [2024.7.104](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20247104-31-july-2024-prerelease) prerelease build.

## 2024.7.104 (31 July 2024) PreRelease

Notable changes:

-   Bug fix: Pylance reports false errors then crashes [pylance-release#6178](https://github.com/microsoft/pylance-release/issues/6178)

## 2024.7.103 (29 July 2024) PreRelease

Notable changes:

-   Bug fix: Highlighting fails after switching between monorepo projects (when switching python interpreters) [pylance-release#5995](https://github.com/microsoft/pylance-release/issues/5995)

Pylance's copy of Pyright has been updated from 1.1.372 to 1.1.373.

-   See Pyright's release notes for details: [1.1.373](https://github.com/microsoft/pyright/releases/tag/1.1.373)

## 2024.7.102 (24 July 2024) PreRelease

Notable changes:

-   Bug fix: Pressing X on pylance has crashed notification should be treated as a `No` [pylance-release#6156](https://github.com/microsoft/pylance-release/issues/6156)
-   Enhancement: Provide a way to disable unreachability hints [pylance-release#6106](https://github.com/microsoft/pylance-release/issues/6106)

## 2024.7.101 (22 July 2024) PreRelease

Notable changes:

-   Bug fix: Asyncio.TaskGroup doc string causes parsing error [pylance-release#6143](https://github.com/microsoft/pylance-release/issues/6143)
-   Bug fix: Incorrect Rendering of Google Style Docstrings in Pylance [pylance-release#6127](https://github.com/microsoft/pylance-release/issues/6127)
-   Bug fix: Sphinx Style Docstring Incorrectly Rendering "Other Parameters" [pylance-release#6100](https://github.com/microsoft/pylance-release/issues/6100)

Pylance's copy of Pyright has been updated from 1.1.369 to 1.1.372.

-   See Pyright's release notes for details: [1.1.370](https://github.com/microsoft/pyright/releases/tag/1.1.370), [1.1.371](https://github.com/microsoft/pyright/releases/tag/1.1.371), [1.1.372](https://github.com/microsoft/pyright/releases/tag/1.1.372)

## 2024.7.100 (15 July 2024) PreRelease

Notable changes:

-   Enhancement: don't show code actions that are not supported in virtual workspace [pylance-release#6090](https://github.com/microsoft/pylance-release/issues/6090)
-   Bug fix: too many notifications when pylance crashes [pylance-release#6056](https://github.com/microsoft/pylance-release/issues/6056)
-   Bug fix: pylance crash: Allocation failed - JavaScript heap out of memory [pylance-release#5925](https://github.com/microsoft/pylance-release/issues/5925)
-   Bug fix: Quick fix suggests importing symbol that is not available in `pythonVersion` [pylance-release#4993](https://github.com/microsoft/pylance-release/issues/4993)
-   Bug fix: Intellisense still not fully working with Enum classes [pylance-release#4928](https://github.com/microsoft/pylance-release/issues/4928)

## 2024.7.1 (8 July 2024) Release

Notable changes:

-   Release version that includes changes through the [2024.6.104](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20246104-3-july-2024-prerelease) prerelease build.

## 2024.6.104 (3 July 2024) PreRelease

Notable changes:

-   Bug fix: `reportShadowedImports` diagnostic missing in `codeaction.py` test file [pylance-release#6087](https://github.com/microsoft/pylance-release/issues/6087)
-   Bug fix: Create stub is missing as a code action [pylance-release#6085](https://github.com/microsoft/pylance-release/issues/6085)

## 2024.6.103 (1 July 2024) PreRelease

Notable changes:

-   Bug fix: Having a pyproject.toml will break diagnosticSeverityOverrides in settings.json [pylance-release#6052](https://github.com/microsoft/pylance-release/issues/6052)
-   Bug fix: [Slow performance] Pylance goes crazy after switching git branch [pylance-release#6046](https://github.com/microsoft/pylance-release/issues/6046)

## 2024.6.102 (25 June 2024) PreRelease

Notable changes:

-   Bug fix: Bokeh export_png docstring is not formatted correctly [pylance-release#6039](https://github.com/microsoft/pylance-release/issues/6039)
-   Enhancement: Support lazy loading individual virtualenvs in a multi-root workspace [pylance-release#6009](https://github.com/microsoft/pylance-release/issues/6009)
-   Bug fix: Multiple notifications "executing command" but no details on what is being run [pylance-release#6048](https://github.com/microsoft/pylance-release/issues/6048)
-   Bug fix: Bug: Code is unreachable [pylance-release#6028](https://github.com/microsoft/pylance-release/issues/6028)
-   Bug fix: The parseTreeUtils.findNodeByOffset function returns an incorrect node when using binary search [pylance-release#5775](https://github.com/microsoft/pylance-release/issues/5775)

Pylance's copy of Pyright has been updated from 1.1.368 to 1.1.369.

-   See Pyright's release notes for details: [1.1.369](https://github.com/microsoft/pyright/releases/tag/1.1.369)

## 2024.6.101 (20 June 2024) PreRelease

Notable changes:

-   Bug fix: Signature help isn't formatted beautifully when class docstring is reused for `__init__` [pylance-release#6012](https://github.com/microsoft/pylance-release/issues/6012)
-   Bug fix: notebook cells sometimes get cycle. [pylance-release#5798](https://github.com/microsoft/pylance-release/issues/5798)
-   Enhancement: Pylance should auto-import from files marked with `_` too [pylance-release#5294](https://github.com/microsoft/pylance-release/issues/5294)

Pylance's copy of Pyright has been updated from 1.1.367 to 1.1.368.

-   See Pyright's release notes for details: [1.1.368](https://github.com/microsoft/pyright/releases/tag/1.1.368)

## 2024.6.100 (13 June 2024) PreRelease

Notable changes:

-   Bug fix: Support sphinx doc strings [pylance-release#5975](https://github.com/microsoft/pylance-release/issues/5975)
-   Bug fix: Variable inlay type hints not displaying [pylance-release#5967](https://github.com/microsoft/pylance-release/issues/5967)
-   Bug fix: Pylance failed to start service instance, caused by a regexp error [pylance-release#5963](https://github.com/microsoft/pylance-release/issues/5963)
-   Bug fix: Docstring rendering doesn't handle indentation [pylance-release#5446](https://github.com/microsoft/pylance-release/issues/5446)
-   Enhancement: Please transform NumpyDoc/ RestructuredText docstrings to nice tooltips to support useful docstrings across VS Code, Jupyter and Sphinx [pylance-release#5363](https://github.com/microsoft/pylance-release/issues/5363)
-   Bug fix: docstring: Regarding Korean line spacing problem [pylance-release#4615](https://github.com/microsoft/pylance-release/issues/4615)
-   Bug fix: Google docstring formatting for multi-line class attributes not recognized/converted properly for use in intellisense popup [pylance-release#3347](https://github.com/microsoft/pylance-release/issues/3347)
-   Bug fix: `itertools.count` docstring is not shown correctly [pylance-release#3231](https://github.com/microsoft/pylance-release/issues/3231)
-   Bug fix: missing new line from dict() help mouse hover [pylance-release#3118](https://github.com/microsoft/pylance-release/issues/3118)
-   Bug fix: Intellisense does not show the complete multiline description of function/method parameters [pylance-release#2942](https://github.com/microsoft/pylance-release/issues/2942)
-   Enhancement: Sphinx Style Docstring Rendering Feature [pylance-release#2251](https://github.com/microsoft/pylance-release/issues/2251)
-   Bug fix: Slow computer -> "Expected 0 positional arguments" [pylance-release#4295](https://github.com/microsoft/pylance-release/issues/4295)
-   Bug fix: Doc string for sqlalchemy.column is misformatted [pylance-release#6004](https://github.com/microsoft/pylance-release/issues/6004)

Pylance's copy of Pyright has been updated from 1.1.364 to 1.1.367.

-   See Pyright's release notes for details: [1.1.365](https://github.com/microsoft/pyright/releases/tag/1.1.365), [1.1.366](https://github.com/microsoft/pyright/releases/tag/1.1.366), [1.1.367](https://github.com/microsoft/pyright/releases/tag/1.1.367)

## 2024.6.1 (6 June 2024) Release

Notable changes:

-   Release version that includes changes through the [2024.5.104](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20245104-4-june-2024-prerelease) prerelease build.

## 2024.5.104 (4 June 2024) PreRelease

Notable changes:

-   Bug fix: cyclic symbolic detection is broken [pylance-release#5937](https://github.com/microsoft/pylance-release/issues/5937)

## 2024.5.103 (28 May 2024) PreRelease

Notable changes:

-   Bug fix: import side by side in standalone file didn't work [pylance-release#5916](https://github.com/microsoft/pylance-release/issues/5916)
-   Bug fix: Pylance reports import Missing in inexistent file when git enabled [pylance-release#5895](https://github.com/microsoft/pylance-release/issues/5895)
-   Bug fix: Pylance deletes automatically-added `#` sign when you line break inside a comment [pylance-release#5484](https://github.com/microsoft/pylance-release/issues/5484)

## 2024.5.102 (23 May 2024) PreRelease

Notable changes:

-   Bug fix: Show Type Hierarchy shows no results for types declared in notebooks [pylance-release#5832](https://github.com/microsoft/pylance-release/issues/5832)
-   Bug fix: Files to analyze count is wrong for notebooks [pylance-release#5173](https://github.com/microsoft/pylance-release/issues/5173)
-   Bug fix: Attributes not recognized when using `converters` in `attrs` module [pylance-release#5391](https://github.com/microsoft/pylance-release/issues/5391)

Pylance's copy of Pyright has been updated from 1.1.362 to 1.1.364.

-   See Pyright's release notes for details: [1.1.363](https://github.com/microsoft/pyright/releases/tag/1.1.363), [1.1.364](https://github.com/microsoft/pyright/releases/tag/1.1.364)

## 2024.5.101 (16 May 2024) PreRelease

Notable changes:

-   Enhancement: Added more detail to assertion message to investigate "Check called before parsing" crash [pylance-release#5868](https://github.com/microsoft/pylance-release/issues/5868)
-   Enhancement: Updated pandas, django and scikit-learn stubs

## 2024.5.100 (9 May 2024) PreRelease

Notable changes:

-   Bug fix: Don't append "py" on show call hierarchy view when source is a notebook file [pylance-release#5815](https://github.com/microsoft/pylance-release/issues/5815)
-   Enhancement: Support enabling/disabling auto-indent without restarting Pylance [pylance-release#5778](https://github.com/microsoft/pylance-release/issues/5778)
-   Enhancement: Add "implement all inherited abstract classes" code action as a quick fix for reportAbstractUsage [pylance-release#5757](https://github.com/microsoft/pylance-release/issues/5757)
-   Bug fix: create stub file not working [pylance-release#5188](https://github.com/microsoft/pylance-release/issues/5188)
-   Bug fix: Syntax highlighting color of keywords should remain constant [pylance-release#4845](https://github.com/microsoft/pylance-release/issues/4845)
-   Bug fix: VS Code + Pylance does not find venv-installed modules while venv is activated [pylance-release#3881](https://github.com/microsoft/pylance-release/issues/3881)

Pylance's copy of Pyright has been updated from 1.1.360 to 1.1.362.

-   See Pyright's release notes for details: [1.1.361](https://github.com/microsoft/pyright/releases/tag/1.1.361), [1.1.362](https://github.com/microsoft/pyright/releases/tag/1.1.362)

## 2024.5.1 (6 May 2024) Release

Notable changes:

-   Release version that includes changes through the [2024.4.106](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20244106-1-may-2024-prerelease) prerelease build.

## 2024.4.106 (1 May 2024) PreRelease

Notable changes:

-   Bug fix: Telemetry fix for perf investigations

## 2024.4.105 (29 April 2024) PreRelease

Notable changes:

-   Bug fix: Unresolved import on package that is installed in kernel used in a notebook [pylance-release#5814](https://github.com/microsoft/pylance-release/issues/5814)

## 2024.4.104 (25 April 2024) PreRelease

Notable changes:

-   Bug fix: multiple `#type: ignore` shown for 1 line if that line contains multiple errors [pylance-release#5657](https://github.com/microsoft/pylance-release/issues/5657)

Pylance's copy of Pyright has been updated from 1.1.359 to 1.1.360.

-   See Pyright's release notes for details: [1.1.360](https://github.com/microsoft/pyright/releases/tag/1.1.360)

## 2024.4.103 (24 April 2024) PreRelease

Notable changes:

-   Bug fix: Syntax tokens are not provided for f-strings [pylance-release#5781](https://github.com/microsoft/pylance-release/issues/5781)
-   Bug fix: Exact match suggestions sometimes not shown for symbol import completions [pylance-release#5764](https://github.com/microsoft/pylance-release/issues/5764)
-   Enhancement: Provide command to start trace logging without restarting pylance [pylance-release#5724](https://github.com/microsoft/pylance-release/issues/5724)

## 2024.4.102 (17 April 2024) PreRelease

Notable changes:

-   Bug fix: Should be able to disable auto-indent without setting `formatOnType` to `false` [pylance-release#5592](https://github.com/microsoft/pylance-release/issues/5592)

Pylance's copy of Pyright has been updated from 1.1.358 to 1.1.359.

-   See Pyright's release notes for details: [1.1.359](https://github.com/microsoft/pyright/releases/tag/1.1.359)

## 2024.4.101 (10 April 2024) PreRelease

Notable changes:

-   Bug fix: Smart indentation is broken in Python [pylance-release#5741](https://github.com/microsoft/pylance-release/issues/5741)
-   Bug fix: [Feature request] Autocomplete Abstract, Protocol and method override [pylance-release#5362](https://github.com/microsoft/pylance-release/issues/5362)
-   Bug fix: Python curses module on Windows is never allowed to autocomplete [pylance-release#2763](https://github.com/microsoft/pylance-release/issues/2763)

Pylance's copy of Pyright has been updated from 1.1.357 to 1.1.358.

-   See Pyright's release notes for details: [1.1.358](https://github.com/microsoft/pyright/releases/tag/1.1.358)

## 2024.4.100 (4 April 2024) PreRelease

Notable changes:

-   Bug fix: The annotation inserted on double-click of the preview of inferred type does not match, and instead inserts the first imported variable of that type [pylance-release#5693](https://github.com/microsoft/pylance-release/issues/5693)
-   Bug fix: File System error with Pylance on activate [pylance-release#5686](https://github.com/microsoft/pylance-release/issues/5686)
-   Bug fix: Conda environment folders are not recognized as virtual environments [pylance-release#5191](https://github.com/microsoft/pylance-release/issues/5191)

Pylance's copy of Pyright has been updated from 1.1.356 to 1.1.357.

-   See Pyright's release notes for details: [1.1.357](https://github.com/microsoft/pyright/releases/tag/1.1.357)

## 2024.4.1 (2 April 2024) Release

Notable changes:

-   Release version that includes changes through the [2024.3.102](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20243102-27-march-2024-prerelease) prerelease build.

## 2024.3.102 (27 March 2024) PreRelease

Notable changes:

-   Bug fix: Some characters are mistaken for invalid identifiers [pylance-release#5656](https://github.com/microsoft/pylance-release/issues/5656)
-   Enhancement: Users should be able to tell which `pandas-stubs` we have bundled [pylance-release#5643](https://github.com/microsoft/pylance-release/issues/5643)
-   Enhancement: Multiline Comment: the 2nd line can be wrongly indented [pylance-release#5488](https://github.com/microsoft/pylance-release/issues/5488)
-   Bug fix: Extract variable shouldn't work on assignments [pylance-release#5339](https://github.com/microsoft/pylance-release/issues/5339)
-   Enhancement: Updated pandas stubs

Pylance's copy of Pyright has been updated from 1.1.355 to 1.1.356.

-   See Pyright's release notes for details: [1.1.356](https://github.com/microsoft/pyright/releases/tag/1.1.356)

## 2024.3.101 (21 March 2024) PreRelease

Notable changes:

-   Bug fix: `Add #type ignore` code action not offered for some type-related diagnostics [pylance-release#5628](https://github.com/microsoft/pylance-release/issues/5628)
-   Bug fix: Respect `files.refactoring.autoSave` for move to file [pylance-release#5217](https://github.com/microsoft/pylance-release/issues/5217)
-   Enhancement: Updated pandas stubs
-   Enhancement: Added SymPy stubs

Pylance's copy of Pyright has been updated from 1.1.354 to 1.1.355.

-   See Pyright's release notes for details: [1.1.355](https://github.com/microsoft/pyright/releases/tag/1.1.355)

## 2024.3.100 (13 March 2024) PreRelease

Notable changes:

-   Enhancement: Provide profiling command to generate `cpuprofile` (chrome perf profile file) for all worker threads [pylance-release#5590](https://github.com/microsoft/pylance-release/issues/5590)
-   Bug fix: No documentation for `isalpha` called on `LiteralString` [pylance-release#5566](https://github.com/microsoft/pylance-release/issues/5566)
-   Bug fix: Regression in 2023.10.41 quick-fix pyright-specific comments [pylance-release#5565](https://github.com/microsoft/pylance-release/issues/5565)
-   Bug fix: Dont show `convert to relative path` for files in local `typings` or `stubs` path. [pylance-release#5505](https://github.com/microsoft/pylance-release/issues/5505)
-   Bug fix: Move symbol to doesn't work in typed context [pylance-release#5498](https://github.com/microsoft/pylance-release/issues/5498)
-   Bug fix: JavaScript heap out of memory - pytest w aws_cdk imports [pylance-release#5440](https://github.com/microsoft/pylance-release/issues/5440)
-   Bug fix: semantic modifiers : BuiltinConstants don't have the TypeHint modifier when they should [pylance-release#4758](https://github.com/microsoft/pylance-release/issues/4758)

Pylance's copy of Pyright has been updated from 1.1.351 to 1.1.354.

-   See Pyright's release notes for details: [1.1.352](https://github.com/microsoft/pyright/releases/tag/1.1.352), [1.1.353](https://github.com/microsoft/pyright/releases/tag/1.1.353), [1.1.354](https://github.com/microsoft/pyright/releases/tag/1.1.354)

## 2024.3.2 (25 March 2024) Release

Notable changes:

-   Bug fix: Code marked as unreachable after pandas concat [pylance-release#5630](https://github.com/microsoft/pylance-release/issues/5630)

## 2024.3.1 (12 March 2024) Release

Notable changes:

-   Release version that includes changes through the [2024.2.106](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20242106-7-march-2024-prerelease) prerelease build.

## 2024.2.106 (7 March 2024) PreRelease

Notable changes:

-   Enhancement: Added telemetry to investigate the hover performance issue [pylance-release#5598](https://github.com/microsoft/pylance-release/issues/5598)

## 2024.2.105 (29 February 2024) PreRelease

Notable changes:

-   Bug fix: add import throws on certain invalid code [pylance-release#5536](https://github.com/microsoft/pylance-release/issues/5536)

## 2024.2.104 (27 February 2024) PreRelease

Notable changes:

-   Bug fix: Telemetry fixes

## 2024.2.103 (22 February 2024) PreRelease

Notable changes:

-   Bug fix: "Auto-Import" imports from wrong path when import format is "relative" [pylance-release#5427](https://github.com/microsoft/pylance-release/issues/5427)
-   Enhancement: Improve error message when symbol fails to be moved to an existing file [pylance-release#4345](https://github.com/microsoft/pylance-release/issues/4345)

## 2024.2.102 (20 February 2024) PreRelease

Notable changes:

-   Bug fix: `searchImport` fails with circular reference some times. [pylance-release#5481](https://github.com/microsoft/pylance-release/issues/5481)
-   Bug fix: Enhancement: Support a different location for downloading type stubs in the browser [pylance-release#5479](https://github.com/microsoft/pylance-release/issues/5479)

Pylance's copy of Pyright has been updated from 1.1.350 to 1.1.351.

-   See Pyright's release notes for details: [1.1.351](https://github.com/microsoft/pyright/releases/tag/1.1.351)

## 2024.2.101 (15 February 2024) PreRelease

Notable changes:

-   Bug fix: Support cancellation in the browser when COI is turned off [pylance-release#5473](https://github.com/microsoft/pylance-release/issues/5473)
-   Enhancement: Add `Change spelling to` code action similar to what typescript provide [pylance-release#5467](https://github.com/microsoft/pylance-release/issues/5467)
-   Bug fix: `region` at the start of a normal comment triggers error about `endregion` being missing [pylance-release#3857](https://github.com/microsoft/pylance-release/issues/3857)

## 2024.2.100 (13 February 2024) PreRelease

Notable changes:

-   Bug fix: Release version 2024.2.1 shows missing imports error for function imported from another python file [pylance-release#5459](https://github.com/microsoft/pylance-release/issues/5459)
-   Enhancement: Add heuristics for add imports quick fixes [pylance-release#5226](https://github.com/microsoft/pylance-release/issues/5226)
-   Bug fix: Editor language status for Python wiggles distractingly [pylance-release#4961](https://github.com/microsoft/pylance-release/issues/4961)
-   Bug fix: Quick Fix import puts local imports with third-party imports [pylance-release#4872](https://github.com/microsoft/pylance-release/issues/4872)

Pylance's copy of Pyright has been updated from 1.1.348 to 1.1.350.

-   See Pyright's release notes for details: [1.1.349](https://github.com/microsoft/pyright/releases/tag/1.1.349), [1.1.350](https://github.com/microsoft/pyright/releases/tag/1.1.350)

## 2024.2.4 (21 January 2025) Release

Notable changes:

-   Bug fix: Support PTVS 17.10 requirements

## 2024.2.3 (4 March 2024) Release

Notable changes:

-   Enhancement: Server-side LSP request telemetry

## 2024.2.2 (14 February 2024) Release

Notable changes:

-   Enhancement: Added telemetry to diagnose slow completions
-   Bug fix: Release version 2024.2.1 shows missing imports error for function imported from another python file [pylance-release#5459](https://github.com/microsoft/pylance-release/issues/5459)

## 2024.2.1 (8 February 2024) Release

Notable changes:

-   Release version that includes changes through the [2024.1.104](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20241104-1-february-2024-prerelease) prerelease build.

## 2024.1.104 (1 February 2024) PreRelease

Notable changes:

-   Bug fix: Cell URI to notebook URI conversion fails if path only contains filename [pylance-release#5435](https://github.com/microsoft/pylance-release/issues/5435)

## 2024.1.103 (31 January 2024) PreRelease

Notable changes:

-   Bug fix: Extract method and variable not working on Untitled notebooks in WSL [pylance-release#5424](https://github.com/microsoft/pylance-release/issues/5424)
-   Bug fix: Cancellation failed in browser [pylance-release#5420](https://github.com/microsoft/pylance-release/issues/5420)

## 2024.1.102 (29 January 2024) PreRelease

Notable changes:

-   Bug fix: Extract variable shouldn't be offered when multiple statements are selected. [pylance-release#5400](https://github.com/microsoft/pylance-release/issues/5400)
-   Bug fix: MoveSymbol doesn't work with network folder [pylance-release#5399](https://github.com/microsoft/pylance-release/issues/5399)

## 2024.1.101 (25 January 2024) PreRelease

Notable changes:

-   Bug fix: Turning off indexing, Pylance gives different results for completions (2023.12.1 did not) [pylance-release#5397](https://github.com/microsoft/pylance-release/issues/5397)
-   Bug fix: Symbols from ancestor cells in Interactive Window are unrecognized [pylance-release#5389](https://github.com/microsoft/pylance-release/issues/5389)

## 2024.1.100 (24 January 2024) PreRelease

Notable changes:

-   Bug fix: No docstrings shown for stdlib symbols [pylance-release#5383](https://github.com/microsoft/pylance-release/issues/5383)
-   Bug fix: Indexing time with 2023.12.104 is about 3x slower [pylance-release#5382](https://github.com/microsoft/pylance-release/issues/5382)

Pylance's copy of Pyright has been updated from 1.1.347 to 1.1.348.

-   See Pyright's release notes for details: [1.1.348](https://github.com/microsoft/pyright/releases/tag/1.1.348)

## 2023.12.104 (22 January 2024) PreRelease

Notable changes:

-   Bug fix: "Received redundant open text document command" when working off mapped network drive [pylance-release#5326](https://github.com/microsoft/pylance-release/issues/5326)
-   Bug fix: Go-to-def/find-all-refs/rename doesn't work for class declared after type alias [pylance-release#5304](https://github.com/microsoft/pylance-release/issues/5304)
-   Bug fix: "unknown import symbol" for symbol in unsaved file in symlinked directory [pylance-release#5181](https://github.com/microsoft/pylance-release/issues/5181)
-   Bug fix: Sync server fails to load `python.analysis.*` (and other) config settings [pylance-release#5035](https://github.com/microsoft/pylance-release/issues/5035)
-   Bug fix: Rename Symbol deletes extra characters when replacing a symbol found after an elif [pylance-release#4966](https://github.com/microsoft/pylance-release/issues/4966)

Pylance's copy of Pyright has been updated from 1.1.338 to 1.1.347.

-   See Pyright's release notes for details: [1.1.339](https://github.com/microsoft/pyright/releases/tag/1.1.339), [1.1.340](https://github.com/microsoft/pyright/releases/tag/1.1.340), [1.1.341](https://github.com/microsoft/pyright/releases/tag/1.1.341), [1.1.342](https://github.com/microsoft/pyright/releases/tag/1.1.342), [1.1.343](https://github.com/microsoft/pyright/releases/tag/1.1.343), [1.1.344](https://github.com/microsoft/pyright/releases/tag/1.1.344), [1.1.345](https://github.com/microsoft/pyright/releases/tag/1.1.345), [1.1.346](https://github.com/microsoft/pyright/releases/tag/1.1.346), [1.1.347](https://github.com/microsoft/pyright/releases/tag/1.1.347)

## 2023.12.103 (10 January 2024) PreRelease

Notable changes:

-   Enhancement: Output Pyright version in Pylance log [pylance-release#5331](https://github.com/microsoft/pylance-release/issues/5331)
-   Bug fix: Extract method not working when invoking it on a member inside a class [pylance-release#5277](https://github.com/microsoft/pylance-release/issues/5277)
-   Bug fix: Auto Generate pandas docify config for docstring injection [pylance-release#5334](https://github.com/microsoft/pylance-release/issues/5334)

## 2023.12.102 (4 January 2024) PreRelease

Notable changes:

-   Bug fix: Slow Code Completion for Function Names When Analyzing Overridable Functions in Classes [pylance-release#5268](https://github.com/microsoft/pylance-release/issues/5268)

## 2023.12.101 (20 December 2023) PreRelease

Notable changes:

-   Bug fix: Pylance renders inlay parameter hints with type hint color [pylance-release#5278](https://github.com/microsoft/pylance-release/issues/5278)
-   Bug fix: Expand Selection on a class method selects the whole file [pylance-release#5272](https://github.com/microsoft/pylance-release/issues/5272)
-   Bug fix: Inconsistent use of '...' in UI labels [pylance-release#5218](https://github.com/microsoft/pylance-release/issues/5218)
-   Bug fix: Fix Pylance crash in PTVS [PTVS#7771](https://github.com/microsoft/PTVS/issues/7771)

## 2023.12.100 (14 December 2023) PreRelease

Notable changes:

-   Bug fix: Pylance not recognizing properties and methods from injected dependencies after v2023.12.1 update [pylance-release#5262](https://github.com/microsoft/pylance-release/issues/5262)
-   Bug fix: Improper handling of partial type stub packages [pylance-release#5139](https://github.com/microsoft/pylance-release/issues/5139)

Pylance's copy of Pyright has been updated from 1.1.336 to 1.1.338.

-   See Pyright's release notes for details: [1.1.337](https://github.com/microsoft/pyright/releases/tag/1.1.337), [1.1.338](https://github.com/microsoft/pyright/releases/tag/1.1.338)

## 2023.12.1 (13 December 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.11.104](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#202311104-7-december-2023-prerelease) prerelease build.

## 2023.11.104 (7 December 2023) PreRelease

Notable changes:

-   Bug fix: Goto def doesn't work in VS code.dev [pylance-release#5222](https://github.com/microsoft/pylance-release/issues/5222)

## 2023.11.103 (7 December 2023) PreRelease

Notable changes:

-   Bug fix: Goto def doesn't work in VS code.dev [pylance-release#5222](https://github.com/microsoft/pylance-release/issues/5222)

## 2023.11.102 (1 December 2023) PreRelease

Notable changes:

-   Bug fix: [Linux] GoTo definition performs symlink resolution [pylance-release#5136](https://github.com/microsoft/pylance-release/issues/5136)
-   Bug fix: Auto-indent indents unexpectedly in "in between comments" scenario [pylance-release#5100](https://github.com/microsoft/pylance-release/issues/5100)
-   Bug fix: Auto indentation doesn't work when hitting enter in a class method [pylance-release#5098](https://github.com/microsoft/pylance-release/issues/5098)
-   Bug fix: Rename symbol in a symbolic py file opens source file [pylance-release#5030](https://github.com/microsoft/pylance-release/issues/5030)

## 2023.11.13 (15 November 2023) PreRelease

Notable changes:

-   Bug fix: Error: Debug Failure. False expression: Check called before binding [pylance-release#5097](https://github.com/microsoft/pylance-release/issues/5097)
-   Enhancement: Add support for "Show super type Hierarchy" command [pylance-release#4978](https://github.com/microsoft/pylance-release/issues/4978)

Pylance's copy of Pyright has been updated from 1.1.335 to 1.1.336.

-   See Pyright's release notes for details: [1.1.336](https://github.com/microsoft/pyright/releases/tag/1.1.336)

## 2023.11.12 (8 November 2023) PreRelease

Notable changes:

-   Bug fix: "RangeError: Maximum call stack size exceeded" [pylance-release#5090](https://github.com/microsoft/pylance-release/issues/5090)
-   Bug fix: Pylance hints not working in Jupyter Notebook in Remote Tunnel [pylance-release#5071](https://github.com/microsoft/pylance-release/issues/5071)
-   Bug fix: Pylance v2023.10.50 is incompatible with Python Extension v2020.8.109390 [pylance-release#5019](https://github.com/microsoft/pylance-release/issues/5019)
-   Bug fix: abstractmethod override inherits typing with only the final object name [pylance-release#4948](https://github.com/microsoft/pylance-release/issues/4948)
-   Bug fix: Auto indentation fails after comment lines [pylance-release#4763](https://github.com/microsoft/pylance-release/issues/4763)

Pylance's copy of Pyright has been updated from 1.1.334 to 1.1.335.

-   See Pyright's release notes for details: [1.1.335](https://github.com/microsoft/pyright/releases/tag/1.1.335)

## 2023.11.11 (2 November 2023) PreRelease

Notable changes:

-   Bug fix: Pylance crashes upon startup: `[info] Error: [UriError]: Scheme contains illegal characters.` [pylance-release#5032](https://github.com/microsoft/pylance-release/issues/5032)
-   Bug fix: ExtractMethod no longer works on notebooks opened from WSL [pylance-release#5016](https://github.com/microsoft/pylance-release/issues/5016)
-   Bug fix: [Auto Import] - Suggest equivalents from `collections.abc` rather than `typing` [pylance-release#3318](https://github.com/microsoft/pylance-release/issues/3318)

Pylance's copy of Pyright has been updated from 1.1.333 to 1.1.334.

-   See Pyright's release notes for details: [1.1.334](https://github.com/microsoft/pyright/releases/tag/1.1.334)

## 2023.11.10 (2 November 2023) Release

Notable changes:

-   Rolled back release version that includes changes through the [2023.10.40](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20231040-20-october-2023-release) release build.

## 2023.10.53 (27 October 2023) PreRelease

Notable changes:

-   Bug fix: Fix crash when calling isSymbolicLink on stat of zip/egg [pylance-release#5009](https://github.com/microsoft/pylance-release/issues/5009)

## 2023.10.52 (26 October 2023) PreRelease

Notable changes:

-   Bug fix: Pylance v2023.10.51 no longer works once Untitled notebooks are saved as e.g. Untitiled-1.ipynb

## 2023.10.51 (26 October 2023) PreRelease

Notable changes:

-   Bug fix: Pytest add fixture type annotation code action shows up for non test files [pylance-release#5003](https://github.com/microsoft/pylance-release/issues/5003)
-   Bug fix: Pylance does not respect `__builtins__.pyi` for notebooks. [pylance-release#4949](https://github.com/microsoft/pylance-release/issues/4949)
-   Bug fix: Wrong inlay hint when passing \*arg or \*\*kwarg [pylance-release#4930](https://github.com/microsoft/pylance-release/issues/4930)

## 2023.10.50 (26 October 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.10.41](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20231041-20-october-2023-prerelease) prerelease build.

## 2023.10.41 (20 October 2023) PreRelease

Notable changes:

-   Bug fix: Pylance latest release killing remote connections to notebooks [pylance-release#4983](https://github.com/microsoft/pylance-release/issues/4983)
-   Bug fix: Use pyright-specific comment for `Quick Fix... > Add '# type: ignore' to suppress warning` [pylance-release#4494](https://github.com/microsoft/pylance-release/issues/4494)
-   Bug fix: "No code actions available" if Ctrl+. is hit quickly after moving the cursor [pylance-release#1247](https://github.com/microsoft/pylance-release/issues/1247)

## 2023.10.40 (20 October 2023) Release

This is a hotfix release based on [2023.10.30](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20231030-18-october-2023-release) with the following changes:

-   Bug fix: Pylance latest release killing remote connections to notebooks [pylance-release#4983](https://github.com/microsoft/pylance-release/issues/4983)

## 2023.10.31 (18 October 2023) PreRelease

Notable changes:

-   Bug fix: There is no preview after renaming module [pylance-release#4964](https://github.com/microsoft/pylance-release/issues/4964)
-   Bug fix: `pytest code action fix all` fails to fully qualify types if it shows up multiple times. [pylance-release#4958](https://github.com/microsoft/pylance-release/issues/4958)
-   Bug fix: The result of finding all references to the **init** function is not correct [pylance-release#4954](https://github.com/microsoft/pylance-release/issues/4954)
-   Bug fix: support hover tooltip on string that mapped to module/symbol [pylance-release#4287](https://github.com/microsoft/pylance-release/issues/4287)

Pylance's copy of Pyright has been updated from 1.1.331 to 1.1.332.

-   See Pyright's release notes for details: [1.1.332](https://github.com/microsoft/pyright/releases/tag/1.1.332)

## 2023.10.30 (18 October 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.10.21](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20231021-11-october-2023-prerelease) prerelease build.

## 2023.10.21 (11 October 2023) PreRelease

Notable changes:

-   Bug fix: [Type hints] Pylance is confused by `type(parameter_name)` instructions [pylance-release#4942](https://github.com/microsoft/pylance-release/issues/4942)
-   Bug fix: Don't show `stubPath xxx is not a valid directory` warning when using config default [pylance-release#4917](https://github.com/microsoft/pylance-release/issues/4917)
-   Bug fix: Cancellation exception from inlay hints [pylance-release#4916](https://github.com/microsoft/pylance-release/issues/4916)
-   Bug fix: Auto imports typeshed fallback when using refactor -> move symbol [pylance-release#4871](https://github.com/microsoft/pylance-release/issues/4871)

Pylance's copy of Pyright has been updated from 1.1.330 to 1.1.331.

-   See Pyright's release notes for details: [1.1.331](https://github.com/microsoft/pyright/releases/tag/1.1.331)

## 2023.10.20 (11 October 2023) Release

Notable changes:

-   Release version that includes changes through the [2022.10.11](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20221011-4-october-2023-prerelease) prerelease build.

## 2022.10.11 (4 October 2023) PreRelease

Notable changes:

-   Bug fix: pyTest features are sometime very slow [pylance-release#4805](https://github.com/microsoft/pylance-release/issues/4805)
-   Enhancement: add support for `__setattr__`, `__delattr__` and `__getattribute__` [pylance-release#4786](https://github.com/microsoft/pylance-release/issues/4786)
-   Enhancement: Add auto import setting as a language status item [pylance-release#3894](https://github.com/microsoft/pylance-release/issues/3894)

Pylance's copy of Pyright has been updated from 1.1.329 to 1.1.330.

-   See Pyright's release notes for details: [1.1.330](https://github.com/microsoft/pyright/releases/tag/1.1.330)

## 2022.10.10 (4 October 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.9.31](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023931-27-september-2023-prerelease) prerelease build.

## 2023.9.31 (27 September 2023) PreRelease

Notable changes:

-   Bug fix: Pylance not starting if python file is located on UNC network drive. [pylance-release#4862](https://github.com/microsoft/pylance-release/issues/4862)
-   Bug fix: Can't import file from the same directory [pylance-release#4861](https://github.com/microsoft/pylance-release/issues/4861)
-   Bug fix: Auto-dedent on `else:` in tabbed file removes too many characters [pylance-release#4858](https://github.com/microsoft/pylance-release/issues/4858)
-   Bug fix: No action on "Remove all unused imports" [pylance-release#4830](https://github.com/microsoft/pylance-release/issues/4830)

Pylance's copy of Pyright has been updated from 1.1.328 to 1.1.329.

-   See Pyright's release notes for details: [1.1.329](https://github.com/microsoft/pyright/releases/tag/1.1.329)

## 2023.9.30 (27 September 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.9.21](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023921-20-september-2023-prerelease) prerelease build.

## 2023.9.21 (20 September 2023) PreRelease

Notable changes:

-   Bug fix: Inconsistent behavior of formatOnType for multi-line with different line break types [pylance-release#4456](https://github.com/microsoft/pylance-release/issues/4456)

Pylance's copy of Pyright has been updated from 1.1.326 to 1.1.328.

-   See Pyright's release notes for details: [1.1.327](https://github.com/microsoft/pyright/releases/tag/1.1.327), [1.1.328](https://github.com/microsoft/pyright/releases/tag/1.1.328)

## 2023.9.20 (20 September 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.9.12](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023912-8-september-2023-prerelease) prerelease build.

## 2023.9.12 (8 September 2023) PreRelease

Notable changes:

-   Bug fix: Pylance returns symbols for previous version of the document [pylance-release#4810](https://github.com/microsoft/pylance-release/issues/4810)
-   Bug fix: Latest insiders does not recognise active pyenv virtualenv [pylance-release#4806](https://github.com/microsoft/pylance-release/issues/4806)
-   Enhancement: Make "add type annotation for pyTest arguments" to add `import` automatically as well. [pylance-release#4779](https://github.com/microsoft/pylance-release/issues/4779)

## 2023.9.11 (6 September 2023) PreRelease

Notable changes:

-   Bug fix: Diagnostics can suddenly disappear in a notebook [pylance-release#4780](https://github.com/microsoft/pylance-release/issues/4780)
-   Enhancement: Support `goto def` on `__getattr__` as well [pylance-release#4764](https://github.com/microsoft/pylance-release/issues/4764)
-   Bug fix: Rename of type alias defined with PEP 695 fails [pylance-release#4696](https://github.com/microsoft/pylance-release/issues/4696)
-   Bug fix: Wrong tooltip `Dictionary key` when indexing a list [pylance-release#4689](https://github.com/microsoft/pylance-release/issues/4689)
-   Bug fix: Pylance not completing suggestions for first party imports [pylance-release#4678](https://github.com/microsoft/pylance-release/issues/4678)
-   Enhancement: Python Analysis Inlay Hints Call Argument Names gives useless and confusing names [pylance-release#4543](https://github.com/microsoft/pylance-release/issues/4543)

Pylance's copy of Pyright has been updated from 1.1.325 to 1.1.326.

-   See Pyright's release notes for details: [1.1.326](https://github.com/microsoft/pyright/releases/tag/1.1.326)

## 2023.9.10 (6 September 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.8.51](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023851-30-august-2023-prerelease) prerelease build.

## 2023.8.51 (30 August 2023) PreRelease

Notable changes:

-   Enhancement: Pylance import resolve messages should be pushed to Pyright [pylance-release#4701](https://github.com/microsoft/pylance-release/issues/4701)
-   Bug fix: Pylance crashing on Jupyter Notebook Cell Deletion [pylance-release#4685](https://github.com/microsoft/pylance-release/issues/4685)
-   Enhancement: Autocomplete for `__getattr__` by Literal values [pylance-release#4660](https://github.com/microsoft/pylance-release/issues/4660)
-   Enhancement: No suggestions for TypedDict value with Union[Literal, None] type annotation [pylance-release#4649](https://github.com/microsoft/pylance-release/issues/4649)
-   Enhancement: Completions don't work for test parameters [pylance-release#4590](https://github.com/microsoft/pylance-release/issues/4590)
-   Enhancement: Go to def on `in` should navigate to `__contains__` [pylance-release#4467](https://github.com/microsoft/pylance-release/issues/4467)

Pylance's copy of Pyright has been updated from 1.1.324 to 1.1.325.

-   See Pyright's release notes for details: [1.1.325](https://github.com/microsoft/pyright/releases/tag/1.1.325)

## 2023.8.50 (30 August 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.8.41](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023841-23-august-2023-prerelease) prerelease build.

## 2023.8.41 (23 August 2023) PreRelease

Notable changes:

-   Bug fix: IntelliSense not fully working with Python Enum classes [pylance-release#4734](https://github.com/microsoft/pylance-release/issues/4734)
-   Bug fix: Pylance crash after saving loose untitled notebook [pylance-release#4733](https://github.com/microsoft/pylance-release/issues/4733)
-   Bug fix: formatOnType causes incorrect indentation in nested function calls within functions and methods [pylance-release#4714](https://github.com/microsoft/pylance-release/issues/4714)
-   Bug fix: Pylance crashing on Jupyter Notebook Cell Deletion [pylance-release#4685](https://github.com/microsoft/pylance-release/issues/4685)
-   Bug fix: Sometimes the referenced objects and methods may appear as Unknown [pylance-release#4684](https://github.com/microsoft/pylance-release/issues/4684)
-   Bug fix: Inconsistency between inlay hint and implied type with recursive type [pylance-release#4641](https://github.com/microsoft/pylance-release/issues/4641)
-   Bug fix: Auto-indent doesn't respect VS Code indentation settings in new files [pylance-release#4071](https://github.com/microsoft/pylance-release/issues/4071)
-   Bug fix: Python code prompt in vscode with docstring [pylance-release#3509](https://github.com/microsoft/pylance-release/issues/3509)

Pylance's copy of Pyright has been updated from 1.1.323 to 1.1.324.

-   See Pyright's release notes for details: [1.1.324](https://github.com/microsoft/pyright/releases/tag/1.1.324)

## 2023.8.40 (23 August 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.8.31](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023831-16-august-2023-prerelease) prerelease build.

## 2023.8.31 (16 August 2023) PreRelease

Notable changes:

-   Bug fix: Pylance crashing for unknown reason [pylance-release#4712](https://github.com/microsoft/pylance-release/issues/4712)
-   Bug fix: False positive when using structural pattern matching inside a loop [pylance-release#4706](https://github.com/microsoft/pylance-release/issues/4706)
-   Enhancement: Importing SynapseML doesn't work [pylance-release#4648](https://github.com/microsoft/pylance-release/issues/4648)

Pylance's copy of Pyright has been updated from 1.1.321 to 1.1.323.

-   See Pyright's release notes for details: [1.1.322](https://github.com/microsoft/pyright/releases/tag/1.1.322), [1.1.323](https://github.com/microsoft/pyright/releases/tag/1.1.323)

## 2023.8.30 (16 August 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.8.21](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023821-9-august-2023-prerelease) prerelease build.

## 2023.8.21 (9 August 2023) PreRelease

Notable changes:

-   Bug fix: FATAL ERROR: MarkCompactCollector: young object promotion failed Allocation failed - JavaScript heap out of memory [pylance-release#4598](https://github.com/microsoft/pylance-release/issues/4598)

Pylance's copy of Pyright has been updated from 1.1.320 to 1.1.321.

-   See Pyright's release notes for details: [1.1.321](https://github.com/microsoft/pyright/releases/tag/1.1.321)

## 2023.8.20 (9 August 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.8.11](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023811-2-august-2023-prerelease) prerelease build.

## 2023.8.11 (2 August 2023) PreRelease

Notable changes:

-   Bug fix: `__iter__` implementation not detected in superclass of Pyomo OrderedScalarSet [pylance-release#4667](https://github.com/microsoft/pylance-release/issues/4667)
-   Bug fix: error: Expected no type arguments for class in pyright, but not pylance [pylance-release#4656](https://github.com/microsoft/pylance-release/issues/4656)
-   Bug fix: Don't show private modules for import completions on a py.typed package [pylance-release#4528](https://github.com/microsoft/pylance-release/issues/4528)

Pylance's copy of Pyright has been updated from 1.1.319 to 1.1.320.

-   See Pyright's release notes for details: [1.1.320](https://github.com/microsoft/pyright/releases/tag/1.1.320)

## 2023.8.10 (2 August 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.7.43](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023743-31-july-2023-prerelease) prerelease build.

## 2023.7.43 (31 July 2023) PreRelease

Notable changes:

-   Bug fix: No `unbound variable` reported for variable self assignment inside function [pylance-release#4634](https://github.com/microsoft/pylance-release/issues/4634)
-   Bug fix: Support for code block wrapped with "~~~" [pylance-release#4612](https://github.com/microsoft/pylance-release/issues/4612)
-   Bug fix: Import resolve error changes should be behind an experiment [pylance-release#4672](https://github.com/microsoft/pylance-release/issues/4672)

## 2023.7.42 (28 July 2023) PreRelease

Notable changes:

-   Bug fix: Unexpected "importSourceResolveFailure" [pylance-release#4653](https://github.com/microsoft/pylance-release/issues/4653)
-   Bug fix: AddExtraPath was broken by the rule change for import resolve errors [pylance-release#4651](https://github.com/microsoft/pylance-release/issues/4651)

## 2023.7.41 (26 July 2023) PreRelease

Notable changes:

-   Bug fix: Pylance not indexing all files and symbols for sqlalchemy even with package depth of 4 [pylance-release#4637](https://github.com/microsoft/pylance-release/issues/4637)
-   Bug fix: Pylance seems to forget the selected interpreter after a (short) while: reportMissingImports [pylance-release#4606](https://github.com/microsoft/pylance-release/issues/4606)
-   Enhancement: Add ability to track messages being displayed to users [pylance-release#4482](https://github.com/microsoft/pylance-release/issues/4482)
-   Enhancement: Import resolution errors should show more information about the environment in use [pylance-release#4368](https://github.com/microsoft/pylance-release/issues/4368)
-   Bug fix: `python.analysis.completeFunctionParens` adds parens on base class names [pylance-release#4273](https://github.com/microsoft/pylance-release/issues/4273)

Pylance's copy of Pyright has been updated from 1.1.318 to 1.1.319.

-   See Pyright's release notes for details: [1.1.319](https://github.com/microsoft/pyright/releases/tag/1.1.319)

## 2023.7.40 (26 July 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.7.31](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023731-19-july-2023-prerelease) prerelease build.

## 2023.7.31 (19 July 2023) PreRelease

Notable changes:

-   Bug fix: Pylance reports errors in EJS file [pylance-release#4591](https://github.com/microsoft/pylance-release/issues/4591)
-   Bug fix: Wrong return type when autocomplete async abstractmethod [pylance-release#4573](https://github.com/microsoft/pylance-release/issues/4573)
-   Bug fix: Annotated[..., Type] forward references are not understood [pylance-release#4565](https://github.com/microsoft/pylance-release/issues/4565)
-   Bug fix: Server settings should be printed when in 'trace' mode. [pylance-release#4559](https://github.com/microsoft/pylance-release/issues/4559)
-   Bug fix: Long operation nearly 80 seconds [pylance-release#4459](https://github.com/microsoft/pylance-release/issues/4459)
-   Bug fix: Show Call Hierarchy doesn't handle overridden methods correctly [pylance-release#2774](https://github.com/microsoft/pylance-release/issues/2774)
-   Enhancement: Stop Suggesting Enum member access on Enum members [pylance-release#1905](https://github.com/microsoft/pylance-release/issues/1905)

Pylance's copy of Pyright has been updated from 1.1.316 to 1.1.318.

-   See Pyright's release notes for details: [1.1.317](https://github.com/microsoft/pyright/releases/tag/1.1.317), [1.1.318](https://github.com/microsoft/pyright/releases/tag/1.1.318)

## 2023.7.30 (19 July 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.7.21](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023721-12-july-2023-prerelease) prerelease build.

## 2023.7.21 (12 July 2023) PreRelease

Notable changes:

-   Bug fix: Enabled "python.analysis.autoFormatStrings" is being applied on docstrings [pylance-release#4583](https://github.com/microsoft/pylance-release/issues/4583)
-   Bug fix: Typo in description of python.analysis.inlayHints.pytestParameters [pylance-release#4576](https://github.com/microsoft/pylance-release/issues/4576)
-   Bug fix: Using autocomplete to override methods yields unexpected imports [pylance-release#4575](https://github.com/microsoft/pylance-release/issues/4575)
-   Bug fix: Moving symbol refactoring: docstrings have the blank line removed [pylance-release#4540](https://github.com/microsoft/pylance-release/issues/4540)
-   Bug fix: PyLance automatically removes tab when using colon [pylance-release#4507](https://github.com/microsoft/pylance-release/issues/4507)

## 2023.7.20 (12 July 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.7.11](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023711-5-july-2023-prerelease) prerelease build.

## 2023.7.11 (5 July 2023) PreRelease

Notable changes:

-   Bug fix: Pylance automatically removes tab when using colon [pylance-release#4507](https://github.com/microsoft/pylance-release/issues/4507)

## 2023.7.10 (5 July 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.6.43](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023643-3-july-2023-prerelease) prerelease build.

## 2023.6.43 (3 July 2023) PreRelease

Notable changes:

-   Bug fix: Fix Django-specific telemetry

## 2023.6.42 (29 June 2023) PreRelease

Notable changes:

-   Enhancement: Add support for localization [pylance-release#3437](https://github.com/microsoft/pylance-release/issues/3437)

## 2023.6.41 (28 June 2023) PreRelease

Notable changes:

-   Bug fix: Pylance does not find scipy functions (e.g. "filtfilt" is not a known member of "scipy.signal") since Pylance 2023.6.20 [pylance-release#4531](https://github.com/microsoft/pylance-release/issues/4531)
-   Bug fix: Overloaded functions not recognized [pylance-release#4526](https://github.com/microsoft/pylance-release/issues/4526)
-   Bug fix: Automatic Indentation for Multiline F-Strings within Brackets [pylance-release#4496](https://github.com/microsoft/pylance-release/issues/4496)
-   Bug fix: Debug Failure. False expression: Check called unnecessarily [pylance-release#4492](https://github.com/microsoft/pylance-release/issues/4492)

Pylance's copy of Pyright has been updated from 1.1.315 to 1.1.316.

-   See Pyright's release notes for details: [1.1.316](https://github.com/microsoft/pyright/releases/tag/1.1.316)

## 2023.6.40 (28 June 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.6.31](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023631-21-june-2023-prerelease) prerelease build.

## 2023.6.31 (21 June 2023) PreRelease

Notable changes:

-   Bug fix: Type Checking Working Inconsistently [pylance-release#4495](https://github.com/microsoft/pylance-release/issues/4495)
-   Bug fix: Automatically infer class variables based on declaration [pylance-release#4389](https://github.com/microsoft/pylance-release/issues/4389)

Pylance's copy of Pyright has been updated from 1.1.314 to 1.1.315.

-   See Pyright's release notes for details: [1.1.315](https://github.com/microsoft/pyright/releases/tag/1.1.315)

## 2023.6.30 (21 June 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.6.21](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023621-14-june-2023-prerelease) prerelease build.

## 2023.6.21 (14 June 2023) PreRelease

Notable changes:

-   Bug fix: Stubs downloader log claims that `django` is not installed, but it is [pylance-release#4469](https://github.com/microsoft/pylance-release/issues/4469)
-   Bug fix: Source actions not found [pylance-release#4464](https://github.com/microsoft/pylance-release/issues/4464)
-   Bug fix: The cursor doesn't auto indent after newline [pylance-release#4444](https://github.com/microsoft/pylance-release/issues/4444)
-   Bug fix: Pylance crash when autocompleting aws_cdk [pylance-release#4241](https://github.com/microsoft/pylance-release/issues/4241)

Pylance's copy of Pyright has been updated from 1.1.313 to 1.1.314.

-   See Pyright's release notes for details: [1.1.314](https://github.com/microsoft/pyright/releases/tag/1.1.314)

## 2023.6.20 (14 June 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.6.11](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023611-7-june-2023-prerelease) prerelease build.

## 2023.6.11 (7 June 2023) PreRelease

Notable changes:

-   Bug fix: Escaped anti-slash at the end of f-string shows syntax error [pylance-release#4460](https://github.com/microsoft/pylance-release/issues/4460)
-   Bug fix: Cannot access member "named_steps" for type "BaseEstimator" [pylance-release#4432](https://github.com/microsoft/pylance-release/issues/4432)
-   Bug fix: Error: Debug Failure. False expression: Check called before binding [pylance-release#4310](https://github.com/microsoft/pylance-release/issues/4310)
-   Enhancement: Provides go to def support for overloaded operators and special method names. [pylance-release#3759](https://github.com/microsoft/pylance-release/issues/3759)

Pylance's copy of Pyright has been updated from 1.1.311 to 1.1.313.

-   See Pyright's release notes for details: [1.1.312](https://github.com/microsoft/pyright/releases/tag/1.1.312), [1.1.313](https://github.com/microsoft/pyright/releases/tag/1.1.313)

## 2023.6.10 (7 June 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.5.51](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023551-31-may-2023-prerelease) prerelease build.

## 2023.5.51 (31 May 2023) PreRelease

Notable changes:

-   Enhancement: Make the file count limit for indexing configurable [pylance-release#4417](https://github.com/microsoft/pylance-release/issues/4417)
-   Enhancement: Using `display` in a notebook requires a kernel be selected that has IPython installed [pylance-release#4193](https://github.com/microsoft/pylance-release/issues/4193)

Pylance's copy of Pyright has been updated from 1.1.310 to 1.1.311.

-   See Pyright's release notes for details: [1.1.311](https://github.com/microsoft/pyright/releases/tag/1.1.311)

## 2023.5.50 (31 May 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.5.41](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023541-24-May-2023-prerelease) prerelease build.

## 2023.5.41 (24 May 2023) PreRelease

Notable changes:

-   Bug fix: Google docstrings, hover preview for args when multiple words in parenthesis [pylance-release#4395](https://github.com/microsoft/pylance-release/issues/4395)
-   Bug fix: "expand selection" behaves inconsistently [pylance-release#4393](https://github.com/microsoft/pylance-release/issues/4393)
-   Bug fix: renaming symbol from untitled python file does not change the symbol in the file [pylance-release#4335](https://github.com/microsoft/pylance-release/issues/4335)

Pylance's copy of Pyright has been updated from 1.1.309 to 1.1.310.

-   See Pyright's release notes for details: [1.1.310](https://github.com/microsoft/pyright/releases/tag/1.1.310)

## 2023.5.40 (24 May 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.5.31](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023531-17-May-2023-prerelease) prerelease build.

## 2023.5.31 (17 May 2023) PreRelease

Notable changes:

-   Bug fix: Very poor performance with CDK for Terraform AWS provider [pylance-release#4362](https://github.com/microsoft/pylance-release/issues/4362)
-   Bug fix: Raw strings should not auto format [pylance-release#4320](https://github.com/microsoft/pylance-release/issues/4320)

Pylance's copy of Pyright has been updated from 1.1.307 to 1.1.309.

-   See Pyright's release notes for details: [1.1.308](https://github.com/microsoft/pyright/releases/tag/1.1.308), [1.1.309](https://github.com/microsoft/pyright/releases/tag/1.1.309)

## 2023.5.30 (17 May 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.5.21](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023521-10-May-2023-prerelease) prerelease build.

## 2023.5.21 (10 May 2023) PreRelease

Notable changes:

-   Bug fix: Raw strings should not auto format [pylance-release#4320](https://github.com/microsoft/pylance-release/issues/4320)
-   Bug fix: Google docstrings with type hints not displaying properly in hover window after version 2023.4.30 [pylance-release#4317](https://github.com/microsoft/pylance-release/issues/4317)
-   Bug fix: wrong result for references [pylance-release#4285](https://github.com/microsoft/pylance-release/issues/4285)
-   Bug fix: Indentation for tuples doesn't work [pylance-release#4259](https://github.com/microsoft/pylance-release/issues/4259)
-   Bug fix: Saving .py files delayed by Getting code actions from 'Python' [pylance-release#4263](https://github.com/microsoft/pylance-release/issues/4263)
-   Enhancement: Enable inlay hints for call argument names by setting 'python.analysis.inlayHints.callArgumentNames' to true

Pylance's copy of Pyright has been updated from 1.1.306 to 1.1.307.

-   See Pyright's release notes for details: [1.1.307](https://github.com/microsoft/pyright/releases/tag/1.1.307)

## 2023.5.20 (10 May 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.5.11](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023511-3-May-2023-prerelease) prerelease build.

## 2023.5.11 (3 May 2023) PreRelease

Notable changes:

-   Enhancement: Support for PEP 712 [pylance-release#4290](https://github.com/microsoft/pylance-release/issues/4290)
-   Bug fix: Typing `import an` should not result in auto-importing of antigravity [pylance-release#4229](https://github.com/microsoft/pylance-release/issues/4229)
-   Enhancement: Remove auto-import when typing the letter d to avoid being serenaded with The Zen of Python [pylance-release#2535](https://github.com/microsoft/pylance-release/issues/2535)

Pylance's copy of Pyright has been updated from 1.1.305 to 1.1.306.

-   See Pyright's release notes for details: [1.1.306](https://github.com/microsoft/pyright/releases/tag/1.1.306)

## 2023.5.10 (3 May 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.4.41](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023441-26-April-2023-prerelease) prerelease build.

## 2023.4.41 (26 April 2023) PreRelease

Notable changes:

-   Bug fix: reportGeneralTypeIssues: Pylance complains about sending any value other than None to a generator. [pylance-release#4275](https://github.com/microsoft/pylance-release/issues/4275)
-   Bug fix: Move symbol refactoring not updating the import when symbol is referenced inside a function [pylance-release#4234](https://github.com/microsoft/pylance-release/issues/4234)
-   Enhancement: feature request: braces should auto-pair inside f-strings [pylance-release#3743](https://github.com/microsoft/pylance-release/issues/3743)
-   Enhancement: Go to definition by python module path in string [pylance-release#3700](https://github.com/microsoft/pylance-release/issues/3700)

Pylance's copy of Pyright has been updated from 1.1.304 to 1.1.305.

-   See Pyright's release notes for details: [1.1.305](https://github.com/microsoft/pyright/releases/tag/1.1.305)

## 2023.4.40 (26 April 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.4.31](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023431-19-April-2023-prerelease) prerelease build.

## 2023.4.31 (19 April 2023) PreRelease

Notable changes:

-   Bug fix: Incorrect Evaluation of Recursive Types in Structural Pattern Matching [pylance-release#4240](https://github.com/microsoft/pylance-release/issues/4240)
-   Bug fix: Error in bundled matplotlib stubs [pylance-release#4237](https://github.com/microsoft/pylance-release/issues/4237)
-   Enhancement: Autocomplete for method overwrites could add missing imports [pylance-release#4200](https://github.com/microsoft/pylance-release/issues/4200)
-   Bug fix: Linebreak issue with tooltip display of function comment [pylance-release#4074](https://github.com/microsoft/pylance-release/issues/4074)
-   Bug fix: Indentation gets removed [pylance-release#3961](https://github.com/microsoft/pylance-release/issues/3961)

Pylance's copy of Pyright has been updated from 1.1.303 to 1.1.304.

-   See Pyright's release notes for details: [1.1.304](https://github.com/microsoft/pyright/releases/tag/1.1.304)

## 2023.4.30 (19 April 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.4.21](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023421-12-April-2023-prerelease) prerelease build.

## 2023.4.21 (12 April 2023) PreRelease

Notable changes:

-   Bug fix: Generic Callable[[T], Any] cannot be passed on to another generic function [pylance-release#4219](https://github.com/microsoft/pylance-release/issues/4219)
-   Bug fix: High CPU on starting pylance from get_pytest_options.py [pylance-release#4218](https://github.com/microsoft/pylance-release/issues/4218)
-   Bug fix: Clear inlay hint on function return type when function declaration is incomplete. [pylance-release#4212](https://github.com/microsoft/pylance-release/issues/4212)
-   Bug fix: Incorrect Evaluation of Recursive Types in Structural Pattern Matching [pylance-release#4207](https://github.com/microsoft/pylance-release/issues/4207)
-   Bug fix: Don't put 2 lines between variables when moving symbol. [pylance-release#4202](https://github.com/microsoft/pylance-release/issues/4202)
-   Bug fix: Folding is not working correctly for `#region` surrounded by imports [pylance-release#4159](https://github.com/microsoft/pylance-release/issues/4159)
-   Bug fix: Get Outgoing Calls always returns no results for aliased functions and classes [pylance-release#4137](https://github.com/microsoft/pylance-release/issues/4137)
-   Bug fix: Matplotlib subplots not returning correct types [pylance-release#3482](https://github.com/microsoft/pylance-release/issues/3482)

Pylance's copy of Pyright has been updated from 1.1.302 to 1.1.303.

-   See Pyright's release notes for details: [1.1.303](https://github.com/microsoft/pyright/releases/tag/1.1.303)

## 2023.4.20 (12 April 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.4.11](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023411-5-april-2023-prerelease) prerelease build.

## 2023.4.11 (5 April 2023) PreRelease

Notable changes:

-   Bug fix: Python 3.11 BaseExceptionGroup mistyped as ExceptionGroup [pylance-release#4183](https://github.com/microsoft/pylance-release/issues/4183)
-   Bug fix: call does not always resolve when in map [pylance-release#4182](https://github.com/microsoft/pylance-release/issues/4182)
-   Bug fix: Auto-import is suggesting completions from local files rather than library [pylance-release#4179](https://github.com/microsoft/pylance-release/issues/4179)
-   Bug fix: Autocomplete places positional arguments after keyword arguments [pylance-release#4173](https://github.com/microsoft/pylance-release/issues/4173)
-   Bug fix: Switching kernels in a notebook made pylance stop working [pylance-release#4166](https://github.com/microsoft/pylance-release/issues/4166)
-   Bug fix: pylance randomly stopped recognizing used imports [pylance-release#4142](https://github.com/microsoft/pylance-release/issues/4142)
-   Bug fix: Infinite loop in the chaining of files [pylance-release#4141](https://github.com/microsoft/pylance-release/issues/4141)
-   Bug fix: The "Move symbol to ..." refactoring displaces trailing comments in the destination module (including `type: ignore`, etc.) [pylance-release#4136](https://github.com/microsoft/pylance-release/issues/4136)
-   Bug fix: Rename on symbol in `from foo import foo` incorrectly updates module name [pylance-release#4129](https://github.com/microsoft/pylance-release/issues/4129)
-   Enhancement: Change hover to only show the overload that applies. [pylance-release#3850](https://github.com/microsoft/pylance-release/issues/3850)

Pylance's copy of Pyright has been updated from 1.1.301 to 1.1.302.

-   See Pyright's release notes for details: [1.1.302](https://github.com/microsoft/pyright/releases/tag/1.1.302)

## 2023.4.10 (5 April 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.3.41](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023341-29-march-2023-prerelease) prerelease build.

## 2023.3.41 (29 March 2023) PreRelease

Notable changes:

-   Bug fix: Crash within `getRegionCommentType` [pylance-release#4157](https://github.com/microsoft/pylance-release/issues/4157)
-   Bug fix: intermittent "ClassName is incompatible with ClassName" [pylance-release#4151](https://github.com/microsoft/pylance-release/issues/4151)
-   Bug fix: "suggestion details" in intellisense stopped showing on Ctrl+Space [pylance-release#4153](https://github.com/microsoft/pylance-release/issues/4153)
-   Bug fix: autoimport stopped working when using workspaces [pylance-release#4144](https://github.com/microsoft/pylance-release/issues/4144)
-   Bug fix: macOS toggleSuggestionDetails not working if Pylance is working [pylance-release#4145](https://github.com/microsoft/pylance-release/issues/4145)
-   Bug fix: Autoimport from module, not directly from file [pylance-release#4065](https://github.com/microsoft/pylance-release/issues/4065)
-   Bug fix: Auto parens happens for except clauses [pylance-release#3969](https://github.com/microsoft/pylance-release/issues/3969)
-   Bug fix: Call Hierarchy always returns no results for function aliased via `import as` [pylance-release#3893](https://github.com/microsoft/pylance-release/issues/3893)
-   Enhancement: `__slots__` not found on dataclass [pylance-release#4147](https://github.com/microsoft/pylance-release/issues/4147)

Pylance's copy of Pyright has been updated from 1.1.300 to 1.1.301.

-   See Pyright's release notes for details: [1.1.301](https://github.com/microsoft/pyright/releases/tag/1.1.301)

## 2023.3.40 (29 March 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.3.31](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023331-22-march-2023-prerelease) prerelease build.

## 2023.3.31 (22 March 2023) PreRelease

Notable changes:

-   Behavior change: Remove support for `python.linting.ignorePatterns` [pylance-release#4100](https://github.com/microsoft/pylance-release/issues/4100)
-   Bug fix: add support for pulsar avro [pylance-release#4117](https://github.com/microsoft/pylance-release/issues/4117)
-   Bug fix: dedent on `else` for an `if` statement that is followed by a `try` is incorrect [pylance-release#4050](https://github.com/microsoft/pylance-release/issues/4050)
-   Enhancement: Added bundled stubs for lightgbm, networkx, and vispy
-   Enhancement: Updated cv2, matplotlib, and sklearn stubs

Pylance's copy of Pyright has been updated from 1.1.299 to 1.1.300.

-   See Pyright's release notes for details: [1.1.300](https://github.com/microsoft/pyright/releases/tag/1.1.300)

## 2023.3.30 (22 March 2023) Release

Notable changes:

-   Release version that includes changes through the [2023.3.25](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023325-17-march-2023-prerelease) prerelease build.

## 2023.3.25 (17 March 2023) PreRelease

Notable changes:

-   Bug fix: Hover over symbols without docstrings isn't rendered correctly [pylance-release#4082](https://github.com/microsoft/pylance-release/issues/4082)
-   Bug fix: Language server crashing with `TypeError: this._token.cancel is not a function` [pylance-release#4055](https://github.com/microsoft/pylance-release/issues/4055)
-   Bug fix: Pylance suggestions show indirect imports through files opened in the site-packages folder [pylance-release#3760](https://github.com/microsoft/pylance-release/issues/3760)

Pylance's copy of Pyright remains on 1.1.299.

-   See Pyright's release notes for details: [1.1.299](https://github.com/microsoft/pyright/releases/tag/1.1.299)

## 2023.3.24 (17 March 2023) PreRelease

Pylance's copy of Pyright remains on 1.1.299.

-   See Pyright's release notes for details: [1.1.299](https://github.com/microsoft/pyright/releases/tag/1.1.299)
-   Unreleased in Pyright, but included in Pylance:
    -   Enhancement: Improved hover text for methods that are synthesized (e.g. the `get` method for TypedDict). This partly addresses https://github.com/microsoft/pylance-release/issues/4098.
    -   Enhancement Added support for `clear` and `popitem` methods on TypedDict instance that is marked `@final` and has no required entries.
    -   Bug fix: Fixed bug that resulted in a crash when user types `import` without a follow-on module name. This can happen in due corse of typing an import statement.
    -   Performance: Changed the logic in the code flow engine so it never attempts to infer a NoReturn return type for a function that lacks a return type annotation. This results in a big speed improvement for some (unannotated) code bases, but it also produces somewhat inconsistent type evaluation results because a function whose type is inferred to be NoReturn by the type checker will not be treated as such if it is called elsewhere in the program.

## 2023.3.23 (16 March 2023) PreRelease

Notable changes:

-   Bug fix: Django. Several DoesNotExist exceptions not reached [pylance-release#3918](https://github.com/microsoft/pylance-release/issues/3918)

Pylance's copy of Pyright remains on 1.1.299.

-   See Pyright's release notes for details: [1.1.299](https://github.com/microsoft/pyright/releases/tag/1.1.299)
-   Unreleased in Pyright, but included in Pylance:
    -   Bug fix: Fixed regression that caused a crash in the presence of the illegal statement `import .`. This addresses [pylance-release#4778](https://github.com/microsoft/pyright/issues/4778).
    -   Bug fix: Fixed bug that resulted in a false positive error relating to variance incompatibility.
    -   Enhancement: Added new diagnostic check `reportImplicitOverride`.
    -   Performance: Further improved perf when determining type compatibility of unions with many subtypes. This further reduces the analysis time of pydantic from 12s to 4s.
    -   Performance: sped up type analyzer by 5-25% by caching types that have been converted to or from an instance. This drops the analysis time of pydantic from 17s to 12s.
    -   Bug fix: Fixed regression that resulted in a false positive error when using an index expression form with a class whose metaclass supplies a `__getitem__` method when the expression is used as a runtime expression, as opposed to a type expression.

## 2023.3.22 (15 March 2023) PreRelease

Notable changes:

-   Bug fix: Type captured by wildcard pattern is partially unknown - Why? [pylance-release#4058](https://github.com/microsoft/pylance-release/issues/4058)
-   Bug fix: Pytest intellisense doesn't work when using direct imports of `fixture, mark` [pylance-release#4039](https://github.com/microsoft/pylance-release/issues/4039)
-   Bug fix: Enabling the Jupyter extension causes high CPU usage [pylance-release#4022](https://github.com/microsoft/pylance-release/issues/4022)
-   Bug fix: Inappropriate type hint or obscured declaration error [pylance-release#3834](https://github.com/microsoft/pylance-release/issues/3834)
-   Bug fix: Invalid Type Suggestion [pylance-release#3824](https://github.com/microsoft/pylance-release/issues/3824)
-   Bug fix: Inlay Hints infills illegal return type hints on methods [pylance-release#3767](https://github.com/microsoft/pylance-release/issues/3767)
-   Bug fix: Renaming in Jupyter notebooks only works in a single cell [pylance-release#3279](https://github.com/microsoft/pylance-release/issues/3279)

Pylance's copy of Pyright has been updated from 1.1.298 to 1.1.299.

-   See Pyright's release notes for details: [1.1.299](https://github.com/microsoft/pyright/releases/tag/1.1.299)

## 2023.3.21 (8 March 2023) PreRelease

Notable changes:

-   Bug fix: In `functools.partial`, container of subclass is not recognized as container of baseclass [pylance-release#4044](https://github.com/microsoft/pylance-release/issues/4044)
-   Bug fix: `__init__` docstring is ignored if `@overload` is used [pylance-release#4042](https://github.com/microsoft/pylance-release/issues/4042)
-   Bug fix: Intellicode no longer works in Azure Notebooks [pylance-release#4032](https://github.com/microsoft/pylance-release/issues/4032)
-   Enhancement: `match` `case` or `if` statements do not recognize `Literal` types [pylance-release#4005](https://github.com/microsoft/pylance-release/issues/4005)
-   Enhancement: Autocomplete Keys for get method [pylance-release#3994](https://github.com/microsoft/pylance-release/issues/3994)

Pylance's copy of Pyright has been updated from 1.1.296 to 1.1.298.

-   See Pyright's release notes for details: [1.1.297](https://github.com/microsoft/pyright/releases/tag/1.1.297), [1.1.298](https://github.com/microsoft/pyright/releases/tag/1.1.298).

## 2023.3.20 (8 March 2023) Release

Notable changes:

-   Release version that includes changes through version [2023.3.11](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023311-1-march-2023-prerelease) prerelease build.

## 2023.3.11 (1 March 2023) PreRelease

Notable changes:

-   Bug fix: incomplete movement expression while Refactor -> Move symbol to [pylance-release#4018](https://github.com/microsoft/pylance-release/issues/4018)
-   Bug fix: Keywords force completions to stop [pylance-release#3968](https://github.com/microsoft/pylance-release/issues/3968)
-   Bug fix: quick fix places # type: ignore on wrong line. [pylance-release#3959](https://github.com/microsoft/pylance-release/issues/3959)
-   Bug fix: Accepting refactor "type: ignore" puts newline in wrong spot [pylance-release#3858](https://github.com/microsoft/pylance-release/issues/3858)
-   Bug fix: Inline docstrings for attributes don't show up unless docstring is on very next line [pylance-release#3769](https://github.com/microsoft/pylance-release/issues/3769)

Pylance's copy of Pyright has been updated from 1.1.295 to 1.1.296.

-   See Pyright's release notes for details: [1.1.296](https://github.com/microsoft/pyright/releases/tag/1.1.296).

-   Unreleased in Pyright, but included in Pylance:
    -   Bug fix: Fixed a bug that caused the variance for type parameters to be incorrectly inferred when an auto-variance class derived from a non-auto-variance class. This addresses [#4713](https://github.com/microsoft/pyright/issues/4713).
    -   Enhancement: Performance optimization: reduced formatting of error messages in cases where it can be determined that they are not needed (e.g. in speculative evaluation code paths).
    -   Enhancement: Declare workspaceFolders support in server capabilities (https://github.com/microsoft/pyright/pull/4666)
    -   Bug fix: Added logic to detect when a type alias is used in a generic class declaration's base class list and a type parameter used with the type alias is incompatible with the variance required for the type alias. This addresses [#4699](https://github.com/microsoft/pyright/issues/4699).
    -   Bug fix: Implemented missing check for generic type alias specialization when too few type arguments are provided. This addresses [#4709](https://github.com/microsoft/pyright/issues/4709).
    -   Bug fix: Fixed a recent regression that resulted in an incorrect type evaluation when using a `__new__` method whose return type annotation is `Self`. This addresses [#4705](https://github.com/microsoft/pyright/issues/4705).
    -   Bug fix: Fixed a bug that led to a false positive error when using the | operator with two dicts whose keys or values are defined as literals. This addresses part of [#4707](https://github.com/microsoft/pyright/issues/4707).

## 2023.3.10 (1 March 2023) Release

Notable changes:

-   Release version that includes changes through version [2023.2.43](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023243-24-february-2023-prerelease) prerelease build.

## 2023.2.43 (24 February 2023) PreRelease

Notable changes:

-   Bug fix: Issues when moving symbol to a different file [pylance-release#4002](https://github.com/microsoft/pylance-release/issues/4002)
-   Bug fix: Unexpected indent when pressing Enter at start of dedented line [pylance-release#3974](https://github.com/microsoft/pylance-release/issues/3974)

## 2023.2.42 (23 February 2023) PreRelease

Notable changes:

-   Rollback changes for [pylance-release#4001](https://github.com/microsoft/pylance-release/discussions/4001). Fix broke imports of stubs.

## 2023.2.41 (22 February 2023) PreRelease

Notable changes:

-   Bug fix: Pytest fixtures that yield should show the yielded result [pylance-release#3973](https://github.com/microsoft/pylance-release/issues/3973)
-   Bug fix: Missing syntax highlighting for multi variable declaration [pylance-release#3904](https://github.com/microsoft/pylance-release/issues/3904)
-   Bug fix: Source directory hiding build directory in analysis and autocomplete [pylance-release#3429](https://github.com/microsoft/pylance-release/issues/3429)
-   Enhancement: Updated pandas stubs.
-   Enhancement: Updated typeshed.

Pylance's copy of Pyright has been updated from 1.1.294 to 1.1.295.

-   See Pyright's release notes for details: [1.1.295](https://github.com/microsoft/pyright/releases/tag/1.1.295).

## 2023.2.40 (22 February 2023) Release

Notable changes:

-   Release version that includes changes through version [2022.2.31](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023231-15-february-2023-prerelease) prerelease build.

## 2023.2.31 (15 February 2023) PreRelease

Notable changes:

-   Enhancement: Make "Fields without default values cannot appear after fields with default values" a toggle-able diagnostic rule [pylance-release#3939](https://github.com/microsoft/pylance-release/issues/3939)
-   Bug fix: New partial typeshed tensorflow stubs break pylance for tensorflow [pylance-release#3937](https://github.com/microsoft/pylance-release/issues/3937)
-   Bug fix: Pandas Dataframe.explode function parameter TypeError [pylance-release#3871](https://github.com/microsoft/pylance-release/issues/3871)
-   Bug fix: Named parameter supports for PEP 692 [pylance-release#3868](https://github.com/microsoft/pylance-release/issues/3868)

Pylance's copy of Pyright has been updated from 1.1.293 to 1.1.294.

-   See Pyright's release notes for details: [1.1.294](https://github.com/microsoft/pyright/releases/tag/1.1.294).

## 2023.2.30 (15 February 2023) Release

Notable changes:

-   Release version that includes changes through version [2022.2.21](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023221-8-february-2023-prerelease) prerelease build.

## 2023.2.21 (8 February 2023) PreRelease

Notable changes:

-   Bug fix: Empty kw only dataclass has incorrect type hint for `__init__` signature [pylance-release#3916](https://github.com/microsoft/pylance-release/issues/3916)
-   Bug fix: Docstring of @property is not rendered correctly [pylance-release#3888](https://github.com/microsoft/pylance-release/issues/3888)

Pylance's copy of Pyright has been updated from 1.1.292 to 1.1.293.

-   See Pyright's release notes for details: [1.1.293](https://github.com/microsoft/pyright/releases/tag/1.1.293).

## 2023.2.20 (8 February 2023) Release

Notable changes:

-   Release version that includes changes through version [2022.2.13](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023213-6-february-2023-prerelease) prerelease build.

## 2023.2.13 (6 February 2023) PreRelease

Notable changes:

-   Bug fix: Crash with multi-root workspace (pre-release) [pylance-release#3907](https://github.com/microsoft/pylance-release/issues/3907)

## 2023.2.12 (2 February 2023) PreRelease

Notable changes:

-   Bug fix: Performance regression with 2023.2.11 Pre-Release [pylance-release#3901](https://github.com/microsoft/pylance-release/issues/3901)
-   Bug fix: VS Code + Pylance does not find venv-installed modules while venv is activated [pylance-release#3881](https://github.com/microsoft/pylance-release/issues/3881)
-   Enhancement: Pylance does not provide source actions for removing unused imports or sorting imports inside Jupyter Notebooks [pylance-release#3175](https://github.com/microsoft/pylance-release/issues/3175)

## 2023.2.11 (1 February 2023) PreRelease

Notable changes:

-   Bug fix: Don't show `__future__` options in auto-import quick action [pylance-release#3882](https://github.com/microsoft/pylance-release/issues/3882)
-   Bug fix: Syntax highlighting stop working after loading certain python files [pylance-release#3886](https://github.com/microsoft/pylance-release/issues/3886)
-   Bug fix: No automatic parens with class types [pylance-release#3870](https://github.com/microsoft/pylance-release/issues/3870)
-   Enhancement: semantic highlighting of cached_property [pylance-release#3742](https://github.com/microsoft/pylance-release/issues/3742)
-   Enhancement: Improve pytest completions and goto def [pylance-release#3727](https://github.com/microsoft/pylance-release/issues/3727)
-   Bug fix: `#region` nesting doesn't recognise last `#endregion` if there's no code after it at the end of the file on a non-"root" indent level [pylance-release#3290](https://github.com/microsoft/pylance-release/issues/3290)
-   Bug fix: Commented code at the end of a method doesn't collapse with method [pylance-release#2321](https://github.com/microsoft/pylance-release/issues/2321)

Pylance's copy of Pyright has been updated from 1.1.291 to 1.1.292.

-   See Pyright's release notes for details: [1.1.292](https://github.com/microsoft/pyright/releases/tag/1.1.292).

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: Fixed a few typos in the pyright documentation.
    -   Bug Fix: Fixed a bug that resulted in incorrect type evaluation when accessing instance methods directly from a `None` instance
    -   Bug Fix: Fixed a regression that resulted in a crash when resolving overloads with different numbers of parameters and with with arguments that evaluate to `Any`

## 2023.2.10 (1 February 2023) Release

-   Release version that rolls up changes from the [2022.1.41](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023141-25-january-2023-prerelease) prerelease build.

## 2023.1.41 (25 January 2023) PreRelease

Notable changes:

-   Bug fix: Request textDocument/foldingRange failed. [pylance-release#3847](https://github.com/microsoft/pylance-release/issues/3847)
-   Bug fix: Bad code insertion when typing Callable params as ellipsis [pylance-release#3841](https://github.com/microsoft/pylance-release/issues/3841)
-   Enhancement: Add more fine-grained code action kinds for `refactor.extract` [pylance-release#3803](https://github.com/microsoft/pylance-release/issues/3803)

Pylance's copy of Pyright has been updated from 1.1.290 to 1.1.291.

-   See Pyright's release notes for details: [1.1.291](https://github.com/microsoft/pyright/releases/tag/1.1.291).

## 2023.1.40 (25 January 2023) Release

-   Release version that rolls up changes from the [2022.1.31](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023131-18-january-2023-prerelease) prerelease build.

## 2023.1.31 (18 January 2023) PreRelease

Notable changes:

-   Bug fix: Overly aggressive automatic indent on deeply nested list in a `@pytest.mark.parametrize()` call [pylance-release#3839](https://github.com/microsoft/pylance-release/issues/3839)
-   Bug fix: No brackets autocompletion with python.analysis.completeFunctionParens set to true when python.languageServer is set to Pylance [pylance-release#3831](https://github.com/microsoft/pylance-release/issues/3831)
-   Bug fix: PYTHONPATH isn't expanded like how python handles it [pylance-release#3823](https://github.com/microsoft/pylance-release/issues/3823)
-   Bug fix: Django utils not found in auto import [pylance-release#3815](https://github.com/microsoft/pylance-release/issues/3815)
-   Bug fix: `extraPaths` starting with `~/` on Linux are considered relative [pylance-release#3730](https://github.com/microsoft/pylance-release/issues/3730)
-   Bug fix: Exclude map files from extension bundle [pylance-release#3647](https://github.com/microsoft/pylance-release/issues/3647)
-   Bug fix: Exclude platform specific bits from extension bundle [pylance-release#3646](https://github.com/microsoft/pylance-release/issues/3646)

Pylance's copy of Pyright has been updated from 1.1.288 to 1.1.290.

-   See Pyright's release notes for details: [1.1.289](https://github.com/microsoft/pyright/releases/tag/1.1.289), [1.1.290](https://github.com/microsoft/pyright/releases/tag/1.1.290).

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: Fixed a bug in the constraint solver that led to unsolved type variables in the case where a `lambda x:x` was passed to a `Callable[[T], S]`.
    -   Bug Fix: Fixed a bug that could lead to infinite type evaluation time when inferring the type of a tuple in a loop.
    -   Bug Fix: When converting a class into a callable (by combining its **new** and `__init__` methods), capture the docstring of the constructor or class. This preserves docstrings when using a class decorator.

## 2023.1.30 (18 January 2023) Release

-   Release version that rolls up changes from the [2022.1.21](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023121-11-january-2023-prerelease) prerelease build.

## 2023.1.21 (11 January 2023) PreRelease

Notable changes:

-   Bug fix: (Python) "Find All References" on any `__init__` shows every constructor for every class [pylance-release#3802](https://github.com/microsoft/pylance-release/issues/3802)
-   Bug fix: Auto-indent behavior as before / jumping to beginning of line [pylance-release#3781](https://github.com/microsoft/pylance-release/issues/3781)
-   Bug fix: No import suggestions for multi-root workspace with editable installs [pylance-release#3732](https://github.com/microsoft/pylance-release/issues/3732)

Pylance's copy of Pyright has been updated from 1.1.287 to 1.1.288.

-   See Pyright's release notes for details: [1.1.288](https://github.com/microsoft/pyright/releases/tag/1.1.288).

## 2023.1.20 (11 January 2023) Release

-   Release version that rolls up changes from the [2022.1.11](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2023111-4-january-2023-prerelease) prerelease build.

## 2023.1.11 (4 January 2023) PreRelease

Notable changes:

-   Bug fix: Any comment that contains the word "region" triggers an error "#region is missing corresponding #endregion" [pylance-release#3765](https://github.com/microsoft/pylance-release/issues/3765)
-   Bug fix: Pyright parser causes tests failures [pylance-release#3761](https://github.com/microsoft/pylance-release/issues/3761)
-   Bug fix: Provide doc string for module in "import statement" completion [pylance-release#3721](https://github.com/microsoft/pylance-release/issues/3721)
-   Bug fix: Python intellisense is very slow [pylance-release#3668](https://github.com/microsoft/pylance-release/issues/3668)
-   Bug fix: option to exclude some auto-import options [pylance-release#3466](https://github.com/microsoft/pylance-release/issues/3466)

Pylance's copy of Pyright has been updated from 1.1.283 to 1.1.287.

-   See Pyright's release notes for details: [1.1.287](https://github.com/microsoft/pyright/releases/tag/1.1.287), [1.1.286](https://github.com/microsoft/pyright/releases/tag/1.1.286), [1.1.285](https://github.com/microsoft/pyright/releases/tag/1.1.285), [1.1.284](https://github.com/microsoft/pyright/releases/tag/1.1.284).

## 2023.1.10 (4 January 2023) Release

-   Release version that rolls up changes from the [2022.12.21](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20221221-7-december-2022-prerelease) prerelease build.

## 2022.12.21 (7 December 2022) PreRelease

Notable changes:

-   Bug fix: Incorrect ShadowedImports warning on relative '.' import [pylance-release#3725](https://github.com/microsoft/pylance-release/issues/3725)
-   Bug fix: `source.unusedImports` is very slow and adds unnecessary whitespace [pylance-release#3715](https://github.com/microsoft/pylance-release/issues/3715)
-   Bug fix: Bad autocomplete when typing an open square bracket [pylance-release#3651](https://github.com/microsoft/pylance-release/issues/3651)
-   Bug fix: Module docstrings have inconsistent behaviour on hover [pylance-release#3636](https://github.com/microsoft/pylance-release/issues/3636)

## 2022.12.20 (7 December 2022) Release

-   Release version that rolls up changes from the [2022.12.11](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20221211-1-december-2022-prerelease) prerelease build.

## 2022.12.11 (1 December 2022) PreRelease

Notable changes:

-   Bug fix: google.cloud namespace package imports fail as of 1.1.282 [pyright#4255](https://github.com/microsoft/pyright/issues/4255)
-   Bug fix: Option to set python.analysis.packageIndexDepths depth globally [pylance-release#3678](https://github.com/microsoft/pylance-release/issues/3678)

## 2022.11.41 (30 November 2022) PreRelease

Notable changes:

-   Enhancement: Dict Key Literal Autocompletion does not work with Attributes [pylance-release#3687](https://github.com/microsoft/pylance-release/issues/3687)
-   Bug fix: Auto-indent fails to break out of nested context [pylance-release#3686](https://github.com/microsoft/pylance-release/issues/3686)
-   Bug fix: Incorrectly Flagged child dataclass "Fields without default values cannot appear after fields with default values" [pylance-release#3676](https://github.com/microsoft/pylance-release/issues/3676)
-   Enhancement: Feature Request: Auto import should suggest all symbols in your project [pylance-release#3670](https://github.com/microsoft/pylance-release/issues/3670)
-   Bug fix: Semantic highlighting broken [pylance-release#3667](https://github.com/microsoft/pylance-release/issues/3667)
-   Enhancement: Flag indentation error without invalidating rest of file [pylance-release#3656](https://github.com/microsoft/pylance-release/issues/3656)
-   Bug fix: `TypeAlias` forward reference results in `Unknown` [pylance-release#3654](https://github.com/microsoft/pylance-release/issues/3654)
-   Bug fix: Linting disappeares when using multiple folders in workspace [pylance-release#3652](https://github.com/microsoft/pylance-release/issues/3652)
-   Bug fix: Massive performance issues for all Pylance features in some projects [pylance-release#3632](https://github.com/microsoft/pylance-release/issues/3632)
-   Enhancement: Inappropriate type error with docstrings [pylance-release#3612](https://github.com/microsoft/pylance-release/issues/3612)
-   Bug fix: How to prevent autocomplete of type hints [pylance-release#3599](https://github.com/microsoft/pylance-release/issues/3599)
-   Bug fix: RPyC Python module description looks strange [pylance-release#3549](https://github.com/microsoft/pylance-release/issues/3549)
-   Bug fix: `Add "# type: ignore" to suppress warning` places comment in wrong place [pylance-release#3544](https://github.com/microsoft/pylance-release/issues/3544)
-   Bug fix: Bug template url gives 404 message [pylance-release#3497](https://github.com/microsoft/pylance-release/issues/3497)
-   Bug fix: Bug on Pylance 2022.9.40 (released Sept 28, 2022) [pylance-release#3401](https://github.com/microsoft/pylance-release/issues/3401)
-   Enhancement: Emit warning for unmatched `#region`/`#endregion` [pylance-release#3308](https://github.com/microsoft/pylance-release/issues/3308)
-   Bug fix: lsp notebooks and jupyter.runStartupCommands [pylance-release#3219](https://github.com/microsoft/pylance-release/issues/3219)

## 2022.11.40 (30 November 2022) Release

-   Release version that rolls up changes from the [2022.11.32](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20221132-16-november-2022-prerelease) prerelease build.

## 2022.11.32 (16 November 2022) PreRelease

Notable changes:

-   Bug fix: Don't treat empty open file as closed file.

## 2022.11.31 (16 November 2022) PreRelease

Notable changes:

-   Enhancement: Support for hint in inline `if` statement [pylance-release#3635](https://github.com/microsoft/pylance-release/issues/3635)
-   Bug fix: Update Pylance details displayed in VS Code [pylance-release#3626](https://github.com/microsoft/pylance-release/issues/3626)
-   Bug fix: Ensure folded function names are visible in Visual Studio [pylance-release#3580](https://github.com/microsoft/pylance-release/issues/3580)
-   Bug fix: Last expression in notebook cell should not be marked as unused [pylance-release#3282](https://github.com/microsoft/pylance-release/issues/3282)
-   Bug fix: Second declarations of from imports are marked as not defined [pylance-release#3218](https://github.com/microsoft/pylance-release/issues/3218)
-   Bug fix: Fix all can be customized and support pyright ignore on unused code [pylance-release#3144](https://github.com/microsoft/pylance-release/issues/3144)

Pylance's copy of Pyright has been updated from 1.1.279 to 1.1.280.

-   See Pyright's release notes for details: [1.1.280](https://github.com/microsoft/pyright/releases/tag/1.1.280).

## 2022.11.30 (16 November 2022) Release

-   Release version that rolls up changes from the [2022.11.21](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20221121-9-november-2022-prerelease) prerelease build.

## 2022.11.21 (9 November 2022) PreRelease

Notable changes:

-   Bug fix: Fix Diagnostic links to jump straight into Pyright's documentation [pylance-release#3589](https://github.com/microsoft/pylance-release/issues/3589)
-   Bug fix: Parameters for a TypedDict don't show on hover [pylance-release#3569](https://github.com/microsoft/pylance-release/issues/3569)
-   Bug fix: Diagnostics in a notebook are not removed when changing language [pylance-release#3555](https://github.com/microsoft/pylance-release/issues/3555)
-   Bug fix: Parmeter hints not working with a child class attribute [pylance-release#3512](https://github.com/microsoft/pylance-release/issues/3512)
-   Bug fix: Rename fails in untitled notebook or untitled python file [pylance-release#3276](https://github.com/microsoft/pylance-release/issues/3276)
-   Bug fix: UNC paths are not parsed correctly [pylance-release#2891](https://github.com/microsoft/pylance-release/issues/2891)

Pylance's copy of Pyright has been updated from 1.1.278 to 1.1.279.

-   See Pyright's release notes for details: [1.1.279](https://github.com/microsoft/pyright/releases/tag/1.1.279).

## 2022.11.20 (9 November 2022) Release

-   Release version that rolls up changes from the [2022.11.11](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20221111-2-november-2022-prerelease) prerelease build.

## 2022.11.11 (2 November 2022) PreRelease

Notable changes:

-   Bug fix: fix django CharField signature mismatch base class Field's init vs CharField's new function [pylance-release#3431](https://github.com/microsoft/pylance-release/issues/3431)
-   Bug fix: Fix parens for extract [pylance-release#1768](https://github.com/microsoft/pylance-release/issues/1768)
-   Bug fix: Fix type alias doc strings [pylance-release#3402](https://github.com/microsoft/pylance-release/issues/3402)
-   Bug fix: Fix crash when indexing is enabled. [pylance-release#3510](https://github.com/microsoft/pylance-release/issues/3510)

Pylance's copy of Pyright has been updated from 1.1.277 to 1.1.278.

-   See Pyright's release notes for details: [1.1.278](https://github.com/microsoft/pyright/releases/tag/1.1.278).

## 2022.11.10 (1 November 2022) Release

-   Release version that rolls up changes from the [2022.10.41](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20221041-26-october-2022-prerelease) prerelease build.

## 2022.10.41 (26 October 2022) PreRelease

Notable changes:

-   Bug Fix: Fixed source mapper perf issue. ([pylance-release#3513](https://github.com/microsoft/pylance-release/issues/3513))
-   Bug Fix: Fixed crash on notebook cell reordering. ([pylance-release#3433](https://github.com/microsoft/pylance-release/issues/3433))
-   Enhancement: Changed auto import default to off. ([pylance-release#3467](https://github.com/microsoft/pylance-release/issues/3467))
-   Enhancement: Updated pandas stubs.
-   Enhancement: Updated typeshed.

Pylance's copy of Pyright has been updated from 1.1.276 to 1.1.277.

-   See Pyright's release notes for details: [1.1.277](https://github.com/microsoft/pyright/releases/tag/1.1.277).

## 2022.10.40 (26 October 2022) Release

-   Release version that rolls up changes from the [2022.10.31](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20221021-19-october-2022-prerelease) prerelease build.

## 2022.10.31 (19 October 2022) PreRelease

Notable changes:

-   Bug Fix: Fixed a crash due to notebook cell reordering. ([pylance-release#3469](https://github.com/microsoft/pylance-release/issues/3469))
-   Bug Fix: Don't disable type checking mode for notebooks that don't exist on disk. ([pylance-release#3412](https://github.com/microsoft/pylance-release/issues/3412))
-   Enhancement: Improved smart selection behavior to include argument lists. ([pylance-release#3301](https://github.com/microsoft/pylance-release/issues/3301))
-   Enhancement: Improved doc string formatter to handle cv2 style doc string better. ([pylance-release#2945](https://github.com/microsoft/pylance-release/issues/2945))
-   Enhancement: Updated pandas stubs

Pylance's copy of Pyright has been updated from 1.1.275 to 1.1.276.

-   See Pyright's release notes for details: [1.1.276](https://github.com/microsoft/pyright/releases/tag/1.1.276).

## 2022.10.30 (19 October 2022) Release

-   Release version that rolls up changes from the [2022.10.21](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20221021-12-october-2022-prerelease) prerelease build.

## 2022.10.21 (12 October 2022) PreRelease

Notable changes:

-   Bug Fix: Fixed a crash due to LSP type mismatch. ([pylance-release#3453](https://github.com/microsoft/pylance-release/issues/3453))
-   Bug Fix: Fixed behavior of `__init__` parameter synthesis when `dataclass_transform` is applied to a base class. ([pylance-release#3304](https://github.com/microsoft/pylance-release/issues/3304))
-   Enhancement: Improved `go to definition` behavior when multiple `pyi` are used for 1 `py` file. ([pylance-release#3227](https://github.com/microsoft/pylance-release/issues/3227))
-   Enhancement: Updated pandas stubs
-   Enhancement: Updated matplotlib stubs
-   Enhancement: New setting `python.analysis.packageIndexDepths` is added. User can use the setting to control indexing behavior.

Pylance's copy of Pyright has been updated from 1.1.274 to 1.1.275.

-   See Pyright's release notes for details: [1.1.275](https://github.com/microsoft/pyright/releases/tag/1.1.275).

## 2022.10.20 (12 October 2022) Release

-   Release version that rolls up changes from the [2022.10.11](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#20221011-5-october-2022-prerelease) prerelease build.

## 2022.10.11 (5 October 2022) PreRelease

Notable changes:

-   Enhancement: Handles cache better with multi root workspaces. ([pylance-release#3408](https://github.com/microsoft/pylance-release/issues/3408))
-   Bug Fix: Properly propagates future imports between notebook cells. ([pylance-release#3376](https://github.com/microsoft/pylance-release/issues/3376))
-   Enhancement: Improved parse tree recovery for missing statements. ([pylance-release#3319](https://github.com/microsoft/pylance-release/issues/3319))
-   Enhancement: Updated pandas stubs

Pylance's copy of Pyright has been updated from 1.1.273 to 1.1.274.

-   See Pyright's release notes for details: [1.1.274](https://github.com/microsoft/pyright/releases/tag/1.1.274).

## 2022.10.10 (5 October 2022) Release

-   Release version that rolls up changes from the [2022.9.41](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2022941-28-september-2022-prerelease) prerelease build.

## 2022.9.41 (28 September 2022) PreRelease

Notable changes:

-   Enhancement: Added UX to control typeCheckingMode within language status button on status bar.
-   Bug Fix: The inferred argument type is confusing in subclass of logging.FileHandler ([pylance-release#3381](https://github.com/microsoft/pylance-release/issues/3381))

Pylance's copy of Pyright has been updated from 1.1.272 to 1.1.273.

-   See Pyright's release notes for details: [1.1.273](https://github.com/microsoft/pyright/releases/tag/1.1.273).

## 2022.9.40 (26 September 2022) Release

-   Release version that rolls up changes from the [2022.9.31](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2022931-21-september-2022-prerelease) prerelease build.

## 2022.9.31 (21 September 2022) PreRelease

Notable changes:

-   Enhancement: Don't show diagnostics within IPython cell magics ([pylance-release#3327](https://github.com/microsoft/pylance-release/issues/3327))
-   Enhancement: Extended support for method override completions that use member access expression forms in a parameter's default value expression ([pylance-release#3374](https://github.com/microsoft/pylance-release/issues/3374))
-   Enhancement: Updated pandas stubs
-   Bug Fix: Default includes and excludes weren't being used if a `pyproject.toml` file was present ([pylance-release#3348](https://github.com/microsoft/pylance-release/issues/3348))
-   Bug Fix: Replaced django-stubs with a more pyright friendly version from ([sbdchd/django-types](https://github.com/sbdchd/django-types)) ([pylance-release#3359](https://github.com/microsoft/pylance-release/issues/3359))
-   Bug Fix: Inlay hint of bigInt incorrectly displaying int ([pylance-release#3355](https://github.com/microsoft/pylance-release/issues/3355))
-   Bug Fix: Display InlayHints only on variables that haven't already been annotated ([pylance-release#3325](https://github.com/microsoft/pylance-release/issues/3325))

Pylance's copy of Pyright has been updated from 1.1.271 to 1.1.272.

-   See Pyright's release notes for details: [1.1.272](https://github.com/microsoft/pyright/releases/tag/1.1.272).

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: False negative for calling positional-only argument by name

## 2022.9.30 (21 September 2022) Release

-   Release version that rolls up changes from the [2022.9.21](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2022921-14-september-2022-prerelease) prerelease build.

## 2022.9.21 (14 September 2022) PreRelease

Notable changes:

-   Bug Fix: Using `Concatenate` and `ParamSpec` leads to skipped parameter in signature help ([pylance-release#3275](https://github.com/microsoft/pylance-release/issues/3275))
-   Bug Fix: Unexpected `reportMissingImports` in notebook for local package ([pylance-release#3208](https://github.com/microsoft/pylance-release/issues/3208))
-   Experiment: New auto-indent approach using `formatOnType`. We'll be enabling this for a percentage of prerelease users in the near future ([pylance-release#1613](https://github.com/microsoft/pylance-release/issues/1613))

Pylance's copy of Pyright has been updated from 1.1.270 to 1.1.271.

-   See Pyright's release notes for details: [1.1.271](https://github.com/microsoft/pyright/releases/tag/1.1.271).

## 2022.9.20 (14 September 2022) Release

-   Release version that rolls up changes from the [2022.9.11](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2022911-7-september-2022-prerelease) prerelease build.

## 2022.9.11 (7 September 2022) PreRelease

Notable changes:

-   Enhancement: Include, exclude, and ignore paths can now be provided via settings in VS Code: `python.analysis.include`, `python.analysis.exclude`, `python.analysis.ignore` ([pylance-release#3261](https://github.com/microsoft/pylance-release/issues/3261), [pylance-release#3266](https://github.com/microsoft/pylance-release/issues/3266))
-   Enhancement: Show names of empty modules in auto completion list ([pylance-release#3293](https://github.com/microsoft/pylance-release/issues/3293), [pylance-release#3289](https://github.com/microsoft/pylance-release/issues/3289))
-   Enhancement: Updated bundled typeshed and pandas stubs
-   Bug Fix: "Remove all unused imports" code action now only removes top level imports and "Remove unused import" code action now removes leading whitespace ([pylance-release#3181](https://github.com/microsoft/pylance-release/issues/3181))
-   Bug Fix: Don't convert imports to relative format in user files that are within `extraPaths` ([pylance-release#3194](https://github.com/microsoft/pylance-release/issues/3194))
-   Bug Fix: Fixed availability of refactoring commands ([pylance-release#3246](https://github.com/microsoft/pylance-release/issues/3246))
-   Bug Fix: Fixed ignoring of IPython magics that appear after a dedent ([pylance-release#3251](https://github.com/microsoft/pylance-release/issues/3251))
-   Bug Fix: Fixed importing of `style` and `Axes` in matplotlib stubs ([pylance-release#3273](https://github.com/microsoft/pylance-release/issues/3273))
-   Bug Fix: Logging of file system exceptions was excessively verbose ([pylance-release#3291](https://github.com/microsoft/pylance-release/issues/3291))

Pylance's copy of Pyright has been updated from 1.1.269 to 1.1.270.

-   See Pyright's release notes for details: [1.1.270](https://github.com/microsoft/pyright/releases/tag/1.1.270).

## 2022.9.10 (7 September 2022) Release

-   Release version that rolls up changes from the [2022.8.51](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2022851-31-august-2022-prerelease) prerelease build.

## 2022.8.51 (31 August 2022) PreRelease

Notable changes:

-   Enhancement: Updated bundled pandas stubs.
-   Bug Fix: Pylance erroneously marks async in async for as invalid in Jupyter notebook ([pylance-release#3205](https://github.com/microsoft/pylance-release/issues/3205))
-   Bug Fix: Ignoring \*.ipynb files does not work ([pylance-release#2135](https://github.com/microsoft/pylance-release/issues/2135))
-   Bug Fix: Pylance experiment doesn't provide semantic colorization without scrolling [pylance-release#2837](https://github.com/microsoft/pylance-release/issues/2837), [pylance-release#2897](https://github.com/microsoft/pylance-release/issues/2897).

Pylance's copy of Pyright has been updated from 1.1.268 to 1.1.269.

-   See Pyright's release notes for details: [1.1.269](https://github.com/microsoft/pyright/releases/tag/1.1.269).

## 2022.8.50 (31 August 2022) Release

-   Release version that rolls up changes from the [2022.8.41](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2022841-24-august-2022-prerelease) prerelease build.

## 2022.8.41 (24 August 2022) PreRelease

Notable changes:

-   Enhancement: Updated matplotlib type stubs
-   Bug Fix: Mismatch between `__init__` arg name and matching attribute results in InternalError in 3.10 pattern matching ([pylance-release#3197](https://github.com/microsoft/pylance-release/issues/3197))
-   Bug Fix: Code folding issue with imports ([pylance-release#3159](https://github.com/microsoft/pylance-release/issues/3159))
-   Bug Fix: No folding of parenth_form expressions without commas [pylance-release#3085](https://github.com/microsoft/pylance-release/issues/3085)

Pylance's copy of Pyright has been updated to 1.1.268.

-   See Pyright's release notes for details: [1.1.268](https://github.com/microsoft/pyright/releases/tag/1.1.268).

## 2022.8.40 (24 August 2022) Release

-   Release version that rolls up changes from the [2022.8.31](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2022831-17-august-2022-prerelease) prerelease build.

## 2022.8.31 (17 August 2022) PreRelease

Notable changes:

-   Bug Fix: Importing .py file in same directory as notebook ([pylance-release#3017](https://github.com/microsoft/pylance-release/issues/3017))
-   Bug Fix: Fixed bug in parser that resulted in crash when a soft keyword was used as a class pattern keyword argument name [pylance-release#3197](https://github.com/microsoft/pylance-release/issues/3197).

Pylance's copy of Pyright has been updated to 1.1.267.

-   See Pyright's release notes for details: [1.1.267](https://github.com/microsoft/pyright/releases/tag/1.1.267).

## 2022.8.30 (17 August 2022) Release

-   Release version that rolls up changes from the [2022.8.21](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2022821-10-august-2022-prerelease) prerelease build.

## 2022.8.21 (10 August 2022) PreRelease

Notable changes:

-   Bug Fix: Symbol renaming in Jupyter notebooks only works in a single cell ([pylance-release#3061](https://github.com/microsoft/pylance-release/issues/3061))

Pylance's copy of Pyright has been updated to 1.1.266.

-   See Pyright's release notes for details: [1.1.266](https://github.com/microsoft/pyright/releases/tag/1.1.266).

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: Fixed bug that caused error to be suppressed when calling `assert_never` with bad arguments (incorrect number, etc).
    -   Enhancement: Added support for dictionary expansion of a TypedDict within a dictionary literal expression.

## 2022.8.20 (10 August 2022) Release

-   Release version that rolls up changes from the [2022.8.11](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2022811-3-august-2022) to the [2022.8.12](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2022812-8-august-2022) prerelease build.

## 2022.8.12 (8 August 2022)

Notable changes:

-   Bug Fix: Improved doc string support on function/callable assigned to a variable.
    ([pylance-release#3135](https://github.com/microsoft/pylance-release/issues/3135))
-   Bug Fix: Fixed crash on untitled.ipynb file.
    ([pylance-release#3126](https://github.com/microsoft/pylance-release/issues/3126))
-   Bug Fix: Fixed side by side file import bug on notebook.
    ([pylance-release#3017](https://github.com/microsoft/pylance-release/issues/3017))
-   Enhancement: Updated bundled typeshed.

Pylance's copy of Pyright has been updated from 1.1.265 to 1.1.266.

-   See Pyright's release notes for details: [1.1.266](https://github.com/microsoft/pyright/releases/tag/1.1.266).

## 2022.8.11 (3 August 2022)

Notable changes:

-   Enhancement: Auto/add imports now supports new import format options (relative, absolute)
-   Bug Fix: Remove double click to insert type hint on TypeVars, ParamSpec and typeAlias assigments

Pylance's copy of Pyright has been updated from 1.1.264 to 1.1.265.

-   See Pyright's release notes for details: [1.1.265](https://github.com/microsoft/pyright/releases/tag/1.1.265).

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: Fixed a bug that caused incorrect type evaluation because of stale module paths that are cached for specific source files. Module paths are dependent on the list of configured import resolution paths, so when the import resolution paths change, we may need to recompute the module path for a source file.
    -   Bug Fix: Fixed a bug that caused a false positive error when using a list comprehension within a method that is overloaded to accept either a `LiteralString` or a `str`. The incorrect overload was chosen in some cases, picking the `LiteralString` variant rather than the `str` variant even though `LiteralString` variant generated type errors.

## 2022.8.10 (3 August 2022)

-   Release version that rolls up changes from the [2022.7.41](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2022741-20-july-2022) to the [2022.7.44](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2022744-31-july-2022) prerelease build.

## 2022.7.44 (31 July 2022)

Notable changes:

-   Bug Fix: Removed `auto` option from import format.

## 2022.7.43 (28 July 2022)

Notable changes:

-   Bug Fix: Fixed the handling of library module under workspace root in toggle import format.

## 2022.7.42 (27 July 2022)

Notable changes:

-   Bug Fix: Improved inlay type hints code gen on double click.
    ([pylance-release#3095](https://github.com/microsoft/pylance-release/issues/3095))
-   Bug Fix: Provided name for all source code actions.
    ([pylance-release#3091](https://github.com/microsoft/pylance-release/issues/3091))
-   Bug Fix: Improved magic command handling in interactive window.
    ([pylance-release#2894](https://github.com/microsoft/pylance-release/issues/2894))

Pylance's copy of Pyright has been updated from 1.1.262 to 1.1.264.

-   See Pyright's release notes for details: [1.1.263](https://github.com/microsoft/pyright/releases/tag/1.1.263), [1.1.264](https://github.com/microsoft/pyright/releases/tag/1.1.264).

-   Issues fixed:
    -   Bug Fix: Incorrect type analysis in loop.
        ([pylance-release#3077](https://github.com/microsoft/pylance-release/issues/3077))

## 2022.7.41 (20 July 2022)

Notable changes:

-   Bug Fix: Improved virtual workspace handling.
    ([pylance-release#2978](https://github.com/microsoft/pylance-release/issues/2978))
-   Bug Fix: Improved extract method code generation around expression.
    ([pylance-release#2906](https://github.com/microsoft/pylance-release/issues/2906))
-   Enhancement: Added new capability to Inlay hint that will insert the type when double clicked.
    ([pylance-release#2970](https://github.com/microsoft/pylance-release/issues/2970))
-   Enhancement: Added new code action `remove all unused imports` that also supports `Fix all`.
-   Enhancement: Updated bundled pandas stubs.
-   Enhancement: Updated bundled typeshed.

Pylance's copy of Pyright has been updated from 1.1.260 to 1.1.262.

-   See Pyright's release notes for details: [1.1.261](https://github.com/microsoft/pyright/releases/tag/1.1.261), [1.1.262](https://github.com/microsoft/pyright/releases/tag/1.1.262).

-   Issues fixed:
    -   Performance: Improved type analysis performance.
        ([pylance-release#2881](https://github.com/microsoft/pylance-release/issues/2881))

## 2022.7.40 (20 July 2022)

-   Release version that rolls up changes from the [2022.7.31](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2022731-13-july-2022) prerelease build.

## 2022.7.31 (13 July 2022)

Notable changes:

-   Bug Fix: Installing py.typed library will disable bundled partial stubs.
-   Enhancement: Provide hidden option to disable library file watching
    ([pylance-release#3001](https://github.com/microsoft/pylance-release/issues/3001))
-   Enhancement: Support extra commit characters ("." and "(") in completion when applicable.
    ([pylance-release#2946](https://github.com/microsoft/pylance-release/issues/2946))
-   Enhancement: Updated bundled pandas stubs.
-   Enhancement: Updated typeshed stubs to the latest version, which eliminates support for Python 3.6.

Pylance's copy of Pyright has been updated from 1.1.257 to 1.1.260.

-   See Pyright's release notes for details: [1.1.258](https://github.com/microsoft/pyright/releases/tag/1.1.258), [1.1.259](https://github.com/microsoft/pyright/releases/tag/1.1.259), [1.1.260](https://github.com/microsoft/pyright/releases/tag/1.1.260).

-   Issues fixed:
    -   Bug Fix: Fixed a bug that resulted in incorrect isinstance type narrowing when one or more of the filter classes was decorated with a class decorator.
        ([pylance-release#3033](https://github.com/microsoft/pylance-release/issues/3033))
    -   Performance: Added performance optimization for a special case that can occur in code without type annotations. It affects "pseudo-generic" classes that are parameterized recursively.
        ([pylance-release#2983](https://github.com/microsoft/pylance-release/issues/2983))

## 2022.7.30 (13 July 2022)

-   Release version that rolls up changes from the [2022.7.21](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2022721-6-july-2022) prerelease build.

## 2022.7.21 (6 July 2022)

Notable changes:

-   Bug Fix: Don't report unused imports/variables in notebooks when using the LSP notebooks experiment.
    ([pylance-release#2986](https://github.com/microsoft/pylance-release/issues/2986))
-   Bug Fix: Handle signature help better on nested calls.
    ([pylance-release#1990](https://github.com/microsoft/pylance-release/issues/1990))
-   Enhancement: Improved semantic token provider performance.
-   Enhancement: Updated bundled pandas stubs.

Pylance's copy of Pyright has been updated from 1.1.256 to 1.1.257.

-   Unreleased in Pyright, but included in Pylance:
    -   Fixed a bug that resulted in incorrect type narrowing when using an `in` expression and the LHS operand is of type `type`. This situation requires some special casing.
    -   Fixed a bug in the handling of generic type aliases that are parameterized by ParamSpecs in the case where an explicit type argument is not provided. The type argument should default to `...` in this case.
    -   Fixed bug in the expression printer. It was not properly handling a minimal slice (`:`).
    -   Added optimization for slice expression evaluation. It can be skipped in cases where the we are speculatively evaluating the type.
    -   Implemented optimization for type evaluation for index expressions. In cases where there are multiple subexpressions separated by commas, we can skip the check for the `__index__` magic method.
    -   Fixed a bug that resulted in incorrect isinstance type narrowing when one or more of the filter classes was decorated with a class decorator.
    -   Added support for context managers whose **exit** method is declared to return a falsy return type other than `None`.
-   See Pyright's release notes for details: [1.1.257](https://github.com/microsoft/pyright/releases/tag/1.1.257).

-   Issues fixed:
    -   Bug Fix: Fixed a bug in type narrowing which caused pyright to report "code is unreachable"
        ([pylance-release#2992](https://github.com/microsoft/pylance-release/issues/2992))
    -   Bug Fix: Fixed a bug that caused incorrect diagnostics to be reported.
        ([pylance-release#2989](https://github.com/microsoft/pylance-release/issues/2989))
    -   Bug Fix: Don't report assert_type diagnostics when type checking mode is off.
        ([pylance-release#2982](https://github.com/microsoft/pylance-release/issues/2982))

## 2022.7.20 (6 July 2022)

-   Release version that rolls up changes from the [2022.6.31](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2022631-29-june-2022) to [2022.7.11](https://github.com/microsoft/pylance-release/blob/main/CHANGELOG.md#2022711-1-july-2022) prerelease builds.

## 2022.7.11 (1 July 2022)

Notable changes:

-   Bug Fix: Method overriding template is auto inserted before opening parentheses.
    ([pylance-release#2987](https://github.com/microsoft/pylance-release/issues/2987)))

## 2022.6.31 (29 June 2022)

Notable changes:

-   Bug Fix: Period and open paren should insert currently selected IntelliSense completion
    ([pylance-release#2946](https://github.com/microsoft/pylance-release/issues/2946))
-   Bug Fix: Pylance/pyright is not running in IPythonMode
    ([pylance-release#2963](https://github.com/microsoft/pylance-release/issues/2963))

Pylance's copy of Pyright has been updated from 1.1.255 to 1.1.256.

-   See Pyright's release notes for details: [1.1.256](https://github.com/microsoft/pyright/releases/tag/1.1.256).

## 2022.6.30 (22 June 2022)

Notable changes:

-   Enhancement: Added support for inlay hints on function return and variable declarations.
    ```json
    "python.analysis.inlayHints.variableTypes": true
    "python.analysis.inlayHints.functionReturnTypes": true
    ```
    ([pylance-release#2643](https://github.com/microsoft/pylance-release/discussions/2643))
-   Bug Fix: Error message persists for package imports
    ([pylance-release#2246](https://github.com/microsoft/pylance-release/issues/2246))
-   Bug Fix: Extension is watching files outside of the workspace
    ([pylance-release#2914](https://github.com/microsoft/pylance-release/issues/2914))

Pylance's copy of Pyright has been updated from 1.1.254 to 1.1.255.

-   See Pyright's release notes for details: [1.1.255](https://github.com/microsoft/pyright/releases/tag/1.1.255).

-   Issues fixed:
    -   Bug Fix: exported name not exposed from workspace package even though listed in `__all__`
        ([pylance-release#2150](https://github.com/microsoft/pylance-release/issues/2150))
    -   Bug Fix: Docstring missing on `@overload` methods (but not plain functions)
        ([pylance-release#2948](https://github.com/microsoft/pylance-release/issues/2948))

## 2022.6.20 (15 June 2022)

Notable changes:

-   Enhancement: Added new configuration setting called "defineConstant". It allows a configuration to specify one or more identifiers that should be assigned by pyright's binder to be constant anywhere they appear. Values can be boolean (true or false) or a string. If an identifier of this value is used within a conditional statement (like `if not DEBUG:`) it will affect pyright's reachability analysis for the guarded code blocks.
-   Enhancement: Added support for new reportTypeCommentUsage diagnostic check. It flags the usage of # type: xxx comments for functions and variables. These are still supported for backward compatibility, but they are increasingly irrelevant and will likely be deprecated in the next few years.

Pylance's copy of Pyright has been updated from 1.1.253 to 1.1.254.

-   See Pyright's release notes for details: [1.1.254](https://github.com/microsoft/pyright/releases/tag/1.1.254).

## 2022.6.10 (8 June 2022)

Notable changes:

-   Enhancment: Changed our version numbering scheme so we can support VS Code's [pre-release extensions feature](https://code.visualstudio.com/updates/v1_63#_pre-release-extensions). Stable versions going forward will be YYYY.MM.X0 and prerelease versions will be YYYY.MM.X1, where X starts at 1 each month and increments. Stable and prerelease versions released on the same day will have the same value for X.
-   Enhancement: Show module paths in auto-import list
    ([pylance-release#2885](https://github.com/microsoft/pylance-release/issues/2885))
-   Bug Fix: "request cancelled" errors when using Pylance on vscode.dev
    ([pylance-release#2743](https://github.com/microsoft/pylance-release/issues/2743))
-   Bug Fix: Fix file watcher behavior with ZIP files
    ([pylance-release#2890](https://github.com/microsoft/pylance-release/issues/2890))

Pylance's copy of Pyright has been updated from 1.1.251 to 1.1.253.

-   See Pyright's release notes for details: [1.1.252](https://github.com/microsoft/pyright/releases/tag/1.1.252), [1.1.253](https://github.com/microsoft/pyright/releases/tag/1.1.253).

-   Issues fixed:
    -   Bug Fix: Stack overflow during symbol rename
        ([pylance-release#2550](https://github.com/microsoft/pylance-release/issues/2550))

## 2022.6.0 (1 June 2022)

Pylance's copy of Pyright has been updated from 1.1.249 to 1.1.251.

-   See Pyright's release notes for details: [1.1.249](https://github.com/microsoft/pyright/releases/tag/1.1.249), [1.1.251](https://github.com/microsoft/pyright/releases/tag/1.1.251).

-   Issues fixed:
    -   Bug Fix: Object of type "None" cannot be called
        ([pylance-release#2871](https://github.com/microsoft/pylance-release/issues/2871))
    -   Bug Fix: No keys hints for TypedDict when it is in union
        ([pylance-release#2860](https://github.com/microsoft/pylance-release/issues/2860))
    -   Bug Fix: Bool are int
        ([pylance-release#2865](https://github.com/microsoft/pylance-release/issues/2865))

## 2022.5.3 (25 May 2022)

Notable changes:

-   Experimental Feature: Treat each Jupyter notebook cell as a separate document rather than concatenating the cells together into a single document. Has the potential to fix a lot of Pylance notebook behaviors. Can be enabled by setting `"python.pylanceLspNotebooksEnabled": true`.
-   Bug Fix: Multiline tuples don't fold
    ([pylance-release#2779](https://github.com/microsoft/pylance-release/issues/2779))
-   Bug Fix: Report Issue command fails if Pylance has not been activated
    ([pylance-release#2791](https://github.com/microsoft/pylance-release/issues/2791))

Pylance's copy of Pyright has been updated from 1.1.247 to 1.1.249.

-   See Pyright's release notes for details: [1.1.248](https://github.com/microsoft/pyright/releases/tag/1.1.248), [1.1.249](https://github.com/microsoft/pyright/releases/tag/1.1.249).

-   Issues fixed:
    -   Enhancement: Improved parser recovery for member access expressions that are missing the member name
        ([pylance-release#2836](https://github.com/microsoft/pylance-release/issues/2836))
    -   Bug Fix: Incorrect type evaluation for a property access within a class when that property's getter has a generic return type
        ([pylance-release#2841](https://github.com/microsoft/pylance-release/issues/2841))

## 2022.5.2 (18 May 2022)

Notable changes:

-   Bug Fix: Jupyter notebooks hang
    ([pylance-release#2783](https://github.com/microsoft/pylance-release/issues/2783))

Pylance's copy of Pyright has been updated from 1.1.246 to 1.1.247.

-   See Pyright's release notes for details: [1.1.247](https://github.com/microsoft/pyright/releases/tag/1.1.247).

-   Issues fixed:
    -   Enhancement: Improved handling of context managers that swallow exceptions
        ([pylance-release#982](https://github.com/microsoft/pylance-release/issues/982),
        [pylance-release#2081](https://github.com/microsoft/pylance-release/issues/2081))

## 2022.5.1 (11 May 2022)

Notable changes:

-   Bug Fix: TypedDict attribute suggestions don't recognise f-string quote type
    ([pylance-release#1919](https://github.com/microsoft/pylance-release/issues/1919))
-   Bug Fix: Auto complete for attributes form CBV in Django not working
    ([pylance-release#2059](https://github.com/microsoft/pylance-release/issues/2059))
-   Bug Fix: Always require restart when installing new package and cannot find python interpreter ([pylance-release#2505](https://github.com/microsoft/pylance-release/issues/2505))

Pylance's copy of Pyright has been updated from 1.1.244 to 1.1.246.

-   See pyright's release notes for details: [1.1.246](https://github.com/microsoft/pyright/releases/tag/1.1.246), [1.1.245](https://github.com/microsoft/pyright/releases/tag/1.1.245).

-   Issues fixed:
    -   Bug Fix: Functions in class cannot be analyzed under some circumstances ([pylance-release#2745](https://github.com/microsoft/pylance-release/issues/2745))
    -   Bug Fix: False positive with type variable seemingly not being bound correctly when return type is inferred ([pylance-release#2785](https://github.com/microsoft/pylance-release/issues/2785))
    -   Bug Fix: Value dependent typing signature with self-defined generic types incorrectly handled ([pylance-release#2784](https://github.com/microsoft/pylance-release/issues/2784))
    -   Bug Fix: Type of "globals" is unknown when module named as globals ([pylance-release#2793](https://github.com/microsoft/pylance-release/issues/2793))

## 2022.5.0-pre.1 (4 May 2022)

We're only shipping to insiders this week. This release includes a change in Pyright's code flow analysis of `NoReturn` calls. When a similar change was attempted in Pylance 2022.2.1 it caused perf issues and was reverted. Pyright has improved its `NoReturn` handling and we're giving it another shot, but we're limiting the exposure to insiders users for now.

Notable changes:

-   Enhancement: Show completion suggestions for overriding inherited class variables
    ([pylance-release#2059](https://github.com/microsoft/pylance-release/issues/2059))
-   Enhancement: Updated typeshed stubs to latest.

Pylance's copy of Pyright has been updated from 1.1.240 to 1.1.244.

-   See pyright's release notes for details: [1.1.241](https://github.com/microsoft/pyright/releases/tag/1.1.241), [1.1.242](https://github.com/microsoft/pyright/releases/tag/1.1.242), [1.1.243](https://github.com/microsoft/pyright/releases/tag/1.1.243), and [1.1.244](https://github.com/microsoft/pyright/releases/tag/1.1.244).

-   Issues fixed:
    -   Bug Fix: Improved detection of NoReturn calls within code flow graph.
    -   Bug Fix: Fixed bug that led to inconsistent type evaluation results when the code flow engine determined that an expression was unreachable.
        ([pylance-release#2745](https://github.com/microsoft/pylance-release/issues/2745))
    -   Bug Fix: Fixed bug that incorrectly inferred the type for an exception group when using a Python 3.11 `except*` statement.
        ([pylance-release#2762](https://github.com/microsoft/pylance-release/issues/2762))

## 2022.4.3 (27 April 2022)

Pylance's copy of Pyright has been updated from 1.1.239 to 1.1.240.

-   Unreleased in Pyright, but included in Pylance:
    -   Fixed regression in "reportUnnecessaryComparison" diagnostic check that resulted in false positives when the LHS or RHS evaluated to `Never`.
-   See pyright's release notes for details: [1.1.240](https://github.com/microsoft/pyright/releases/tag/1.1.240)

-   Issues fixed:
    -   Bug Fix: Fixed bug on tuple assignment inside of loop. ([pylance-release#2731](https://github.com/microsoft/pylance-release/issues/2731))

## 2022.4.2 (20 April 2022)

Notable changes:

-   Enhancement: Improvement on supporting doc comment for builtin modules.
    ([pylance-release#1938](https://github.com/microsoft/pylance-release/issues/1938))
-   Enhancement: Updated typeshed stubs to latest.

In addition, Pylance's copy of Pyright has been updated from 1.1.237 to 1.1.239.

-   See pyright's release notes for details: [1.1.238](https://github.com/microsoft/pyright/releases/tag/1.1.238) and [1.1.239](https://github.com/microsoft/pyright/releases/tag/1.1.239)

-   Issues fixed:
    -   Bug Fix: Fixed bug that resulted in an infinite loop when a reference to a generic function was passed to itself as an argument. ([pylance-release#2686](https://github.com/microsoft/pylance-release/issues/2686))

## 2022.4.1 (13 April 2022)

Notable changes:

-   Enhancement: Renaming a method will rename all overridden methods as well.
    ([pylance-release#813](https://github.com/microsoft/pylance-release/issues/813))
-   Bug Fix: pandas stub updated to remove Unknown type argument.
    ([pylance-release#1968](https://github.com/microsoft/pylance-release/issues/1968))
-   Enhancement: Named argument in call context will show up at the top in completion.

In addition, Pylance's copy of Pyright has been updated from 1.1.235 to 1.1.237.

-   Unreleased in Pyright, but included in Pylance:
    -   Fixed a bug that generated a false positive when importing from a "py.typed" namespace package. This change also loosens the requirements for a "py.typed" file to be in each of the submodules within a namespace package; a single "py.typed" within the top-level namespace directory is also now supported.
    -   Improved error message for protocol mismatch due to invariance of mutable attributes.
-   See pyright's release notes for details: [1.1.236](https://github.com/microsoft/pyright/releases/tag/1.1.236) and [1.1.237](https://github.com/microsoft/pyright/releases/tag/1.1.237)

-   Issues fixed:
    -   Enhancement: Better handling on namespace packages ([pylance-release#2562](https://github.com/microsoft/pylance-release/issues/2562))
    -   Bug Fix: Incorrect type inference in loops ([pylance-release#2552](https://github.com/microsoft/pylance-release/issues/2552))
    -   Bug Fix: False positive reportOptionalMemberAccess ([pylance-release#2549](https://github.com/microsoft/pylance-release/issues/2549))
    -   Performance: Improvement on analyzing "while True" loop ([pylance-release#2540](https://github.com/microsoft/pylance-release/issues/2540))

## 2022.4.0 (6 April 2022)

Notable changes:

-   Enhancement: Improved completions for native modules with matching stub files.
    ([pylance-release#2533](https://github.com/microsoft/pylance-release/issues/2533))
-   Bug Fix: Fixed docstring lookup for typeshed stubbed packages.
    ([pylance-release#2472](https://github.com/microsoft/pylance-release/issues/2472))
-   Enhancement: The stubs for pandas and django have been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.234 to 1.1.235 including the following changes:

-   [1.1.235](https://github.com/microsoft/pyright/releases/tag/1.1.235)
    -   Performance: Fixed a performance regression that manifested when analyzing a large dictionary literal statement with a declared type.
    -   Enhancement: (Contributed by Robert Craigie) Show TypedDict key type and docstring on hover.
    -   Behavior Change: Updated logic for `dataclass_transform` to handle recent clarification in PEP 681 for cases where one or more overloads are decorated with `dataclass_transform`.
    -   Enhancement: (Contributed by Kevin Coffey) Added support for type guard based on `a.b is None` or `a.b is not None` patterns where `b` is a member variable that distinguishes two different classes.
    -   Enhancement: (Contributed by Robert Craigie) Add support for going to definition for TypedDict keys.
    -   Behavior Change: Changed hover provider to display `(property)` rather than `(method)` if the field is decorated with a descriptor object.
        ([pylance-release#2508](https://github.com/microsoft/pylance-release/issues/2508))
    -   Enhancement: Changed logic for hover and completion providers to support docstrings for general descriptors rather than just properties.
    -   Enhancement: Made synthesized `get` method in `TypedDict` classes a bit smarter. If a field is required, the default parameter's argument (or `None` if no default argument is provided) is ignored because the type will always come from the required field. If the `TypedDict` class is marked `@final`, any literal key name that is not part of the class will always return the type of the default argument (or `None` if no default argument is provided).
    -   Bug Fix: Fixed bug that could theoretically account for some of the remaining stack overflows that we're seeing in the pylance telemetry.
    -   Bug Fix: Fixed bug in the package type verifier where it incorrectly flagged an assignment to a descriptor member within a child class as an ambiguous override of that member.
    -   Bug Fix: Changed the way pyright detects high memory usage and decides to empty its internal type cache.
    -   Performance: Added perf enhancement to improve analysis times for complex unannotated code. Lowered complexity threshold for call-site return type inference and skipped argument expression evaluation for call expression when base call expression type is unknown.
    -   Performance: More performance optimizations for complex unannotated functions. Don't evaluate argument or subscript expressions if base type of call expression or index expression is incomplete.
    -   Enhancement: Updated typeshed stubs to latest.

## 2022.3.4 (30 March 2022)

Notable changes:

-   Enhancement: Improved `Rename Symbol` to handle imports.
    ([pylance-release#1175](https://github.com/microsoft/pylance-release/issues/1175))
-   Bug Fix: Fixed conda temp.txt files causing analysis unneeded refresh.
-   Bug Fix: Ignore var decl in completions
    ([pylance-release#2189](https://github.com/microsoft/pylance-release/issues/2189))

In addition, Pylance's copy of Pyright has been updated from 1.1.232 to 1.1.234 including the following changes:

-   [1.1.234](https://github.com/microsoft/pyright/releases/tag/1.1.234)
    -   Performance: Fixed bug that resulted in long analysis times when using call-site type inference for very complex functions that have no parameter annotations.
    -   Behavior Change: Removed support for `transform_descriptor_types` parameter in `dataclass_transform`, a feature that was determined to be not necessary. Added support on normal dataclass handling for field types that are custom descriptor objects.
    -   Bug Fix: Fixed bug in logic that determines whether to empty the in-memory type cache if it has the potential to overflow the heap.
    -   Enhancement: Improved printing of string nodes in error and log messages. If the string node is long, it is truncated to 32 characters.
    -   Enhancement: Improved textual form of string literal types. If the string literal is very long (>50 characters), it is truncated.
    -   Bug Fix: Fixed recent regression that caused the "--verifytypes" feature to incorrectly report that the "self" parameter of a `@property` method as unannotated.
    -   Performance: Removed older mechanism for tracking "incomplete types" — those that have been partially evaluated within a code flow loop. The older mechanism is no longer needed. Removing this is a big performance win in some (typically more complex) pieces of code.
    -   Performance: Fixed performance issue that caused long analysis times in some complex unannotated functions when attempting to infer whether the function was a NoReturn return type.
    -   Performance: Improved performance of code flow "reachability" analysis.
    -   Enhancement: Updated typeshed stubs to the latest version.
    -   Bug Fix: Fixed false positive error in "unreachable exception" detection code when the exception was typed as `Type[Exception]`.
    -   Enhancement: Contributed by Kevin Coffey - Extended `a[I] is None` type narrowing logic to handle subtypes of Tuple including NamedTuple.
-   [1.1.233](https://github.com/microsoft/pyright/releases/tag/1.1.233)
    -   Behavior Change: When hovering over the LHS of an augmented assignment (e.g. the `a` within `a += x`), reveal the type of the symbol _after_ the operation rather than _before_.
    -   Enhancement: Updated the `reportUnusedExpression` check to also report diagnostics for a simple name expression as a standalone statement.
    -   Bug Fix (from pylance): Fixed several bugs related to "Rename Symbol" command and improved performance in some cases.
    -   Bug Fix: Fixed crashing bug due to stack overflow when traversing the code flow graph.
    -   Behavior Change: Modified algorithm for calculating the complexity of a function's code flow. If the complexity exceeds a certain threshold, pyright will not attempt to analyze the code.
    -   Bug Fix: Fixed a bug that resulted in incorrect import resolution when the import referenced an empty directory within the stubspath. It should continue searching for imports in other locations in this case.
    -   Bug Fix: Fixed regression that caused false positive error when protocol match involved a property that returned a type that was generic.
    -   Bug Fix: Fixed bug that resulted in a false negative when assigning an invariant type var was specialized with a protocol type.
    -   Bug Fix: Fixed several bugs relating to type evaluation within loops. This is a significant change to the code flow engine logic.
        ([pylance-release#2983](https://github.com/microsoft/pylance-release/issues/2983))

## 2022.3.3 (23 March 2022)

Notable changes:

-   Enhancement: Added support for `prepare rename`. This will let users know when `rename` is not allowed.
    ([pylance-release#1360](https://github.com/microsoft/pylance-release/issues/1360))
    ([pylance-release#2457](https://github.com/microsoft/pylance-release/issues/2457))
-   Enhancement: Improved `reportMissingSourceModule` to work for all different import cases.
    ([pylance-release#2158](https://github.com/microsoft/pylance-release/issues/2158))
-   Enhancement: Improved property completions.
-   Enhancement: The bundled stubs for django have been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.230 to 1.1.232 including the following changes:

-   [1.1.232](https://github.com/microsoft/pyright/releases/tag/1.1.232)
    -   Enhancement: Improved diagnostic messages for overload implementation mismatch.
    -   Bug Fix: Fixed bug that resulted in false negative when assigning one function to another and the dest contains named positional arguments that have no corresponding positional slot in the dest and the dest does not contain a \*\*kwargs.
        ([pylance-release#2497](https://github.com/microsoft/pylance-release/issues/2497))
    -   Bug Fix: Modified the special-case logic for `property` so it exposes methods and attributes provided by `object`.
    -   Bug Fix: Improved the `reportIncompatibleMethodOverride` check to report a diagnostic if the base method provides a default argument value for a parameter but the override does not.
    -   Behavior Change: Lowered cyclical code complexity threshold for code flow analysis in an attempt to reduce stack overflow crashes.
    -   Bug Fix: Fixed a false positive error relating to `__slots__` when using a descriptor object that was assigned to a class variable in a base class.
    -   Enhancement: Updated typeshed stubs to the latest version.
    -   Enhancement: Added support for new `assert_type` call, which is being added to Python 3.11 and typing_extensions.
    -   Bug Fix: Fixed false positive error that occurs when assigning a class variable with a type annotation an expression that involves the name of the class variable symbol.
    -   Bug Fix: Improved modeling of property class so its `fget`, `fset`, `fdel`, `__get__`, `__set__` and `__delete__` methods are updated properly when adding a setter or deleter.
    -   Bug Fix: Fixed bug that resulted in false positive when overriding a method with position-only parameters when the base uses the old-style mechanism and the override uses the new-style `/` separator or vice versa.
-   [1.1.231](https://github.com/microsoft/pyright/releases/tag/1.1.231)
    -   Behavior Change: Moved a couple of type-related diagnostics under the reportGeneralTypeIssues diagnostic rule rather than reporting them unconditionally.
    -   Bug Fix: Fixed false negative for the reportIncompatibleMethodOverride diagnostic check. It was not detecting the case where the base method used keyword parameters but the override method used position-only parameters.
    -   Bug Fix: Fixed bug that resulted in a false positive error when matching a module against a specialized generic protocol class.
    -   Bug Fix: Fixed a bug that resulted in misleading output when printing the type of a generic alias that includes a generic function parameterized by a ParamSpec and is later specialized.
    -   Bug Fix: Fixed bug that resulted in incorrect type evaluation when a generic type alias parameterized with a ParamSpec was specialized multiple times.
    -   Bug Fix: Fixed bug in "--verifytypes" feature. It was ignoring a missing parameter annotation for the first parameter in a non-method function.
    -   Bug Fix: Fixed a bug that resulted in a false positive error when a generic callback protocol was passed as an argument to another generic callback protocol.

## 2022.3.2 (16 March 2022)

Notable changes:

-   Enhancement: Updated Pandas stubs
-   Bug Fix: Removed duplicate SQLAlchemy stubs due to them now being in typeshed.
-   Enhancement: Allow auto import customization
    ([pylance-release#2312](https://github.com/microsoft/pylance-release/issues/2312))
-   Enhancement: Allow `Rename` on excluded files
    ([pylance-release#2468](https://github.com/microsoft/pylance-release/issues/2468))

In addition, Pylance's copy of Pyright has been updated from 1.1.228 to 1.1.230 including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Behavior Change: Moved a couple of type-related diagnostics under the reportGeneralTypeIssues diagnostic rule rather than reporting them unconditionally.
        ([pylance-release#2482](https://github.com/microsoft/pylance-release/issues/2482))
    -   Bug Fix: Fixed false negative for the reportIncompatibleMethodOverride diagnostic check. It was not detecting the case where the base method used keyword parameters but
        the override method used position-only parameters.
-   [1.1.230](https://github.com/microsoft/pyright/releases/tag/1.1.230)
    -   Bug Fix: Fixed a bug that resulted in a false positive "reportMissingParameterType" error when using an old-style double underscore parameter name to indicate position-only parameter.
    -   Bug Fix: Handled the special case where an `Any` expression is bound to a ParamSpec giving it default parameters.
    -   Bug Fix: Fixed bug that resulted in a false positive error when using a dictionary unpack operator `**` with an instance of a class that satisfied the `SupportsKeysAndGetItem` protocol but did not directly derive from `Mapping`.
    -   Enhancement: Added new diagnostic check `reportUnusedExpression` to catch bugs like `a == 4` when `a = 4` was intended.
    -   Enhancement: Added special-case logic for a Type[T] (where T is an unbound TypeVar) that is instantiated through a call to its constructor. It should evaluate to T rather than Any.
    -   Bug Fix: Fixed bug in pattern exhaustive match logic that failed to detect exhaustive match when the subject expression was a unnarrowable expression form.
        ([pylance-release#2475](https://github.com/microsoft/pylance-release/issues/2475))
    -   Bug Fix: Improved the heuristics in the alias resolution logic to prefer declarations that are in non-exception paths even if the exception path has a typed decl and the non-exception decl must be inferred.
        ([pylance-release#2476](https://github.com/microsoft/pylance-release/issues/2476))
    -   Bug Fix: Fixed two bugs that generated false positive errors when using PEP 604 union syntax in an implicit type alias. The first bug affected the case where the union started with `None`. The second affected the case where a TypeVar was included in the union.
    -   Enhancement: Updated typeshed stubs to the latest.
    -   Bug Fix: Fixed bug that resulted in false positive reportIncompatibleVariableOverride error when one base class defined a symbol as a property and another base class defined a symbol as Any.
    -   Enhancement: Added support for the use of `Concatenate` as a type argument for a generic type alias that accepts a ParamSpec.
-   [1.1.229](https://github.com/microsoft/pyright/releases/tag/1.1.229)
    -   Bug Fix: Fixed a bug that caused semantic highlighting to sometimes skip information for certain tokens involved in member access expressions.
    -   Enhancement: Added checks for incompatible variable types for same-named instance or class variables in two base classes.
    -   Enhancement: Updated typeshed stubs to the latest version.
    -   Bug Fix: Fixed a bug that led to misleading type error messages and hover text when a type with an associated generic type alias was specialized. The underlying generic type was properly specialized, but the type alias itself appeared to be unspecialized still. Since the type alias is displayed in error messages and hover text, this was confusing.
    -   Bug Fix: Fixed a bug where classes that derive from `Any` are not allowed to be assigned to a TypeVar. This resulted in a false positive error when returning `NotImplemented` in a function that is annotated to return a TypeVar.
    -   Bug Fix: Fixed a bug that resulted in a false positive error "variable not in slots" when a value was assigned to a class variable that is a descriptor.
    -   Bug Fix: Fixed a bug in the `__post_init__` validation logic that resulted in a false positive when a dataclass with an `InitVar` derives from another dataclass with an `InitVar`.
    -   Enhancement: Added support for per-line suppression of diagnostics using `# pyright: ignore` comment. This also supports rule-specific suppression using a list of diagnostic rules, as in `# pyright: ignore [reportGeneralTypeIssues]`.
    -   Bug Fix: Fixed a bug in the reportUnnecessaryComparison diagnostic rule that resulted in false negatives when one of the two operands included a `None` in the type.
    -   Bug Fix: Fixed a bug that resulted in a false positive error when testing type compatibility of an invariant type argument that consists of a union of types, some of which are subtypes of each other.

## 2022.3.1 (9 March 2022)

Notable changes:

-   Enhancement: The bundled native module stubs for sklearn, scipy, and pandas have been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.226 to 1.1.228 including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: Improved solution to stack overflow and fixed another potential theoretical source based on code review.
-   [1.1.228](https://github.com/microsoft/pyright/releases/tag/1.1.228)
    -   Bug Fix: Improved "reportUnnecessaryComparison" diagnostic check so it catches more cases.
    -   Performance: Fixed performance bug that was causing a significant slowdown when evaluating highly nested call expressions especially when there are argument errors in the innermost expressions.
        ([pylance-release#2366](https://github.com/microsoft/pylance-release/issues/2366))
    -   Enhancement: Extended support for narrowing of index expressions to include those with negative subscripts, such as `a[-1]`. This is supported for all supported type guard patterns.
    -   Bug Fix: Fixed bug that resulted in a false positive error when using `typing.Self` in an inner function defined within an outer method.
    -   Enhancement: Added negative type narrowing support for sequence patterns in match statements.
    -   Bug Fix: Fixed a bug in negative type narrowing for class patterns in match statements when the class in the class pattern is one of the designated "special built-in classes" specified in PEP 634 and a class argument is specified.
    -   Bug Fix: Fixed a bug that resulted in incorrect TypeVar resolution when the TypeVar was used in a `Type[T]` type expression, was constrained, and two of the constraints overlapped in type.
    -   Bug Fix: Fixed an edge case in the code flow engine that theoretically could result in incorrect type evaluation.
    -   Bug Fix: Fixed a bug in the code flow engine that resulted in inconsistent type evaluation depending on order of evaluation in some cases where a variable is modified in a loop.
        ([pylance-release#2324](https://github.com/microsoft/pylance-release/issues/2324))
    -   Bug Fix: Fixed bug that resulted in a stack overflow when evaluating unions with large numbers of subtypes.
-   [1.1.227](https://github.com/microsoft/pyright/releases/tag/1.1.227)
    -   Enhancement: Extended conditional types to function and constructor calls where one or more arguments is a conditional type.
    -   Bug Fix: Fixed a bug that resulted in incorrect type inference when assigning `()` to a variable with an explicit type declaration of `tuple[()]`.
    -   Bug Fix: Fixed bug that results in incorrect type evaluation when an `if` statement is not paired with an `else` and the condition expression uses a `not` paired with an `and` or `or`.
    -   Bug Fix: Fixed bug that caused a class that derives from `NamedTuple` to not conform to the `Hashable` protocol.
    -   Behavior Change: Changed override detection to always use an overload implementation if present.
        ([pylance-release#2430](https://github.com/microsoft/pylance-release/issues/2430))
    -   Behavior Change: Fixed bug that caused symbols in unreachable code to be ignored in "Rename Symbol" and "Find all References" operations.
        ([pylance-release#2431](https://github.com/microsoft/pylance-release/issues/2431))
    -   Bug Fix: Fixed bug that resulted in a false positive when `cls` was used as an argument to a dynamic `type` creation call.
    -   Enhancement: Improved error message for overload that doesn't match its implementation.
    -   Bug Fix: Added code to avoid an attempt to analyze a function if its code flow complexity is too high. This reduces the likelihood of a stack overflow within the type evaluator. If a function or module is too complex, a diagnostic is now emitted to tell the developer that full analysis is suspended for that execution scope.
    -   Bug Fix: Improved reportIncompatibleMethodOverride diagnostic check, including fixes for a few false positives and false negatives and improvements to diagnostic messages.

## 2022.3.0 (3 March 2022)

Notable changes:

-   Enhancement: Django and SQLAlchemy stubs have been updated to their latest versions.
-   Enhancement: Pandas stubs updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.225 to 1.1.226 including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: Extended conditional types to function and constructor calls where one or more arguments is a conditional type.
-   [1.1.226](https://github.com/microsoft/pyright/releases/tag/1.1.226)
    -   Bug Fix: Improved parser to detect extremely deep chains of call expressions that can crash the type evaluator.
    -   Bug Fix: Fixed bug that resulted in false positive error when detecting overlapping method overloads when the overloads use a class-scoped TypeVar.
    -   Bug Fix: Fixed a bug that resulted in a false positive error when validating type compatibility between two functions with nested Concatenate and ParamSpec usage.
    -   Bug Fix: Fixed a bug in the code flow graph relating to "with" statements that are nested within a "try" statement when the context manager does not swallow exceptions but instead forwards them to the outer except clause.
    -   Enhancement: Improved error message for binary and unary operations when an expected type (bidirectional inference) is present.
    -   Bug Fix: Fixed a performance issue that caused long analysis times for some code flow graphs that involve deeply nested loops and many interdependent variables.
    -   Bug Fix: Fixed a bug that resulted in a false positive error when assigning a value of type `type | Any` to type `type[T]`.
    -   Bug Fix: Fixed a bug that resulted in false positive errors when assigning a value to class variable that contains a generic descriptor object.
    -   Enhancement: Improved the error message for a call expression where a keyword argument and a positional argument target the same parameter.
    -   Enhancement: Updated typeshed stubs to the latest version.
-   [1.1.225](https://github.com/microsoft/pyright/releases/tag/1.1.225)
    -   Bug Fix: Added missing checks for an attempt to modify a variable that has been marked "Final" using a means other than a simple assignment statement. This includes augmented assignments, tuple assignments, for statements, with statements, assignment expressions, etc.
    -   Behavior Change: Modified parameter type inference logic to not infer a parameter's type based on the default argument value if the value is a tuple, list, set or dict.
    -   Enhancement: Improved type evaluation of `type(x)` to handle the case where `x` is a union type.
    -   Bug Fix: Fixed bug that caused false negative when a class defined a `__getattr__` method but no `__getitem__` method and a subscript expression was used with a class instance.
    -   Bug Fix: Fixed a bug in the logic that determines whether a class that derives from a protocol implements all of the functions and variables within that protocol. It wasn't considering mix-in classes.
    -   Bug Fix: Fixed regression in "finally" type analysis that allowed type violation errors to go unreported in finally clauses.
    -   Behavior Change: Changed the behavior of type evaluator when it encounters an unannotated symbol within a "py.typed" source file. Previously, it did not fall back on type inference and instead evaluated the type as "Unknown". It now falls back on type inference but internally marks the type as "ambiguous". Added logic to detect "likely ambiguous inferences".
    -   Behavior Change: Updated package type verifier to differentiate between "unknown" and "ambiguous" types.
    -   Bug Fix: Fixed a bug in type evaluator that resulted in a crash when a function signature contains a "\*\*" parameter with no name.
    -   Bug Fix: Fixed a bug that resulted in a crash due to infinite recursion.
    -   Bug Fix: Enhanced parser to detect extremely deep parse trees created from index or member access expressions. The parser now emits an error rather than allowing the type evaluator to crash (with a stack overflow) in such situations.
    -   Enhancement: Updated typeshed stubs to the latest.

## 2022.2.4 (23 February 2022)

Notable changes:

-   Enhancement: Several improvements in Pandas stubs (Thanks to @Dr-Irv and @sjdemartini)
-   Behavior Change: Changed `strictParameterNoneValue` to default to true rather than false. This reflects the updated guidance in PEP 484, which indicates that type checkers should not assume that a default argument of `None` should imply an `Optional` type.

In addition, Pylance's copy of Pyright has been updated from 1.1.222 to 1.1.224 including the following changes:

-   [1.1.224](https://github.com/microsoft/pyright/releases/tag/1.1.224)
    -   Bug Fix: Improved NoReturn return call inference when the callable type evaluates to a partial Any or Unknown.
    -   Bug Fix: Improved heuristics related to NoReturn detection when dealing with certain libraries that attempt to import another package within a `try` statement but provide a "dummy implementation" in an `except` clause. In this situation, we should use the declaration within the `try` block and ignore the one in the `except` clause. ([pylance-release#2402](https://github.com/microsoft/pylance-release/issues/2402))
    -   Bug Fix: Fixed buggy assert in type evaluator that resulted in some crashes.
    -   Behavior Change: Changed `strictParameterNoneValue` to default to true rather than false. This reflects the updated guidance in PEP 484, which indicates that type checkers should not assume that a default argument of `None` should imply an `Optional` type.
    -   Enhancement: If CLI version of pyright is run without providing arguments to certain commands, a failure is detected and reported. Thanks to Martin Fischer for this contribution.
    -   Bug Fix: Fixed performance regression due to a recent change in the code flow engine when attempting to evaluate whether call is a NoReturn.
    -   Enhancement: Added support for parameter type inference based on annotated base class method signatures and on default argument expressions.
    -   Bug Fix: Fixed recent regression that caused unnecessary reanalysis when closing a file when using pyright as an LSP. The regression also sometimes resulted in unexpected errors from reanalyzed files including diagnostics about unaccessed variables.
-   [1.1.223](https://github.com/microsoft/pyright/releases/tag/1.1.223)
    -   Bug Fix: Fixed a bug in negative type narrowing logic for value patterns in `match` statement.
    -   Behavior Change: Removed provisional support for PEP 677 (Alternate Call Syntax) because the proposal was rejected by the Python steering council.
    -   Bug Fix: Fixed a bug that led to incorrect type evaluation in the "implied else" code flow path.
    -   Bug Fix: Improved support for functions or methods that return a context manager that swallow exceptions, such as `pytest.raises`.
    -   Behavior Change: Modified `reportIncompatibleVariableOverride` check to permit a ClassVar in the base class to be overridden by a compatible class declaration in a child class.
    -   Bug Fix: Fixed a bug in the type evaluator that led to false positives when assigning a function type to another function type and the source contained parameters annotated with literal types and the dest contained corresponding parameters annotated with TypeVars.
    -   Bug Fix: Fixed bug in the handling of wildcard imports. If the target module doesn't contain a dunder all definition, the resulting imported symbol list should exclude names that start with a single underscore.
    -   Bug Fix: Fixed bug that resulted in a false positive error when using a TypeVarTuple in a `classmethod`.
    -   Behavior Change: Changed heap overflow detection to use a dynamic value based on available memory rather than a hard-coded size. For the pyright VS Code extension, changed the default "max heap size" from 1.7GB to 3.0GB on 32-bit systems. On 64-bit systems, this value appears to already be a higher value (4GB), and it doesn't appear to get overridden by the lower number.

## 2022.2.3 (16 February 2022)

Notable changes:

-   Bug Fix: Pandas stubs fixes.

In addition, Pylance's copy of Pyright has been updated from 1.1.220 to 1.1.222 including the following changes:

-   [1.1.222](https://github.com/microsoft/pyright/releases/tag/1.1.222)
    -   Bug Fix: Fixed bug that resulted in false positive when using a recursive type alias with a generic dataclass constructor.
    -   Bug Fix: Fixed a bug that results in a false negative when handling a function parameter that is annotated with a function-scoped TypeVar and has a default argument value.
    -   Behavior Change: Changed the handling of `reveal_type` so it participates in bidirectional type inference when used within a larger expression.
    -   Bug Fix: Fixed long-standing bug in logic that applies config file settings for diagnostic rule severity levels. The bug caused all settings overrides to be ignored if a pyrightconfig.json file was present. The new logic applies the default values, then the settings overrides, then the pyrightconfig.json file values. The change also simplifies the code, which was getting a bit unmaintainable.
    -   Enhancement: Extended `dataclass_transform` to support `transform_descriptor_types` parameter.
    -   Enhancement: Added support for an unpacked TypedDict as a type annotation for a `*kwargs` parameter.
    -   Bug Fix: Improved the `type(x) is y` type narrowing logic to handle the case where `y` is a TypeVar or Self type.
    -   Bug Fix: Fixed bug in match statement type narrowing. It wasn't properly handling the negative type narrowing case for class patterns when the subject expression was a bound TypeVar or Self type.
    -   Bug Fix: Fixed a bug related to the `__eq__` method (and other order methods) that are synthesized for a dataclass. The parameter name was incorrect. It should be `other`.
    -   Bug Fix: Added support for NFKC normalization of identifiers as specified in the Python lexical specification.
-   [1.1.221](https://github.com/microsoft/pyright/releases/tag/1.1.221)
    -   Behavior Change (from Pylance): Auto-exclude any folder under workspace starting with a period.
    -   Bug Fix: Fixed a bug in type narrowing for `match` statement. It was not properly handling `None` literal patterns when narrowing in the negative case.
    -   Bug Fix: Fixed bug that leads to a false positive error when using a class whose constructor doesn't contain any type annotations. Pyright treats such classes as though they are generic to help with inference of instance variables initialized in the constructor, but it shouldn't enforce the variance of the under-the-cover type variables.
    -   Bug Fix: Fixed bug that resulted in a false positive when evaluating certain list comprehensions where the subexpressions had interdependencies.
    -   Bug Fix: Fixed bug that resulted in a false positive error when evaluating type compatibility between two callables that included an `*args` parameter plus a set of keyword-only parameters. ([pylance-release#2370](https://github.com/microsoft/pylance-release/issues/2370))
    -   Enhancement: Updated typeshed stubs to the latest version.
    -   Enhancement: Added support for PEP 675 (arbitrary literal strings).
    -   Bug Fix: Added support for multiple unpack operators in a tuple list without parentheses when used in the RHS of a for statement. This was a grammar change introduced in Python 3.9. ([pylance-release#2371](https://github.com/microsoft/pylance-release/issues/2371))
    -   Enhancement: Improved completions for class member access when the member variable in a child class is unannotated but a parent class provides an annotation. In this case, we should use the type information from the annotated symbol.
    -   Behavior Change: Changed the behavior of the package type verifier so it does not flag unannotated class or instance variables if a parent class provides a type annotation for a variable of the same name. The type is inherited in this case. Also updated the library guidance to reflect this change.
    -   Bug Fix: Fixed bug that resulted in an incorrect type evaluation when handling a `namedtuple` call with a second parameter that is dynamic (not statically known).
    -   Enhancement: Improved support for `namedtuple` when the second argument is a tuple of string literals. It's more common to pass a list of string literals, but tuples should work as well.
    -   Bug Fix: Reverted a recent bug fix that caused significant performance degradations and crashes under some circumstances. ([pylance-release#2373](https://github.com/microsoft/pylance-release/issues/2373), [pylance-release#2387](https://github.com/microsoft/pylance-release/issues/2387), [pylance-release#2391](https://github.com/microsoft/pylance-release/issues/2391))
    -   Enhancement: Added special-case check for new callable syntax used within a quoted annotation passed as a bound or constraint argument to a TypeVar constructor.
    -   Bug Fix: Improved symbol resolution of module imports within the code flow engine when determining whether a context manager swallows exceptions or a callable returns NoReturn.
    -   Performance: Mitigated performance issue that results when doing a type compatibility check between two distinct recursive type aliases.
    -   Bug Fix: Fixed incorrect type evaluation when evaluating a constructor call with bidirectional type inference when the expected type is generic.
    -   Bug Fix: Fixed bug that resulted in incorrect type evaluation when a generic class with constrained type parameters was explicitly specialized with a subclass of one of the constrained types.

## 2022.2.2 (11 February 2022)

This release was not published.

## 2022.2.1 (9 February 2022)

Notable changes:

-   Performance: Only index workspaces that have open files. ([pylance-release#2270](https://github.com/microsoft/pylance-release/issues/2270))
-   Performance: Exclude folders whose names start with "." from indexing.
-   Performance: Delay indexing of libraries until 10 minutes after last edit.
-   Performance: Added partial seaborn stub.
-   Performance: Added colors API to matplotlib stub.

In addition, Pylance's copy of Pyright has been updated from 1.1.217 to 1.1.220 including the following changes:

-   [1.1.220](https://github.com/microsoft/pyright/releases/tag/1.1.220)
    -   Behavior Change: Changed the type narrowing logic for truthy and falsy conditions to exempt protocol classes.
    -   Bug Fix: Fixed bug that resulted in incorrect type evaluation of an `or` binary operator when the same expression was used in the LHS and RHS and was always truthy.
    -   Bug Fix: Fixed bug that resulted in the incorrect evaluation of a type resulting from a call to a constructor for an explicitly-specialized generic class in the case where that class implements neither a `__new__` nor an `__init__` method.
    -   Enhancement: Improved error message for descriptor and property setters.
    -   Bug Fix: Fixed a bug in PEP 646 unpacked tuple support where `*args` could not be annotated with `*tuple` type.
    -   Bug Fix: Fixed a false negative in the handling of dataclasses that contain fields with default orders before fields without default values in the case where an `__init__` is already defined on the class.
    -   Bug Fix: Fixed bug that results in false positive error when using a PEP 677 callable arrow syntax within a quoted type on Python 3.10 or older.
    -   Bug Fix: Fixed a bug in the code that prints types to text. It was not properly handling the case where a callable contains a synthesized \*args parameter with a type that isn't unpacked.
    -   Bug Fix: Fixed false negative where type annotations beginning with "\*" were not properly flagged as a syntax error.
    -   Improved support for matching of TypeVarTuple when used with \*args parameter.
    -   Bug Fix: Added missing check for a TypeVarTuple value that is not unpacked when passed as an argument.
-   [1.1.219](https://github.com/microsoft/pyright/releases/tag/1.1.219)
    -   Enhancement: Updated typeshed stubs to latest version.
    -   Bug Fix: Fixed a bug that results in a false positive error when using a `Self` return type for an `__aenter__` method.
    -   Bug Fix: Fixed false positive error when `P.args` or `P.kwargs` parameter type annotation is wrapped in `Annotated`.
    -   Bug Fix: Fixed bug that caused false negative when evaluating a recursive type alias involving a tuple.
    -   Bug Fix: Fixed a bug in the bidirectional type inference logic for list, set and dictionary expressions when that affected certain cases where the expected type contained a union.
    -   Bug Fix: Fixed bug that resulted in false negative when using a recursive type alias with dictionary, list or set expressions.
    -   Bug Fix: Fixed bug that resulted in the inappropriate generation of an Unknown type (and therefore false positive errors in strict mode) when using bidirectional type inference with a function that accepts a generic callable parameter.
    -   Bug Fix: Improved detection of NoReturn calls within code flow graph. In particular, the code now handles the case where the LHS of the call expression is a member access expression and the LHS of that expression is a local variable whose type needs to be inferred.
    -   Enhancement: Added better error handling and reporting for dataclass_transform.
    -   Bug Fix: Fixed bug that caused crash when handling bigint literal values.
    -   Bug Fix: Added missing check for a dataclass field that is declared with a default value in a base class but then overridden with one that doesn't include a default value in a child class. At runtime, it still acts as though it has a default value, which is inherited from the base class.
    -   Bug Fix: Fixed bug that prevented the "--verifytypes" feature from working with namespace packages.
    -   Bug Fix: Added missing check for improper use of `Unpack` when used in some contexts.
-   [1.1.218](https://github.com/microsoft/pyright/releases/tag/1.1.218)
    -   Enhancement: Allow "--watch" to be used in conjunction with "--outputjson" command-line options.
    -   Enhancement: Added support for bidirectional type inference for `yield` statements. The expected type is based on the first type argument in a `Generator` or `AsyncGenerator` return type annotation.
    -   Enhancement: Added the ability to add new symbols to `builtins` by simply adding a type stub file named `__builtins__.pyi` locally. ([pylance-release#1383](https://github.com/microsoft/pylance-release/issues/1383)), ([pylance-release#2103](https://github.com/microsoft/pylance-release/issues/2103))
    -   Bug Fix: Fixed a bug that led to a false positive error when handling bidirectional type inference for tuple expressions when the expected type was a union that contained multiple tuple subtypes.
    -   Bug Fix: Fixed a bug that resulted in a false negative when a list comprehension was used within a class body and referenced a class-scoped variable in a subexpression other than the first iterable. This also fixes a similar bug where a lambda was used within a class body and referenced a class-scoped variable in its return expression. These now property generate errors, reflecting the runtime behavior.
    -   Bug Fix: Fixed a bug that resulted in incorrect type inference for positional parameters used in class patterns if the corresponding class was defined in a "py.typed" library and it defined a `__match_args__` symbol with no annotation. ([pylance-release#2327](https://github.com/microsoft/pylance-release/issues/2327))
    -   Bug Fix: Fixed bug in stub generator that caused it to omit import statements with multi-part names (e.g. `import a.b.c`) even though there was a reference within the generated stub to the imported module.
    -   Enhancement: Extended type narrowing for class pattern matching so it supports narrowing in the negative case when arguments are present and when the pattern class is generic.
    -   Bug Fix: Fixed a bug that resulted in a false negative when a `*args` parameter was used in conjunction with a `*` keyword-only separator parameter. This generates a syntax error at runtime.
    -   Bug Fix: Fixed a false positive error when `TypeGuard` was used without a type argument in a runtime manner (outside of a type annotation).
    -   Bug Fix: Fixed recent regression that results in false positive errors detected in the `reportUnknownParameterType` diagnostic check when the function includes a parameter with a double underscore name indicating that it's positional-only.
    -   Enhancement: Improved signature help and hover text for synthesized `__init__` dataclass method when a parameter uses a field descriptor with a default value.

## 2022.2.0 (2 February 2022)

Notable changes:

-   Enhancement: Improve perf when python.analysis.indexing is on by only re-indexing user files that are directly changed. ([pylance-release#1368](https://github.com/microsoft/pylance-release/issues/1368))
-   Bug Fix: Fixed Pandas stubs to allow passing `NamedAgg` to `aggregate` and `agg`. ([pylance-release#2180](https://github.com/microsoft/pylance-release/issues/2180))

In addition, Pylance's copy of Pyright has been updated from 1.1.215 to 1.1.217 including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Enhancement: Added support for bidirectional type inference for `yield` statements.
    -   Enhancement: Allow `--watch` to be used in conjunction with `--outputjson` command-line options.
-   [1.1.217](https://github.com/microsoft/pyright/releases/tag/1.1.217)
    -   Bug Fix: Fixed a bug that resulted in a false positive error when passing an `*args` argument typed as an unpacked TypeVarTuple to a function that includes an unpacked TypeVarTuple parameter.
    -   Enhancement: Added special-case bidirectional type inference for the right operand of the "|" and "|=" operators (with an expected type based on the left operand). This supports the case where the left operand is a TypedDict and the right operand is a dict expression that conforms to the TypedDict type. ([pylance-release#2300](https://github.com/microsoft/pylance-release/issues/2300))
    -   Bug Fix: Fixed a bug in the reportIncompatibleMethodOverride check that resulted in false positive errors when both the base class and child methods have overloads but the base class does not have an - implementation and the child class does.
    -   Enhancement: Updated typeshed stubs to the latest version.
    -   Bug Fix: Fixed a bug that results in false positive errors when a `ClassVar` type declaration appears within an `Annotated`.
    -   Bug Fix: Added special-case handling of `Generic` base types to match the (undocumented) runtime behavior. Without this special-case handling, pyright reports that "a consistent method ordering cannot be found" in some cases where the runtime does not.
    -   Bug Fix: Fixed bug that is leading to some crashes that appear in the telemetry.
    -   Bug Fix: Added recursion detection for wildcard import lookups during code flow.
    -   Bug Fix: Fixed a bug that caused a type alias of `Any` to be evaluated as `Unknown` if defined within a py.typed library.
    -   Performance: Improved performance when analyzing types that involve some forms of recursive type aliases.
    -   Enhancement: Added support for typing_extensions.Never and typing.Never type and unified the underlying handling of Never and NoReturn, which are synonyms.
    -   Enhancement: Improved type stub generation code to emit definitions for TypeVar, TypeVarTuple, ParamSpec and NewType.
    -   Behavior Change: Changed heuristics for matching two union types when the destination union includes a combination of concrete types and one or more type variables. This case involves some heuristics in the constraint solver because multiple solutions are possible.
    -   Bug Fix: Fixed a bug that resulted in a false positive when assigning to a field in a dataclass that is annotated with a Callable type.
-   [1.1.216](https://github.com/microsoft/pyright/releases/tag/1.1.216)
    -   Bug Fix: Fixed recent regression that resulted in a crash (stack overflow) in the code flow engine.
    -   Bug Fix: Fixed a bug that resulted in unknown types in member access expressions to go unreported with `reportUnknownMemberType` was enabled. This occurred when the member access expression was located within a subscript of an index expression.
    -   Performance: Changed the logic that infers a NoReturn type to avoid inferring symbol types. This was causing a bunch of extra work to be performed in complex unannotated code bases like sklearn.
    -   Performance: Fixed performance issue in parser for deeply-nested parenthesized expressions. ([pylance-release#2299](https://github.com/microsoft/pylance-release/issues/2299))
    -   Bug Fix: Fixed bug in callable type compatibility logic. It was not properly handling some edge cases where a keyword parameter in the source and destination had an incompatible type if one or both of the types were specialized.
    -   Bug Fix: Fixed a bug that resulted in false positives when specializing a callback protocol with a TypeVarTuple when the callback protocol also contained one or more keyword parameters that were generic.
    -   Bug Fix: Fixed a bug in the protocol invariance checking logic. It wasn't properly handling protocols that used a TypeVarTuple as a type parameter that wasn't last (right-most) in the type parameter list.
    -   Behavior Change: Changed import resolution order to more closely match PEP 561. Typeshed stdlib type stubs are now resolved later in the import resolution process, after all local modules and modules within the python environment.

## 2022.1.5 (27 January 2022)

Notable changes:

-   Behavior Change: Changed folding of classes and functions to fold at the line containing the function or class name.
-   Enhancement: Updated to requied node 14 and vscode 1.63.1
-   Enhancement: Added new diagnostic check "reportMatchNotExhaustive" which reports cases where a `match` statement doesn't exhaustively cover all cases.
-   Enhancement: Added option to disable "Go to symbol in workspace"
    ([pylance-release#2236](https://github.com/microsoft/pylance-release/issues/2236))

In addition, Pylance's copy of Pyright has been updated from 1.1.213 to 1.1.215 including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Enhancement: Changed the logic that infers a NoReturn type to avoid inferring symbol types. This was causing a bunch of extra work to be performed in complex unannotated code bases like sklearn.
    -   Enhancement: Updated type inference documentation to eliminate a statement that was leading to some confusion.
    -   Bug Fix: Fixed a bug that resulted in unknown types in member access expressions to go unreported with `reportUnknownMemberType` was enabled. This occurred when the member access expression was located within a subscript of an index expression.
    -   Bug Fix: Fixed recent regression that resulted in a crash (stack overflow) in the code flow engine.
-   [1.1.215](https://github.com/microsoft/pyright/releases/tag/1.1.215)
    -   Bug Fix: Fixed bug that resulted in crash when extremely large integer literals are encountered.
        ([pylance-release#2279](https://github.com/microsoft/pylance-release/issues/2279))
    -   Bug Fix: Fixed bug that caused "extraPaths" specified for individual execution environment to be combined for all execution environments if a default "extraPaths" was also specified in the same config file.
    -   Bug Fix: Fixed handling of `NoReturn` type, which should act like `Never` in that both are considered "bottom types" and are assignable to any other type.
    -   Enhancement: Updated typeshed stubs to the latest.
    -   Enhancement: Added new diagnostic check "reportMatchNotExhaustive" which reports cases where a `match` statement doesn't exhaustively cover all cases.
    -   Enhancement: Added support for unpack operator for tuples used within type arguments. Support for this new syntax will appear in Python 3.11.
    -   Bug Fix: Added code in parser to detect obscenely deep parse subtrees containing binary and unary operations. These were sometimes leading to crashes in the binder and type evaluator. The parser now replaces them with error parse nodes and reports an error to the user.
    -   Bug Fix: Added recursion check in type guard logic to address stack overflow issue seen in telemetry.
    -   Bug Fix: Fixed bug that produces a false positive when attempting to assign a value of type `Type[NoneType]` to `Type[None]`. These are equivalent, so the assignment should be allowed.
    -   Enhancement: Enhanced parser to detect and report a runtime error that occurs when using a generator expression without surrounding parens as an argument within a call expression when more than one argument or a trailing comma is present.
    -   Bug Fix: Fixed a bug that resulted in a false positive when a member access expression targeted an attribute that was returned by a `__getattr__` method that returns a descriptor object. The old logic was binding the descriptor to the object, but that's inconsistent with the way things work at runtime.
        ([pylance-release#2282](https://github.com/microsoft/pylance-release/issues/2282))
    -   Enhancement: Improved analysis of `finally` block and the code that comes after the `finally` block so type narrowing performed within the `finally` block in the fall-through case is preserved.
    -   Enhancement: Added support for `Final` and `ClassVar` annotations embedded within `Annotated`. Runtime support has recently been added for this case.
    -   Enhancement: Added support for `InitVar` that is wrapped in `Annotated`. Support is being added for this in the runtime.
    -   Enhancement: Added special-case handling for methods declared as returning a `Generator`, `AsyncGenerator` or `AwaitableGenerator` that do not contain a yield statement. This special case applies only to methods declared in stub files, an abstract method, or a protocol definition with no code.
        ([pylance-release#2287](https://github.com/microsoft/pylance-release/issues/2287))
    -   Bug Fix: Improved support for custom subclasses of the builtin `property` class. Previously, the special-case handling in place for `property` were not handling these custom subclasses well, and this resulted in several false positive errors and incorrect type evaluations.
-   [1.1.214](https://github.com/microsoft/pyright/releases/tag/1.1.214)
    -   A regression was introduced in the 1.1.213 release that has the potential of impacting many pyright users, so I decided to do a quick update.
    -   Bug Fix: Reverted change from previous release that caused incorrect type evaluations and false positive errors in certain situations involving bidirectional type inference with call expressions.
    -   Enhancement: Updated typeshed stubs to latest.
-   [1.1.213](https://github.com/microsoft/pyright/releases/tag/1.1.213)
    -   Behavior Change: For not-required TypedDict fields, added a second synthesized overload for the two-parameter form of `get` that specifies the type of the second parameter is the same type as the field value. The other overload allows this second parameter to be of a different type.
    -   Bug Fix: Fixed bug that resulted in a false positive when accessing a field in a base class that provides a `__getattr__` method and is use in conjunction with another base class.
    -   Bug Fix: Fixed bug that resulted in crash due to infinite recursion.
    -   Bug Fix: Fixed a bug in the logic that detects duplicate enum members that resulted in a false positive when an enum class has other instance variables that are not enum members.
    -   Bug Fix: Added special-case handling for instance variables in a dataclass that are marked `Final`. Previously, these were flagged as an error because there was no explicit value assigned to them, but the synthesized `__init__` method implicitly initializes them.
    -   Enhancement: Added check for a class that derives from a protocol class where the protocol declares a method with an empty implementation, and the subclass doesn't provide a concrete implementation of the same-named method.
    -   Bug Fix: Fixed a bug that resulted in a false positive type evaluation error when using bidirectional type analysis for a call expression and the return type of the call contained a union of a TypeVar and another type and the expected type contained a union with at least one literal type.
    -   Bug Fix: Fixed bug that resulted in confusing error message when dataclass field was annotated with `Self` and then the class was subclassed.
    -   Enhancement: Improved the logic that handles instantiation of a custom metaclass when the name of the new class is passed as a string literal to the metaclass constructor.
    -   Enhancement: Improved the bidirectional type inference logic for lambdas to handle the case where one or more of the matching parameter types was a TypeVar.
    -   Bug Fix: Fixed a bug in the parser that resulted in a false negative when using an assignment expression (walrus operator) in the `if` clause of a list comprehension with no surrounding parentheses.
    -   Enhancement: Added support for bidirectional type inference when an `await` operator is used in an expression.
    -   Bug Fix: Fixed a bug in the logic that handles classes that are constructed from custom metaclasses.
    -   Enhancement: Added provisional support for the proposed "typing.reveal_type" call.

## 2022.1.3 (21 January 2022)

Notable changes:

-   Enhancement: Add folding for f-strings, dicts, and #regions.
-   Enhancement: Adding `"python.analysis.indexing"` to the config. Index installed third party libraries and user files for language features such as auto-import, add import, workspace symbols, etc.
    ([pylance-release#291](https://github.com/microsoft/pylance-release/issues/291))
    ([pylance-release#1288](https://github.com/microsoft/pylance-release/issues/1288))
    ([pylance-release#2261](https://github.com/microsoft/pylance-release/issues/2261))
-   Enhancement: Better support for docstrings on overload functions. example numpy.random.choice
    ([pylance-release#2243](https://github.com/microsoft/pylance-release/issues/2243))
-   Enhancement: Import completions no longer show builtin symbols
-   Enhancement: Implemented a new diagnostic check "reportMissingSuperCall" that checks for `__init__`, `__init_subclass__`, `__enter__` and `__exit__` methods that fail to call through to their parent classes' methods of the same name. This is a common source of bugs. The check is disabled by default. We may eventually enable it by default in strict mode, but we want to get feedback before doing so.

In addition, Pylance's copy of Pyright has been updated from 1.1.209 to 1.1.212 including the following changes:

-   Unreleased in Pyright, but included in Pylance:

    -   Bug Fix: Fixed bug that resulted in crash due to infinite recursion.
    -   Bug Fix: Fixed bug that resulted in a false positive when accessing a field in a base class that provides a `__getattr__` method and is use in conjunction with another base class.
        main
    -   Enhancement: For not-required TypedDict fields, added a second synthesized overload for the two-parameter form of `get` that specifies the type of the second parameter is the same type as the field value. The other overload allows this second parameter to be of a different type.
    -   Enhancement: Updated documentation to cover the new # pyright: basic comment.

-   [1.1.212](https://github.com/microsoft/pyright/releases/tag/1.1.212)
    -   Bug Fix: Fixed bug that resulted in false positive when one or more sources of types in TypeVar solving was unknown.
    -   Bug Fix: Fixed bug that resulted in a crash if a `TypedDict` class was derived from another `TypedDict` class and the base class had zero fields defined.
    -   Enhancement: Added support for `# pyright: basic` comment to enable basic type checking in a file.
    -   Bug Fix: Fixed a bug that resulted in a false positive error when determining whether method overrides for a multi-inheritance chain are compatible.
    -   Bug Fix: Fixed bug that resulted in a false positive when using bidirectional inference with a constructor with complex set of covariant, invariant, and contravariant type parameters.
    -   Enhancement: Improved logic for `type(x) is y` type narrowing pattern so it handles the case where `x` is `Any`.
        ([pylance-release#2896](https://github.com/microsoft/pylance-release/issues/2896))
-   [1.1.211](https://github.com/microsoft/pyright/releases/tag/1.1.211)
    -   Enhancement: Added support for very large integer literals (both in the tokenizer/parser and in the type system for Literals).
    -   Bug Fix: Fixed bug where call to async function that returns `NoReturn` was treated as a "no-return" function even though it wasn't awaited.
    -   Enhancement: Added check for class or instance variables that are declared but not assigned in a protocol class and not assigned in a concrete class that explicitly derives from the protocol class.
    -   Bug Fix: Fixed bug in type narrowing logic for `isinstance` calls where the input value includes a `Callable` and the class list includes a class that is not a runtime-checkable protocol class. In this case, the `Callable` should not be removed in the negative ("else") case even if the class defines a compatible `__call__` method.
    -   Bug Fix: Fixed bug that resulted in a false positive error when assigning a value to a TypedDict with not-required keys when that key had previously been assigned a literal value that narrowed the type.
    -   Behavior Change: Reverted recent change to TypedDict where the single-argument form of `get` was removed for not-required fields. This caused problems because there is a fallback overload that accepted this case still.
    -   Behavior Change: Changed `reportUnknownArgumentType` diagnostic check to be suppressed if the argument is an empty list or dict that comes from a `[]` or `{}` expression. While these types do technically contain `Unknown` type arguments, they are not unsafe, so reporting a diagnostic here is just noise.
    -   Behavior Change: Changed the implementation of `reveal_type` so it no longer returns a literal string type but now accepts optional keyword arguments `expected_text` and `expected_type`. The return type of `reveal_type` is now the same as the type of the first argument, making it consistent with mypy's implementation of `reveal_type`.
    -   Enhancement: Modified error messages for Required and NotRequired for clarity.
    -   Bug Fix: Fixed bug in parser that resulted in a false negative error when using an assignment expression within a subscript. This is allowed in the grammar as of Python 3.10.
    -   Enhancement: Updated typeshed stubs to the latest.
    -   Bug Fix: Fixed internal crash caused by infinite recursion.
    -   Bug Fix: Fixed bug that caused a crash in functools.partial special-case logic.
    -   Bug Fix: Fixed bug in type evaluation of index expressions that involve a recursive type alias in the subscript. Also improved text version of expanded types that include recursive type aliases.
-   [1.1.210](https://github.com/microsoft/pyright/releases/tag/1.1.210)
    -   Behavior Change: Removed support for two-argument form of `TypeGuard` including support for "type asserts". The feedback on this idea was relatively negative.
    -   Enhancement: Added provisional support for a proposed `StrictTypeGuard` feature. For details, refer to [this discussion](https://github.com/python/typing/discussions/1013).
    -   Enhancement: Added support for old-style (pre-await) coroutines.
    -   Bug Fix: Fixed a bug that resulted in a false positive in cases involving bidirectional type inference with an expected callable type where one or more of the parameter types was a tuple with non-literal element types and the provided argument was a tuple with a literal value.
    -   Bug Fix: Improved limit check for literal math.
    -   Enhancement: Updated typeshed stubs to the latest.
    -   Bug Fix: Fixed bug that results in false positive when using a `super().__init__` call within a metaclass `__init__` method.
    -   Bug Fix: Fixed bug that results in a false positive error when using `yield` within the outermost iterator of a list comprehension.
    -   Bug Fix: Fixed a bug that resulted in a false positive when importing `OrderedDict` from `typing_extensions`. Added a mechanism for loading typeshed modules on demand within the type evaluator, - Enhancement: Added improved checks for size mismatches when unpacking known-length iterables into a list target (like `[a, b] = (1, 2, 3)`).
    -   Behavior Change: Changed the `setdefault` method generated for TypedDict classes so it accepts only literal key values. Fixed a bug in the `get` method generated for TypedDict classes so it accepts arbitrary values for the default value parameter.
        ([pylance-release#2256](https://github.com/microsoft/pylance-release/issues/2256))
    -   Bug Fix: Fixed bug that resulted in incorrect type evaluation when using a generic type alias that consists of a union of multiple type variables that are filled with the same type when the type alias is specialized.
    -   Behavior Change: Modified the `reportMissingSuperCall` diagnostic based on feedback. It now emits an error for classes that include an `__init__` and don't call through to `super().__init__` even if that class derives from `object`, unless it's marked `@final`.
-   [1.1.209](https://github.com/microsoft/pyright/releases/tag/1.1.209)
    -   Enhancement: Added support for "literal math" for certain unary and binary operations where the operands are all the same literal class types (str, bytes, int, or bool). For example, `Literal[0, 1]` + `Literal[1, 2]` results in type `Literal1, 2, 3]`.
    -   Enhancement: Implemented a new diagnostic check "reportMissingSuperCall" that checks for `__init__`, `__init_subclass__`, `__enter__` and `__exit__` methods that fail to call through to their parent classes' methods of the same name. This is a common source of bugs. The check is disabled by default. We may eventually enable it by default in strict mode, but we want to get feedback before doing so.
    -   Behavior Change: Changed text output of CLI version to use the word "information" rather than "info" for consistency with JSON output.
    -   Bug Fix: Fixed bug that resulted in a crash if `Self` was used in a type argument within a method decorator.
    -   Behavior Change: Changed behavior to allow `Self` to appear within a `ClassVar` type.
    -   Bug Fix: Fixed bug that resulted in an incorrect type evaluation when `Self` was used as a return type annotation for a property or class property.

## 2022.1.1 (12 January 2022)

Notable changes:

-   Enhancement: Added LSP support for code folding ranges
    ([vscode-codebasics-folding](https://code.visualstudio.com/docs/editor/codebasics#_folding))
-   Enhancement: Added support for USERNAME and VIRTUAL_ENV shell variables in vscode settings.
    ([pylance-release#2221](https://github.com/microsoft/pylance-release/issues/2221))
-   Enhancement: Improved completion provider suggestions for static members.
    ([pylance-release#1318](https://github.com/microsoft/pylance-release/issues/1318))
-   Enhancement: "add import" suggestions now suggest exact matches with higher priority.
    ([pylance-release#297](https://github.com/microsoft/pylance-release/issues/297))
-   Enhancement: Improved override function completions around positional and keyword only parameters.
    ([pylance-release#711](https://github.com/microsoft/pylance-release/issues/711))
-   Behavior Change: Always enable stdlib indexing if possible. This will allow users to use 'auto import' and 'add import' in open single file mode.
    ([pylance-release#1765](https://github.com/microsoft/pylance-release/issues/1765))
-   Bug Fix: Pylance is not working on vscode.dev/github.dev.
    ([pylance-release#2235](https://github.com/microsoft/pylance-release/issues/2235))

In addition, Pylance's copy of Pyright has been updated from 1.1.205 to 1.1.208 including the following changes:

-   [1.1.208](https://github.com/microsoft/pyright/releases/tag/1.1.208)
    -   Enhancement (from pylance): Added support for USERNAME and VIRTUAL_ENV shell variables in ".env" file.
    -   Enhancement (from pylance): Improved completion provider suggestions for static members.
    -   Bug Fix: Reverted check for base classes that use variables. It was too disruptive, so another approach is needed.
-   [1.1.207](https://github.com/microsoft/pyright/releases/tag/1.1.207)
    -   Bug Fix: Fixed bug that results in false positive error when a function signature captured by a ParamSpec includes an \*args or \*\*kwargs parameter.
    -   Bug Fix: Fixed bug that resulted in false positive error and unclear error message with the reportIncompatibleMethodOverride check.
    -   Behavior Change: Changed type analysis of `def` statements to insert implicit `/` parameter (a position-only parameter separator) when one or more parameter names start with double underscores.
    -   Bug Fix: Fixed a bug that resulted in no error being emitted when an `await` keyword was used with a `Generator` object.
    -   Bug Fix: Fixed bug that resulted in false positive error when accessing a staticmethod or classmethod from a protocol class.
    -   Bug Fix: Fixed bug that prevented a file-level override of `reportUnnecessaryTypeIgnoreComment` from working correctly.
    -   Bug Fix: Fixed bug that resulted in a false positive error when adding a 'staticmethod' or 'classmethod' decorator to an already-decorated method.
    -   Enhancement: Updated typeshed stubs to latest.
    -   Enhancement: Improved check for index values for tuples to handle unions of tuples.
    -   Enhancement: Added new diagnostic check `reportInconsistentConstructor` that checks for inconsistent input signatures between `__new__` and `__init__` methods.
    -   Bug Fix: Added a check for base classes specified in a class declaration that is not a concrete class but instead a variable (dynamic) type.
-   [1.1.206](https://github.com/microsoft/pyright/releases/tag/1.1.206)
    -   Bug Fix: Fixed a bug in the logic that determines whether a call expression is a "NoReturn". In particular, the logic wasn't handling the case where the call was to the constructor of a class that had a custom metaclass that defined a `__call__` method.
        ([pylance-release#2224](https://github.com/microsoft/pylance-release/issues/2224))
    -   Bug Fix: Fixed regression that caused a false positive error when attempting to invoke constructor for a class derived from `ctypes.Structure`. This class uses a custom metaclass with a custom `__getattr__` method.
    -   Bug Fix: Updated heuristics in type variable constraint solver to better handle literals in the case where bidirectional type inference is being used.
    -   Enhancement: Updated `dataclass_transform` support so it applies to both metaclasses and base classes to conform to the latest version of the specification.
    -   Bug Fix: Fixed bug that resulted in false positive errors when dealing with protocol classes that referred to themselves internally.
    -   Bug Fix: Fixed bug in `reportIncompatibleMethodOverride` diagnostic check where it omitted an error if an overridden method had a decorator applied.
    -   Bug Fix: Fixed a bug in the type evaluation of the two-argument for of `super()` when the second argument is a class instance and the call is made from within a class or static method.
        ([pylance-release#2230](https://github.com/microsoft/pylance-release/issues/2230))
    -   Behavior Change: Added implied position-only parameter separator for `Concatenate` operator.
    -   Enhancement: Added new diagnostic check `reportUnnecessaryTypeIgnoreComment` that emits a diagnostic when a `# type: ignore` comment has no effect.
    -   Bug Fix: Fixed several bugs in type var constraint solver related to functions that have parameters that are callable that have parameters that are callable.
-   [1.1.205](https://github.com/microsoft/pyright/releases/tag/1.1.205)
    -   Enhancement: Improved type narrowing for `x.y == L` pattern to also support `x.y is L` if `L` is a `bool` or enum literal.
    -   Bug Fix: Fixed regression that resulted in a false positive error when assigning an empty tuple to a declared type that involved an unbounded tuple.
    -   Bug Fix: Fixed bug that causes a crash due to infinite recursion.
    -   Bug Fix: Fixed recent regression that resulted in a crash when using a zero-length tuple as a function argument.
    -   Bug Fix: Fixed bug that resulted in the first parameter of a local function declared within a method to be interpreted as a "self" parameter.
    -   Bug Fix: Fixed bug that resulted in a false positive when using a decorator that applies to a method and provides a type for the parameter corresponding to "self".
    -   Bug Fix: Fixed bug in tokenizer that resulted in a missing error when the first statement in a source file is preceded by whitespace.
    -   Enhancement: Updated typeshed stubs to latest.
    -   Bug Fix: Fixed bug that resulted in false positive error when a ParamSpec was bound to a generic function with some unresolved TypeVars.
    -   Behavior Change: Changed behavior of type alias declarations that use a generic class or alias in the RHS without any subscripts or unions. These are treated as unspecialized aliases, whereas they were previously specialized with `Any` type arguments.

## 2022.1.0 (5 January 2022)

Notable changes:

-   Enhancement: Improved untitled file support

In addition, Pylance's copy of Pyright has been updated from 1.1.196 to 1.1.204 including the following changes:

-   [1.1.204](https://github.com/microsoft/pyright/releases/tag/1.1.204)
    -   Behavior Change: Added special-cased handling for `__slots__` and `__class_getitem__` in protocol matching logic.
    -   Enhancement: Improved bidirectional type inference for lambdas with default argument values.
    -   Enhancement: Improved heuristics for when constraint solver should prefer literals over non-literals when solving a TypeVar in the case of bidirectional inference when assigning to a callable type.
    -   Enhancement: Added support for unpacking of tuples in type annotations (part of PEP 646).
    -   Bug Fix: Fixed bug that resulted in false positive error when a `Literal` was used within a Python-2 style type annotation comment.
    -   Enhancement: Updated typeshed stubs to the latest.
    -   Bug Fix: Fixed bug in "x is None" type guard logic. It wasn't preserving conditional types if x was a TypeVar.
    -   Bug Fix: Fixed bug that resulted in false positive error when a constrained TypeVar was checked against a particular constraint in an `isinstance` type guard.
    -   Bug Fix: Fixed a bug in the logic for assignment-based type narrowing that resulted in the wrong narrowed type if the declared type of the destination expression contained a union and the source contained a TypeVar.
-   [1.1.203](https://github.com/microsoft/pyright/releases/tag/1.1.203)
    -   Happy New Year everyone!
    -   Bug Fix: Fixed false positive error when `Optional` is used outside of a type annotation with no type arguments.
    -   Enhancement: Added provisional support for "asserting type guard functions", those that return a type of `TypeGuard[X, NoReturn]`.
    -   Enhancement: Added support for type narrowing in pattern classes based on the absence of an attribute (or a pattern mismatch of an attribute) if the class in question is marked `@final`.
    -   Behavior Change: Changed the behavior for wildcard imports when the target module defines `__all__` in a way that pyright cannot understand. Previously, the wildcard import didn't import any symbols in this case. Now, it imports all symbols from the target module.
    -   Enhancement: Added support for undocumented behavior of functools.partial whereby it allows keyword parameters to be overridden by the caller even though they are already supplied in the `partial` decorator.
    -   Behavior Change: Changed the reportImplicitStringConcatenation diagnostic check to not flag concatenated strings if they are contained within enclosing parentheses.
    -   Bug Fix: Fixed bug that caused `__hash__` function not to be synthesized for frozen pydantic models when using `dataclass_transform`.
    -   Enhancement: Enhanced the "aliased conditional" type narrowing capability to accommodate multiple assignments of the variable used within the aliased conditional as long as the variable isn't reassigned between the the aliased conditional assignment and the conditional check that uses the aliased value.
    -   Enhancement: Added support for `bool(x)` type guard.
    -   Bug Fix: Fixed several bugs that prevented type narrowing to work correctly when conditional expression included an assignment expression.
    -   Enhancement: Added check for member access expressions that access a member of a protocol class directly from the class. In this case, the member must be declared as a ClassVar.
    -   Enhancement: Improved "x in y" type narrowing logic to better handle literal types in the iterable value y.
    -   Behavior Change: Adjusted heuristics for assignment-based type narrowing. If the RHS type contains an unsolved TypeVar and the LHS (declared) type is concrete, do not apply type narrowing in this case.
    -   Bug Fix: Fixed bug that resulted in unreported type violation (false negative) when an inner function with a ParamSpec used a concatenated parameter but the outer function's return type did not.
    -   Enhancement: Added support for new type narrowing pattern: `len(x) == L` and `len(x) != L` where `x` is a tuple or union of tuples and `L` is a literal integer value.
-   [1.1.202](https://github.com/microsoft/pyright/releases/tag/1.1.202)
    -   Enhancement: Added check for class patterns for special builtin types (like int, float, etc.). These class patterns accept at most a single sub-pattern as an argument, and it must be positional.
    -   Bug Fix: Fixed type compatibility bug that allowed `Literal[1]` to be assignable to `type` when it should not be.
    -   Bug Fix: Fixed bug that caused "unnecessary isinstance" check to emit a false positive diagnostic when second argument was `Literal[1]`.
    -   Enhancement: Improved heuristics for determining preferred TypeVar match when matching against a union that includes a TypeVar.
    -   Enhancement: Added provisional support for two-argument form of TypeGuard to support negative narrowing cases.
    -   Bug Fix: Fixed bug in hover provider that caused docstrings not to appear for callable types that were generated from a callable with a ParamSpec.
    -   Bug Fix: Fixed a bug that resulted in a missing type error when a generic function returned a Callable type that used a TypeVar in its parameter types.
    -   Bug Fix: Fixed regression that resulted in a crash under certain circumstances where a `finally` clause was used in a generic function that used constrained TypeVars.
-   [1.1.201](https://github.com/microsoft/pyright/releases/tag/1.1.201)
    -   Enhancement: Added code to detect except clauses that are unreachable because their exception types are already handled by previous except clauses.
    -   Enhancement: Added type validation for custom metaclass keyword parameters specified in the metaclass's `__new__` method.
    -   Enhancement: Added type validation logic for dataclass `__post_init__` method.
    -   Bug Fix: Fixed bug that results in false positive error when class declaration arguments are evaluated out of order.
    -   Enhancement: Updated typeshed stubs to the latest version.
    -   Enhancement: Added support for `Required` and `NotRequired` type annotations in alternative syntax form of TypedDict.
    -   Behavior Change: Changed overload implementation consistency check so it doesn't require the implementation to include a `NoReturn` if one of the overload signatures returns a `NoReturn`.
    -   Bug Fix: Fixed a bug that resulted in a false positive in the overlapping overload check, specifically when a later overload used a type variable in a parameter annotation.
    -   Enhancement: Added type checking support for functools.total_ordering.
-   [1.1.200](https://github.com/microsoft/pyright/releases/tag/1.1.200)
    -   "The Christmas Edition"
    -   Enhancement: Added type checking support for functools.partial. This advanced support does not work with overloads or argument lists that include list or dictionary unpack operators.
    -   Bug Fix: Fixed a bug that resulted in a ParamSpec used within a generic function from becoming `Unknown` in some circumstances.
    -   Bug Fix: Fixed a bug that resulted in an incorrect specialized return type in certain cases involving ParamSpecs.
    -   Bug Fix: Fixed bug that can result in incorrect type evaluations when a keyword argument name is evaluated first when hovering over it.
    -   Behavior Change: Added special-case handling to accommodate assignment of a method that differs only in the Self parameter.
    -   Enhancement: Added logic to preserve function doc strings for a ParamSpec when it captures the signature of a function with a doc string. This is useful for decorators.
-   [1.1.199](https://github.com/microsoft/pyright/releases/tag/1.1.199)
    -   Bug Fix: Fixed bug that resulted in false positive error when class constructor is invoked with more than one argument and the class's metaclass has a custom `__call__` method.
    -   Enhancement: Updated typeshed stubs to the latest version.
    -   Bug Fix: Fixed recent regression that resulted in false positive when assigning a `Type[Proto]` to `Type[Proto]`.
    -   Enhancement: Added type checking for class constructor calls when the class has a metaclass with a custom `__call__` method.
    -   Bug Fix: Fixed a bug that resulted in an incorrect type inference when assigning to a list that includes an unpacked target variable.
    -   Enhancement: Improved handling of call expressions that have a `NoReturn` type. In particular, the logic now handles constructors, `__call__` methods, inferred symbol types, and symbol import chains.
    -   Bug Fix: Fixed bug that resulted in infinite recursion in certain cases when an aliased conditional expression was used.
    -   Bug Fix: Fixed bug in type evaluator that masked certain type errors when assigning a concrete type to a class TypeVar type.
    -   Bug Fix: Fixed bug that caused false positive when passing a generic function callback as an argument to another generic function.
-   [1.1.198](https://github.com/microsoft/pyright/releases/tag/1.1.198)
    -   Enhancement: Added support for exception group syntax introduced in PEP 654.
    -   Bug Fix: Fixed bug that resulted in false positive errors when using a TypeVar within the new callable syntax within a function declaration.
    -   Enhancement: Added missing check mandated by PEP 544, which disallows an assignment of a class type to a Type[Proto] if the class type is a protocol itself.
    -   Enhancement: Added support for class types that satisfy protocols. This is specifically allowed in PEP 544 in the section titled "Type[] and class objects vs protocols".
    -   Enhancement: Added support for assigning a param spec to a `...` signature, since the latter is the `Any` equivalent for ParamSpecs.
    -   Behavior Change: Changed type logic to allow `type` to be assigned to `Type[T]`. In this case, `type` is treated the same as `Type[Any]`, so `T` receives a value of `Any`.
    -   Enhancement: Added support for `__getattr__` and `__getattribute__` overloads that are typed with a literal str representing the attribute name.
    -   Bug Fix: Fixed bug in handling of callable syntax when a TypeVar, ParamSpec or TypeVarTuple was used outside of an appropriate scope. No error was emitted in this case.
    -   Bug Fix: Fixed a bug in the handling of the new callable syntax when it's used with an "async" keyword. The resulting return type should be `Awaitable` rather than `Coroutine`.
    -   Behavior Change: Changed the behavior of the new callable syntax to not accept `...` with other parameters. After further discussion on the typing-sig, the consensus is that supporting this will cause confusion.
    -   Bug Fix: Fixed a false negative (missing) error when a method within a generic class was annotated to return a generic type of itself.
    -   Enhancement: Added logic to handle the case where a declared return type of a function includes a constrained TypeVar and a return statement is guarded by a conditional check that guarantees that the constraint is met on that code path.
    -   Enhancement: Improved error message (and reduced cascading errors) for the case where a variable is incorrectly used as the LHS of a subscript expression within a type annotation.
-   [1.1.197](https://github.com/microsoft/pyright/releases/tag/1.1.197)
    -   Bug Fix: Fixed bug in type narrowing code for literal enums. It wasn't correctly handling the edge case where the enum class has no enumerated members.
    -   Bug Fix: Fixed bug in type narrowing logic for comparisons to literals that involve enums declared in a type stub. It was incorrectly narrowing the type to `Never` in the negative (else) case.
    -   Bug Fix: Fixed bug in type evaluator that resulted in incomplete (Unknown) types when variable types depend on each other within a loop and one of the expressions involves an unpack operator.
    -   Bug Fix: Fixed bug in protocol TypeVar variance validation. Thanks to @Azureblade3808 for this contribution.
    -   Enhancement: Added support for ellipsis type argument for a generic alias that uses a ParamSpec.
    -   Bug Fix: Fixed bug that caused false positives when assigning a function to a generic class or callback protocol that is parameterized with a ParamSpec that is specialized using an ellipsis.
    -   Bug Fix: Fixed several bugs where `Type[None]` was incorrectly treated as compatible with `None` and vice versa.
    -   Bug Fix: Fixed bug that resulted in a false positive error when `Required` or `NotRequired` special forms were used with no type arguments in contexts where they are used as runtime class names rather than type annotations.
    -   Behavior Change: Changed text representation of callables to more closely match the syntax introduced in PEP 677 including the use of "..." to represent "any parameters" and "\*\*P" to represent a ParamSpec.
    -   Bug Fix: Fixed error in pyrightconfig JSON schema, which duplicated a couple of IDs.
    -   Bug Fix: Fixed bug that caused crash in type analyzer when a TypeVar of the same name was declared twice in the same scope with constraints in one case and without in the other.
    -   Enhancement: Added support for draft PEP 677: callable type syntax.
-   [1.1.196](https://github.com/microsoft/pyright/releases/tag/1.1.196)
    -   Enhancement: Added support for Python 3.11 StrEnum.
    -   Behavior Change: Modified behavior for assignment-based type narrowing when the target of the assignment references an "asymmetric" descriptor or property, one where the setter accepts a different value type than the getter returns. When this is detected, assignment-based type narrowing is no longer applied.
    -   Behavior Change: Changed class pattern matching behavior to support narrowing of `Any` or `Unknown`, exempting this case from the general "never narrow Any" rule.
    -   Behavior Change: Modified behavior of overload matching when unpacked argument is present and the unpacked iterator is a type that doesn't provide any length information. In this case, overload matching will prefer an overload that includes a `*args` parameter rather than individual positional parameters.
    -   Enhancement: Added check for a module used as a type annotation, which is not permitted.
    -   Enhancement: Improved `isinstance` type narrowing logic to retain type arguments in cases where the corresponding type parameter is bound or constrained.
    -   Bug Fix: Fixed bug that resulted in a false positive error indicating that an overload isn't compatible with its implementation when the overload includes a callable parameter with a type variable as a parameter.
    -   Bug Fix: Fixed a bug in type evaluation of a `Final` class variable that has no explicit type but is assigned a literal value.
    -   Bug Fix: Fixed a bug that resulted in incorrect type evaluations when a generic class using a ParamSpec was explicitly specialized using a `Concatenate` in the type argument, as in `A[Concatenate[int, P]]`.
    -   Bug Fix: Fixed a bug that resulted in incorrect type resolution when evaluating mutually-dependent variables within a loop where one of the expressions involved a call to a constructor with an unpacked argument.
    -   Bug Fix: Fixed false positive error with reportUnnecessaryIsInstance diagnostic check with the provided class is dynamic.

## 2021.12.2 (13 December 2021)

Notable changes:

-   Bug Fix: Fixed false positive when using a generic type alias that refers to a class with a `__getitem__` method.
    ([pylance-release#2161](https://github.com/microsoft/pylance-release/issues/2161))
    ([pylance-release#2169](https://github.com/microsoft/pylance-release/issues/2169))

In addition, Pylance's copy of Pyright has been updated from 1.1.194 to 1.1.195 including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Behavior Change: Changed class pattern matching behavior to support narrowing of Any or `Unknown`, exempting this case from the general "never narrow Any" rule.
    -   Behavior Change: Modified behavior for assignment-based type narrowing when the target of the assignment references an "asymmetric" descriptor or property, one where the setter accepts a different value type than the getter returns. When this is detected, assignment-based type narrowing is no longer applied.
    -   Enhancement: Added support for Python 3.11 StrEnum.
-   [1.1.195](https://github.com/microsoft/pyright/releases/tag/1.1.195)
    -   Bug Fix: Fixed bug in handling of `__slots__`. Entries listed in `__slots__` apply only to instance variables, not to class variables.
    -   Bug Fix: Fixed false positive error with reportUnnecessaryComparison diagnostic rule when one of the two operands is `type` or `Type[Any]` and the other is a class.
    -   Bug Fix: Fixed false positive when using a generic type alias that refers to a class with a `__getitem__` method.
        ([pylance-release#2161](https://github.com/microsoft/pylance-release/issues/2161))
        ([pylance-release#2169](https://github.com/microsoft/pylance-release/issues/2169))
    -   Enhancement: Implemented support for type guards that based on "aliased conditional expressions". For details and examples, refer to https://github.com/microsoft/pyright/blob/main/docs/type-concepts.md#aliased-conditional-expression.
    -   Bug Fix: Fixed a bug that caused a false positive error under certain circumstances where a function return type annotation referred to a forward-declared symbol and `from __future__ import annotations` was in effect.
        ([pylance-release#2157](https://github.com/microsoft/pylance-release/issues/2157))
    -   Enhancement: Added error for an attempt to call a module, which generates an exception at runtime.
    -   Bug Fix: Fixed bug related to ParamSpec specialization when the signature has zero parameters.
    -   Behavior Change: Changed type completeness report (the "--verifytypes" feature) to exempt symbols that derive from "**slots**" entries.
    -   Enhancement: Improved `isinstance` type narrowing when the original type is a generic class with a TypeVar as a type argument and the second argument to `isinstance` is a generic subclass of the original type. The type argument is now properly retained.

## 2021.12.1 (9 December 2021)

Notable changes:

-   Pylance now supports smart selection (shift + alt + rightArrow/leftArrow)
-   Pylance's copy of typeshed has been updated.
-   The bundled stubs for django have been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.192 to 1.1.194 including the following changes:

-   [1.1.194](https://github.com/microsoft/pyright/releases/tag/1.1.194)
    -   Bug Fix: Fixed inconsistency in definition provider where it would sometimes fail to go to a declaration if the symbol was not re-exported from a type stub or "py.typed" module.
    -   Enhancement: Added support for explicit specialization of generic type aliases that include a ParamSpec.
    -   Bug Fix: Fixed bug that resulted in the import resolution paths retrieved from the currently-selected Python interpreter to omit the working directory if it happens to be in the "sys.path" list.
    -   Bug Fix: Fixed bug in specialization of callable type where the return type includes the expansion (unpacking) of a variadic type variable.
    -   Enhancement: Improved handling of `x in y` type guard to handle the case where `y` is a tuple.
    -   Bug Fix: Fixed a bug that caused type narrowing to fail in certain cases when the "X in Y" type guard pattern was used.
    -   Bug Fix: Fixed bug that resulted in false positive when a variable was modified in a loop that employed conditional type narrowing and was also used as a member access expression.
    -   Bug Fix: Fixed a bug whereby an explicit TypeAlias definition that includes a generic type with no explicit type arguments was not assuming `Unknown` for those type arguments. For example, `A: TypeAlias = list` should assume that `A` is equivalent to `list[Unknown]`.
    -   Enhancement: Added a missing diagnostic for an attempt to specialize a class that has already been specialized. This can occur in the case of a type alias, such as `A = list[int], A[int]`.
    -   Enhancement: Added code to support `__qualname__` in class definitions.
    -   Bug Fix: PEP 484 indicates that `Type[Any]` should be interpreted as equivalent to `type`, but the previous code was treating it as `Any`.
    -   Enhancement: Added error check for the use of a generic class as a metaclass.
    -   Bug Fix: Fixed a bug that resulted in a false positive error when a dictionary literal was passed to a constructor of a generic subclass of dict.
-   [1.1.193](https://github.com/microsoft/pyright/releases/tag/1.1.193)
    -   Bug Fix: Fixed incorrect type evaluation for symbols that are modified within a context manager block that is nested within a try/except statement.
    -   Enhancement: Updated to the latest typeshed stubs. Note that type stubs for several third-party packages were recently removed from typeshed: click, flask, jinja2, markupsafe, werkzeug.
    -   Bug Fix: Fixed bug that resulted in "unknown" type evaluation for variables assigned in a loop using a tuple assignment pattern.
        ([pylance-release#2140](https://github.com/microsoft/pylance-release/issues/2140))
    -   Bug Fix: Fixed bug in TypeVar solver where Self type was being incorrectly replaced with its concrete form in some cases.
    -   Bug Fix: Fixed bug that resulted in TypeVar not being solved in some circumstances involving recursive types.
    -   Bug Fix: Fixed a bug in the handling of generic classes whose implementation includes another instantiation of itself using the original type parameters as type arguments for the nested instantiation.
    -   Bug Fix: Fixed a bug in the handling of generic classes whose implementation includes another instantiation of itself using the original type parameters as type arguments for the nested instantiation.
    -   Enhancement: Enhanced reportIncompatibleMethodOverride diagnostic check to also detect incompatible methods defined by two classes that are used as base classes in a multiple-inheritance derived class.
-   [1.1.192](https://github.com/microsoft/pyright/releases/tag/1.1.192)
    -   Enhancement: Sped up "find reference" by performing a quick text search for the reference symbol and avoiding additional work for that file if there is no chance of finding a reference within it.
    -   Bug Fix: Fixed misleading error message involving a type mismatch within the TypeVar constraint solver. The source and destination types were reversed.
    -   Bug Fix: Fixed a bug in ternary expression type evaluation that resulted in a false positive error. It was not properly handling the case where the condition was statically determined to be false or true.
    -   Enhancement: Improved error message for unknown or partially-unknown type arguments in package type verifier.
    -   Bug Fix: Added missing check in package type verifier for generic type aliases with missing type arguments.
    -   Bug Fix: Fixed bug that resulted in false positive error when a `__new__` method has its own type variables that are not scoped to its corresponding class.
    -   Bug Fix: Changed behavior of symbol resolution involving a quoted (forward-declared) type annotation that references a symbol in the global (module) or builtins namespaces. The previous implementation didn't match the runtime behavior of `typing.get_type_hints`.
    -   Bug Fix: Improved heuristics that are intended to choose the simplest type when more than one solution is possible for a set of type variables.
    -   Enhancement: Added support for class-based definition of "NewType", which will appear in a new version of typeshed stubs soon.
    -   Bug Fix: Added missing check in function type compatibility checks for the case where the source type contains position-only parameters but the destination type does not.
    -   Bug Fix: Added support for synthesized `__hash__` method for dataclass and dataclass_transform.
    -   Bug Fix: Fixed bug that resulted in false positive parse error when using "/" parameter in type stub when pythonVersion was prior to Python 3.8.

## 2021.12.0 (2 December 2021)

Notable changes:

-   Pylance now supports Go to Type Definition.
-   Performance of Find All References and Rename Symbol has been improved for large workspaces.
    ([pylance-release#2109](https://github.com/microsoft/pylance-release/issues/2109))
-   Pylance's copy of typeshed has been updated.
-   The bundled stubs for django have been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.188 to 1.1.191 including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Enhancement: Improved heuristics that are intended to choose the simplest type when more than one solution is possible for a set of type variables.
    -   Bug Fix: Fixed regression introduced in previous check-in related to type stubs that use symbol names that overlap with builtins symbols.
    -   Behavior Change: Modified symbol resolution involving a quoted (forward-declared) type annotation that references a symbol in the global (module) or builtins namespaces. The previous implementation didn't match the runtime behavior of `typing.get_type_hints`.
    -   Bug Fix: Fixed bug that resulted in false positive error when a `__new__` method has its own type variables that are not scoped to its corresponding class.
    -   Enhancement: Updated command-line documentation for consistency.
-   [1.1.191](https://github.com/microsoft/pyright/releases/tag/1.1.191)
    -   Bug Fix: Fixed bug in synthesized `__match_args__` type for dataclass, which shouldn't include any keyword-only fields. Thanks to @HKGx for this contribution.
    -   Bug Fix: Added special-casing to suppress "partially unknown type" diagnostic within member access expressions when they are used to access non-specialized generic classes within an argument expression. There are legitimate uses of partially unknown types in this case (e.g. in "isinstance" calls).
    -   Behavior Change: Exempted class symbol `__weakref__` from type completeness check since its type is well defined by the Python spec.
    -   Behavior Change: Changed reportPropertyTypeMismatch to be disabled by default in all diagnostic modes.
    -   Bug Fix: Fixed a hole in the check for partially-unknown types. Generic type aliases that are not specialized or are partially specialized (i.e. only some type arguments are specified) should trigger this check.
    -   Bug Fix: Fixed bug that resulted in a false positive error when using class pattern matching with type variables.
    -   Bug Fix: Fixed bug in "--ignoreexternal" mode of "--verifytypes" feature. It was not properly flagging errors when the type was external (and known) but the type arguments were partially unknown.
    -   Enhancement: Enhanced truthy/falsy type narrowing pattern to handle classes that contain a `__bool__` method that always returns True or False.
    -   Enhancement: Changed parse error messages related to unclosed parentheses, braces and brackets so they are reported at the location of the starting token to better match the new Python 3.10 parse error reporting behavior.
        ([pylance-release#2118](https://github.com/microsoft/pylance-release/issues/2118))
-   [1.1.190](https://github.com/microsoft/pyright/releases/tag/1.1.190)
    -   Bug Fix: Fixed bug that caused false positive when evaluating type compatibility between two TypedDict types that are structurally the same but have different declarations. PEP 589 indicates that these should be treated as compatible types.
    -   Bug Fix: In the case where a type annotation is an illegal form (e.g. a variable or a function), the annotation should evaluate to an Unknown type.
    -   Enhancement: Added support for async functions that return `NoReturn` type.
    -   Bug Fix: Fixed bug that prevented error when a generator function returned an inappropriate type if that type was a subclass of `Iterable`.
        ([pylance-release#2127](https://github.com/microsoft/pylance-release/issues/2127))
    -   Bug Fix: Fixed bug that resulted in unreported Unknown type in strict mode when the type was evaluated as part of a call to an overloaded function in some circumstances.
    -   Enhancement: Updated typeshed stubs to the latest.
    -   Bug Fix: Improved check for inconsistent use of tabs and spaces to catch a previously-unreported case that generates runtime errors.
    -   Bug Fix: Added a type consistency check for TypedDicts which are otherwise compatible except that one is marked @final and the other is not.
    -   Behavior Change: Changed reportUnusedVariable diagnostic check to exempt variables whose names begin with an underscore.
    -   Behavior Change: Changed logic that determines whether a function should be exempt from return type consistency checks. If a function or method contains only a docstring but no `...`, it is no longer exempt (unless it is an `@overload`). ([pylance-release#2111](https://github.com/microsoft/pylance-release/issues/2111))
-   [1.1.189](https://github.com/microsoft/pyright/releases/tag/1.1.189)
    -   Bug Fix: Fixed regression relating to type inference for non-generic classes that have unannotated constructors (so-called "pseudo-generic classes").
    -   Bug Fix: Fixed crash that occurred when specializing a class with a TypeVarTuple and failing to provide a type argument for the TypeVarTuple type parameter.
    -   Bug Fix: Fixed recent regression in import resolver that caused a local import to no longer be preferred over an installed module by the same name.
    -   Bug Fix: Fixed bug that caused incorrect type evaluation of parameter with implied Optional type based on `None` default argument value when `strictParameterNoneValue` setting is false.
        ([pylance-release#2091](https://github.com/microsoft/pylance-release/issues/2091))
    -   Enhancement: Added checks for illegal forms of `Literal` type arguments.
    -   Bug Fix: Fixed false positive error when using a union type expression in an `isinstance` or `issubclass` call on Python 3.10.
    -   Bug Fix: Fixed bug in code flow engine that caused incorrect determination of node reachability in cases where an unannotated function recursively called itself.
    -   Bug Fix: Fixed a hole in the type checking logic for TypedDict classes. It was not properly handling the invariant case.
    -   Behavior Change: Made illegal assignment target checks unconditional so they are not gated by reportGeneralTypeIssues. These should be treated more like parse errors than type checking errors.
-   [1.1.188](https://github.com/microsoft/pyright/releases/tag/1.1.188)
    -   Bug Fix: Fixed issue that caused import resolution failures for certain submodules of `google.cloud`.
    -   Bug Fix: Fixed crash in completion provider.
    -   Bug Fix: Fixed bug in ParamSpec type evaluation that caused a false positive error when assigning a callable with a `Concatenate` to another `ParamSpec`.
    -   Bug Fix: Fixed bug in ParamSpec logic that resulted in false positive when a TypeVar was used as within a Concatenate expression.
    -   Bug Fix: Fixed bug in type evaluator that resulted in false positive error in strict mode. Type of call argument expression was incorrectly reported as partially unknown in some cases.
    -   Bug Fix: Fixed bug that resulted in a false positive when a tuple with known element types is used as an unpacked argument in a call to a function that uses position-only parameters.
        ([pylance-release#2083](https://github.com/microsoft/pylance-release/issues/2083))
    -   Bug Fix: Fixed type checking hole (false negative) in certain circumstances involving loop constructs and variables whose types are modified within these loops. This bug fix also has a positive performance impact when analyzing functions with complex code flow graphs.
        ([pylance-release#1979](https://github.com/microsoft/pylance-release/issues/1979))
    -   Bug Fix: Fixed issue that caused CLI version of pyright to use incorrect Python interpreter to discover the Python version when no "pythonVersion" configuration setting was supplied.
    -   Enhancement: Implemented diagnostic check for a `ClassVar` declaration that uses a type variable. PEP 526 explicitly states that this is not allowed.

## 2021.11.2 (17 November 2021)

Notable changes:

    -   Intellicode context now includes collections.
    -   Pylance's copy of typeshed has been updated.
    -   The bundled stubs have been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.186 to 1.1.187 including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: Fixed bug in type evaluator that resulted in false positive error in strict mode. Type of call argument expression was incorrectly reported as partially unknown in some cases.
    -   Bug Fix: Fixed style issue.
    -   Bug Fix: Fixed bug in ParamSpec logic that resulted in false positive when a TypeVar was used as within a Concatenate expression.
    -   Bug Fix: Fixed bug in ParamSpec type evaluation that caused a false positive error when assigning a callable with a `Concatenate` to another `ParamSpec`.
    -   Bug Fix: Fixed crash in completion provider.
    -   Bug Fix: Fixed issue that caused import resolution failures for certain submodules of `google.cloud`.
-   [1.1.187](https://github.com/microsoft/pyright/releases/tag/1.1.187)
    -   Bug Fix: Fixed false positive error when assigning type `T | Any` to type `T`.
        ([pylance-release#2054](https://github.com/microsoft/pylance-release/issues/2054))
    -   Behavior Change: Changed `Callable` special form to include a position-only marker at the end of the parameter list. Changed type printer to omit the `/` if it is unnecessary.
    -   Behavior Change: Modified the check for function declaration redefinitions to allow for same-signature overrides in cases where the declarations are not within the same statement suite (e.g. one in the "if" and the other in the "else" block).
    -   Bug Fix: Fixed missing diagnostic when a Self parameter was assigned to a `Concatenate[X, P]` where `X` is a type that is incompatible with `Self`.
    -   Bug Fix: Fixed bug that resulted in a false positive error when a specialized generic class with a `__call__` method uses a ParamSpec and is assigned to a `Callable` that is also parameterized with a ParamSpec.
    -   Enhancement: Updated typeshed stubs to the latest.
    -   Bug Fix: Fixed bug that resulted in hover text for symbols used within a default argument expression to sometimes be displayed as "Unknown".
        ([pylance-release#2064](https://github.com/microsoft/pylance-release/issues/2064))
    -   Bug Fix: Fixed regression in handling of callback protocols that define a `__name__` attribute, which is common to all functions.
    -   Behavior Change: Added support for upcoming change in typing.pyi in the way that the `NoReturn` symbol is declared.

## 2021.11.1 (10 November 2021)

Notable changes:

-   Bug fix: Fixed semantic token bug involving file opened and closed repeatedly in a short period times.

In addition, Pylance's copy of Pyright has been updated from 1.1.185 to 1.1.186 including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: Fixed missing diagnostic when a Self parameter was assigned to a `Concatenate[X, P]` where `X` is a type that is incompatible with `Self`.
    -   Enhancement: Modified the check for function declaration redefinitions to allow for same-signature overrides in cases where the declarations are not within the same statement suite (e.g. one in the "if" and the other in the "else" block).
    -   Enhancement: Changed isTypeSame function to handle functions whose signatures include position-only parameters. Also added support for inferred return types and eliminated the check for declaration parity. This allows two function types to be deemed the same even if they originate from different declarations.
    -   Enhancement: Changed Callable special form to include a position-only marker at the end of the parameter list. Changed type printer to omit the `/` if it is unnecessary.
    -   Bug Fix: Fixed false positive error when assigning type T | Any to type T. ([pylance-release#2054](https://github.com/microsoft/pylance-release/issues/2054))
-   [1.1.186](https://github.com/microsoft/pyright/releases/tag/1.1.186)
    -   Enhancement: Added checks for incorrect runtime usage of a UnionType object.
    -   Enhancement: Added more complete type checks involving the use of a default argument for a generic parameter in a constructor.
    -   Bug Fix: Fixed a bug that resulted in a false positive error when accessing members from a `type` instance or a `Type[T]`.
    -   Bug Fix: Fixed false positive error related to heuristics employed in bidirectional type inference for calls when the expected type comprises a union and the return type of the call is a union that includes Any and a type variable.
    -   Enhancement: Added support for `slots` parameter to dataclass, a new feature added in Python 3.10.
    -   Bug Fix: Fixed regression that caused a false positive error related to incorrect usage of a type variable within a type alias definition.
    -   Bug Fix: Fixed incorrect handling of client-initiated progress reporting for "onReferences" and "onExecuteCommand" handlers in language server.
-   [1.1.185](https://github.com/microsoft/pyright/releases/tag/1.1.185)
    -   Bug Fix: Fixed bug in completion provider where it was not properly handling binding to classes, which left parameter types unspecialized in some cases. It was already properly handling binding to objects (class instances), so this was a straightforward extension.
    -   Enhancement: Added support in completion provide for enum members. They are now properly identified as such and prioritized higher in the completion list than other non-member symbols. ([pylance-release#1977](https://github.com/microsoft/pylance-release/issues/1977))
    -   Enhancement: Improved readability of diagnostic message for type mismatch when assigning to a tuple expression. ([pylance-release#2020](https://github.com/microsoft/pylance-release/issues/2020))
    -   Bug Fix: Fixed a bug in the handling of `reveal_type` that caused hover text within the argument to be displayed as `Unknown` in some circumstances. ([pylance-release#2024](https://github.com/microsoft/pylance-release/issues/2024))
    -   Enhancement: Added special-case support for the `__self__` attribute of a bound method.
    -   Bug Fix: Fixed bug that resulted in stack overflow.
    -   Bug Fix: Fixed bug in stub generation code that resulted in an error if a stub was requested for a submodule in a package that includes an `__init__.py` file in the same directory as the submodule source file. ([pylance-release#2013](https://github.com/microsoft/pylance-release/issues/2013))
    -   Enhancement: Improved signature help for the constructor of classes that define a `__new__` method but no `__init__` method, such as the `zip` class. The previous logic was always preferring the `__init__`, which is supplied by the `object` class, which all classes derive from. ([pylance-release#1912](https://github.com/microsoft/pylance-release/issues/1912))
    -   Bug Fix: Fixed a bug that resulted in a false positive error when assigning one ParamSpec to another ParamSpec.
    -   Bug Fix: Fixed bug that resulted in false positive "reportUnknownMemberType" error when using a generic class within a class pattern.
    -   Bug Fix: Added missing diagnostic check for illegal type argument lists that include a ParamSpec when the type parameter list includes a ParamSpec.
    -   Enhancement: Added missing keyword "with" from completion provider. ([pylance-release#2042](https://github.com/microsoft/pylance-release/issues/2042))
    -   Bug Fix: Fixed bug in type promotion logic that resulted in false positive. It wasn't properly handling subclasses of promotable types (like 'int', which can be promoted to 'float').
    -   Enhancement: Improved bidirectional type inference for call expressions. The logic now handles the case where the return type of the callable is a generic type that is not an exact match for the expected type but is assignable to the expected type.
    -   Enhancement: Added support for explicit type aliases (PEP 613) within class scopes. A proposed amendment to PEP 613 will make this legal.
    -   Enhancement: Added check for a class-scoped generic type alias that uses a class-scoped TypeVar. This is now flagged as an error.

## 2021.11.0 (3 November 2021)

Notable changes:

-   Enum member values are now appear before other enum class members in completions.
    ([pylance-release#1977](https://github.com/microsoft/pylance-release/issues/1977))
-   Type mismatch errors involving tuples are now more descriptive.
    ([pylance-release#2020](https://github.com/microsoft/pylance-release/issues/2020))
-   Pylance's copy of typeshed has been updated.
-   The bundled stubs for django have been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.183 to 1.1.184 including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Enhancement: Improved signature help for the constructor of classes that define a `__new__` method but no `__init__` method, such as the `zip` class. The previous logic was always preferring the `__init__`, which is supplied by the `object` class, which all classes derive from. ([pylance-release#1912](https://github.com/microsoft/pylance-release/issues/1912))
    -   Bug Fix: Fixed bug in stub generation code that resulted in an error if a stub was requested for a submodule in a package that includes an `__init__.py` file in the same directory as the submodule source file. ([pylance-release#2013](https://github.com/microsoft/pylance-release/issues/2013))
    -   Bug Fix: Fixed overflow.
    -   Enhancement: Increased stack trace limit from default to 256 in pyright VS Code extension to facilitate debugging of stack overflow errors.
    -   Enhancement: Added special-case support for the **self** attribute of a bound method.
    -   Bug Fix: Fixed a bug in the handling of reveal_type that caused hover text within the argument to be displayed as `Unknown` in some circumstances. ([pylance-release#2024](https://github.com/microsoft/pylance-release/issues/2024))
    -   Enhancement: Improved readability of diagnostic message for type mismatch when assigning to a tuple expression. ([pylance-release#2020](https://github.com/microsoft/pylance-release/issues/2020))
    -   Enhancement: Added support in completion provide for enum members. They are now properly identified as such and prioritized higher in the completion list than other non-member symbols. ([pylance-release#1977](https://github.com/microsoft/pylance-release/issues/1977))
    -   Bug Fix: Fixed bug in completion provider where it was not properly handling binding to classes, which left parameter types unspecialized in some cases. It was already properly handling binding to objects (class instances), so this was a straightforward extension.
-   [1.1.184](https://github.com/microsoft/pyright/releases/tag/1.1.184)
    -   Bug Fix: Fixed false positive error when a class used within as a TypeVar `bound` argument is a "pseudo generic" class, one whose constructor is unannotated. ([pylance-release#2017](https://github.com/microsoft/pylance-release/issues/2017))
    -   Bug Fix: Changed type evaluator to elide `NoReturn` from union generated from `or` or `and` operator.
    -   Enhancement: Improved error handling for the `Generic` special form. Eliminated false positive error when `Generic` is used in certain legitimate ways within a function.
    -   Enhancement: Improved error messages for call expressions that involve overloaded functions. ([pylance-release#1982](https://github.com/microsoft/pylance-release/issues/1982))
    -   Enhancement: Implemented optimization that reduces analysis time and memory usage by generating a diagnostic message (which often involve converting types to a textual representation) only if the caller is interested in the diagnostic message.
    -   Enhancement: Added support for "Self" type documented in draft PEP: https://docs.google.com/document/d/1ujuSMXDmSIOJpiZyV7mvBEC8P-y55AgSzXcvhrZciuI/edit.
    -   Enhancement: Added support for trace logging of type evaluation from the command line when both `--stats` and `--verbose` are specified.
    -   Bug Fix: Fixed bug that resulted in the incorrect type evaluation when a property was defined on a metaclass and accessed through a class with that metaclass.
-   [1.1.183](https://github.com/microsoft/pyright/releases/tag/1.1.183)
    -   Bug Fix: Fixed bug in handling of the recently-added "--skipunannotated" command-line flag.
    -   Bug Fix: Fixed a recent regression that resulted in a false positive error when `Union` was used with no type arguments outside of a type annotation. [pylance-release#2014](https://github.com/microsoft/pylance-release/issues/2014))
    -   Enhancement: Extended support for bidirectional type inference for functions that have a generic return type and the "expected type" is a generic class with type arguments that include literal types.
    -   Enhancement: Expanded support for bidirectional type checking for function call expressions where the return type of the function includes a TypeVar that also appears within a function parameter and that parameter is a callable.
    -   Bug Fix: Fixed bug that resulted in incorrect type evaluation for a generic function that returns a specialized class that uses a `Concatenate` in one of the type arguments.
    -   Bug Fix: Fixed bug that caused the type of `super().__new__(cls)` to be evaluated incorrectly.
    -   Bug Fix: Changed type evaluator to elide `NoReturn` from union generated from ternary operator. ([pylance-release#2008](https://github.com/microsoft/pylance-release/issues/2008))
    -   Bug Fix: Fixed a bug that allowed a function to be assigned to a (non-protocol) class if that class defined a `__call__` method. This should be allowed only for protocol classes.
    -   Bug Fix: Fixed a bug that allowed a function to be assigned to a protocol class if it defined a `__call__` method but also defined additional methods or attributes. ([pylance-release#2006](https://github.com/microsoft/pylance-release/issues/2006))
    -   Behavior Change: Changed text representation of inferred type of `self` and `cls` parameters to `Self@ClassName`. This is more consistent with the emerging standard for an explicit `Self` type.

## 2021.10.3 (27 October 2021)

Notable changes:

-   Analysis performance has been improved for large and complicated functions, such as those in `scipy` and `sympy`.
    ([pylance-release#1964](https://github.com/microsoft/pylance-release/issues/1964))
-   Pylance's copy of typeshed has been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.181 to 1.1.182 including the following changes:

-   [1.1.182](https://github.com/microsoft/pyright/releases/tag/1.1.182)
    -   Enhancement: Implemented missing check for a write to a Final instance or class variable outside of the class implementation.
    -   Enhancement: Added missing check for an attempt to write to a named tuple attribute, which generates a runtime exception.
        ([pylance-release#1976](https://github.com/microsoft/pylance-release/issues/1976))
    -   Bug Fix: Fixed bug that resulted in a false positive when a function returned a callable type that included a parameter with a union type that included an unsolved type variable.
    -   Bug Fix: Improved handling of intersection types produced as part of `isinstance` or `issubclass` type narrowing when the source variable is a type variable. The creation of the intersection type was incorrectly eliminating the association with the type variable, so the narrowed type was no longer seen as compatible with the TypeVar.
    -   Enhancement: Added check for `Union` when only one type argument is provided and it is not an unpacked variadic type variable.
    -   Bug Fix: Fixed bug in "--ignoreexternal" option used with package type verification. It was not correctly ignoring all externally-imported symbols that had unknown or partially-unknown types.
    -   Enhancement: Updated typeshed stubs to latest.
    -   Bug Fix: Fixed false positive error when a constrained TypeVar T and Type[T] were both used in the same function signature.
-   [1.1.181](https://github.com/microsoft/pyright/releases/tag/1.1.181)
    -   Enhancement (from pylance): Improved completion suggestions when typing within a list expression.
    -   Enhancement: Updated typeshed stubs to the latest.
    -   Bug Fix: Fixed bug in type printing logic where it incorrectly displayed captured ParamSpec signature with "/" or "\*" parameters.
    -   Bug Fix: Fixed bug that caused false positive error when assigning one callback protocol to another when both protocols are generic and parameterized with a ParamSpec.
    -   Bug Fix (from pylance): Fixed regression with "--watch" option in command-line version of pyright.
    -   Behavior Change (from pylance): Increase max file size to 50 MB, matching VS Code.
    -   Enhancement: Improved logic for isinstance and issubclass type narrowing when the filter class's type arguments can be determined from the type arguments of the subject type.
    -   Enhancement: Improved type narrowing logic for class pattern matching when the matched class's type arguments can be determined from the type arguments of the subject type.
    -   Bug Fix: Fixed bug that resulted in an incorrect type evaluation for a binary operator that acts upon a bound TypeVar.
    -   Performance: Reduced the max number of nested call-site return type inference evaluations from 3 to 2. This can be extremely expensive in some code bases, such as with scipy, and it was leading to a poor user experience.
        ([pylance-release#1964](https://github.com/microsoft/pylance-release/issues/1964))
    -   Performance: Improved analyzer performance for code that contains thousands of statements with tens of thousands of call statements within a single function or module. This is found in some test modules within the sympy library.
    -   Enhancement: Added "--skipunannotated" option for command-line version of pyright. If specified, pyright skips type analysis of functions and methods that have no parameter or return type annotations. Return types of functions are also never inferred from the function implementation. This matches the default behavior of mypy and allows for more efficient analysis of complex code bases that are only partially annotated.

## 2021.10.2 (20 October 2021)

Notable changes:

-   A bug related to missing completions inside lists and tuples has been fixed.
    ([pylance-release#1302](https://github.com/microsoft/pylance-release/issues/1302))
-   The bundled stubs for django have been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.179 to 1.1.180 including the following changes:

-   [1.1.180](https://github.com/microsoft/pyright/releases/tag/1.1.180)
    -   Bug Fix: Fixed bug that resulted in a false positive error when a generic class used a specialized version of itself parameterized with one of its own type parameters.
    -   Bug Fix: Fixed recent regression where imported symbols that were ultimately resolved with a native library (e.g. a ".pyd" or ".so" file) were incorrectly resolved as a module rather than an Unknown type.
        ([pylance-release#2446](https://github.com/microsoft/pylance-release/issues/2446))
    -   Bug Fix: Fixed a type evaluation regression that caused type arguments to be incorrectly determined when calling a constructor and passing a callable that is generic.
    -   Enhancement: Added broader support for context managers in with statements which swallow exceptions. Thanks to Rik de Graaff for this contribution.
        ([pylance-release#1945](https://github.com/microsoft/pylance-release/issues/1945))
    -   Bug Fix: Added missing error condition for walrus operator used within a type annotation expression.
    -   Bug Fix: Fixed bug in pattern matching type evaluation where `bytearray` was matched against a sequence pattern even though PEP 634 explicitly excludes this case.
    -   Enhancement: Added support for sequence pattern match type narrowing when the subject type is a simple "object".
    -   Enhancement: Added support for type narrowing of enums when using pattern matching.
    -   Enhancement: Added error reporting for usage of type aliases within class pattern matching statements that generate runtime exceptions.
    -   Behavior Change: Changed the printed type of a ParamSpec signature to avoid the use of synthesized parameter names "\_\_p0", etc. Instead, the parameter names are omitted in the signature consistent with the emerging standard for the improved callable syntax.
    -   Enhancement: Added support for explicit specialization of generic classes that include a ParamSpec. This is defined in PEP 612 but was previously missing.
    -   Bug Fix: Fixed bug in check for generator return type. A diagnostic was meant to be generated if the declared return type was incorrect for a generator.
-   [1.1.179](https://github.com/microsoft/pyright/releases/tag/1.1.179)
    -   Enhancement: Added support for an unpacked tuple assignment within an instance method when the source of the assignment is the `self` parameter.
    -   Bug Fix: Fixed false positive error in protocol variance check (in the `reportInvalidTypeVarUse` diagnostic rule) when a protocol class used a ParamSpec.
    -   Bug Fix: Fixed bug that caused false positive errors when generic callback protocol class used a ParamSpec and a `__call__` method with only two parameters consisting of `P.args` and `P.kwargs`.
    -   Bug Fix: Fixed bug that resulted in a false positive error when using a generic callback protocol with a ParamSpec where the `__call__` method included a positional-only marker prior to the `P.args` and `P.kwargs` parameters.
    -   Bug Fix: Fixed a bug that results in false positive error when assigning a source union type to a destination union type.
    -   Bug Fix: Fixed an internal crash that was caused by infinite recursion.
    -   Bug Fix: Fixed bug in completion provider that resulted in inappropriate suggestions when typing arguments within a class declaration.
    -   Bug Fix: Changed type logic for sequence pattern matching to produce `list` rather than `tuple` for star subpatterns. This matches the runtime behavior in Python 3.10.
    -   Enhancement: Added support for name expressions in `with` statements where the name refers to a variable or parameter with a declared type that corresponds to a context manager class that swallows exceptions.
    -   Bug Fix: Fixed bug that resulted in a false positive error when a generic class used a specialized version of itself parameterized with one of its own type parameters.

## 2021.10.1 (14 October 2021)

Notable changes:

-   A bug in the import completion that prevented some absolute imports from being suggested has been fixed.
-   Variables named `match` no longer cause a parser error when used in a slice expression.
    ([pylance-release#1911](https://github.com/microsoft/pylance-release/issues/1911))
-   `TypedDict` completions now work correctly in `dict` literals with more than one key-value pair.
    ([pylance-release#1920](https://github.com/microsoft/pylance-release/issues/1920)
-   The bundled stubs for pandas, django and openpyxl have been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.176 to 1.1.178, including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Enhancement: Added support for an unpacked tuple assignment within an instance method when the source of the assignment is the `self` parameter.
-   [1.1.178](https://github.com/microsoft/pyright/releases/tag/1.1.178)
    -   Bug Fix: Fixed false positive error that occurred when importing a symbol in a `from x import y` statement that referred to a chain of imports and was eventually resolved to a native library (e.g. ".pyd" or ". so" file).
    -   Bug Fix: Added missing check for type compatibility between callables where the destination type includes a default argument for a parameter but the source type does not.
    -   Bug Fix: Fixed bug that caused incorrect evaluation of inferred return type based on inferred type of unannotated "self" or "cls" parameter.
        ([pylance-release#1927](https://github.com/microsoft/pylance-release/issues/1927))
    -   Enhancement: Added support for "narrowing" of TypedDict instances on assignment when the TypedDict defines entries that are not required but are supplied.
        ([pylance-release#1926](https://github.com/microsoft/pylance-release/issues/1926))
    -   Behavior Change: Changed the interpretation of a property declared within a protocol class. It was previously interpreted only as a property (i.e. classes compatible with the protocol must implement a property of the same name). Compatible classes are now able to declare an attribute whose type is compatible with the property getter. Access to the property from the protocol class as a class variable is no longer allowed.
        ([pylance-release#1915](https://github.com/microsoft/pylance-release/issues/1915))
    -   Enhancement: Improved error message for improper use of a module as a type argument.
    -   Bug Fix: Fixed a bug in import resolution logic that resulted in incorrect resolution of a symbol in the presence of wildcard imports that allowed for multiple resolution paths, some of them cyclical. Pyright previously gave up when it detected a cycle rather than using a different (non-cyclical) resolution path.
    -   Bug Fix: Improved parser's detection of "match" as a soft keyword versus some other usage of a symbol named "match".
        ([pylance-release#1911](https://github.com/microsoft/pylance-release/issues/1911))
    -   Bug Fix: Fixed bug that resulted in a false negative when a TypedDict value was assigned to a protocol that included attributes that matched the TypedDict keys.
    -   Bug Fix: Fixed bug that resulted in false positive when a function is used in an `==` or `!=` binary expression.
    -   Bug Fix (from pylance): Fixed bug in import completions for parent directory resolution.
-   [1.1.177](https://github.com/microsoft/pyright/releases/tag/1.1.177)
    -   Bug Fix: Fixed bug in stub generation logic. It wasn't properly handling module paths with more than a single ".", such as "google.cloud.storage".
    -   Bug Fix: Fixed false positive error in certain cases where type variable was bound to a union.
    -   Enhancement: Implemented check for an attempt to subclass an Enum class that defines one or more enumerated values. This condition generates a runtime exception.
    -   Enhancement: Type aliases in the printed form of a union type are retained when aliased types are combined in a union.
    -   Bug Fix: Fixed bug in completion provider's handling of key completions for TypedDicts.
        ([pylance-release#1920](https://github.com/microsoft/pylance-release/issues/1920))
    -   Bug Fix: Fixed false positive type evaluation error when constrained TypeVar is assigned to a union that contains a compatible constrained TypeVar.
    -   Bug Fix: Added code to work around the circular definition found in the typeshed stub that defines the os.scandir function.
        ([pylance-release#1918](https://github.com/microsoft/pylance-release/issues/1918))
-   [1.1.176](https://github.com/microsoft/pyright/releases/tag/1.1.176)
    -   Enhancement: Exempted check for unsafe access to TypedDict key if it's within a context manager. It was previously exempted if included in a `try` block, but some prefer to use a context manager to catch exceptions.
    -   Behavior Change: Bumped pyright's default Python version from 3.9 to 3.10.
    -   Enhancement: Added support for "bare" `ClassVar` annotations.
    -   Enhancement: Updated to the latest version of typeshed stubs.
    -   Enhancement: Added new "--warnings" command-line option that generates an exit code of 1 if one or more warnings are emitted. By default, only errors generate an exit code of 1.
    -   Bug Fix: Fixed bug that resulted in a "unknown member of module" error if the member referred to a submodule that was imported privately from another module but that submodule was also explicitly imported. For example, if a module imports both `a` and `a.b` and then uses the symbol `a.b.c`.
    -   Enhancement: Added new diagnostic check "reportMissingParameterType" that checks for function and method input parameters that are missing a type annotation.
    -   Enhancement: Added support for new type guard pattern: `x[I] is None` and `x[I] is not None` where `x` is a tuple or union of tuples with known lengths and entry types and `I` is an integer.
    -   Enhancement: Enhanced the stub generation logic to emit `__all__ = ...` and `__all__ += ...` statements when they appear in the module scope and are not within a conditional (if/else) block.

## 2021.10.0 (6 October 2021)

Notable changes:

-   Return type inference is now skipped for high-complexity unannotated functions, which prevents hangs in `sympy`, `scipy`, and other unannotated libraries.
    ([pylance-release#946](https://github.com/microsoft/pylance-release/issues/946), [pylance-release#1890](https://github.com/microsoft/pylance-release/issues/1890), [pylance-release#1895](https://github.com/microsoft/pylance-release/issues/1895))
-   The bundled stubs for pandas have been updated.
-   Pylance's copy of typeshed has been updated.
    ([pylance-release#1909](https://github.com/microsoft/pylance-release/issues/1909))

In addition, Pylance's copy of Pyright has been updated from 1.1.173 to 1.1.175, including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Enhancement: Updated typeshed stubs to the latest.
    -   Enhancement: Added support for "bare" ClassVar annotations.
    -   Enhancement: Bumped pyright's default Python version from 3.9 to 3.10.
    -   Behavior Change: Exempted check for unsafe access to TypedDict key if it's within a context manager. It was previously exempted if included in a `try` block, but some prefer to use a context manager to catch exceptions.
-   [1.1.175](https://github.com/microsoft/pyright/releases/tag/1.1.175)
    -   This is a "hot fix" release that addresses two regressions introduced in 1.1.174.
    -   Bug Fix: Reverted a change that broke the use of generic dataclass types.
    -   Bug Fix: Reverted a change that resulted in a false positive error when subclassing an Enum base class that defined no enumerated values.
-   [1.1.174](https://github.com/microsoft/pyright/releases/tag/1.1.174)
    -   Behavior Change: Modified import resolution logic to handle namespace stub packages. This case isn't explicitly covered by PEP 561, but there is a proposal to amend the PEP to clarify how to handle this case.
    -   Bug Fix: Fixed bug that resulted in a false negative when dealing with types that are conditioned on constrained or bound TypeVars.
    -   Bug Fix: Fixed bug that affected a missing type argument for a ParamSpec type parameter. It should be an Unknown type.
    -   Bug Fix: Fixed bug that resulted in an `Unknown` type appearing in a type evaluation for an unannotated variable that is modified in a loop.
    -   Enhancement: Added error reporting for an attempt to subclass an Enum class and a duplicate definition of enum members.
    -   Enhancement: Improved error reporting for index expressions used for non-generic classes.
    -   Enhancement: Fixed performance issue in stub generation code that caused stub generation to take longer than needed.
    -   Enhancement: Added performance improvement that skips return type inference for functions whose parameters are not annotated and have a "code flow complexity" beyond a certain threshold.
        ([pylance-release#946](https://github.com/microsoft/pylance-release/issues/946), [pylance-release#1890](https://github.com/microsoft/pylance-release/issues/1890), [pylance-release#1895](https://github.com/microsoft/pylance-release/issues/1895))
    -   Bug Fix: Fixed bug the resulted in a false positive when an overloaded function is passed as an argument to a function that accepts a callable parameter using generics.
    -   Bug Fix: Fixed a false positive error when a class with an overloaded constructor is passed as an argument to a callable parameter.
    -   Bug Fix: Fixed bug in type var matching logic that resulted in a false positive when using a generic class that conforms to a generic protocol and uses that protocol within its own method signatures.
        ([pylance-release#1807](https://github.com/microsoft/pylance-release/issues/1807))
-   [1.1.173](https://github.com/microsoft/pyright/releases/tag/1.1.173)
    -   Bug Fix: Fixed a false positive error with the new union syntax when the LHS expression is an Any or Unknown type.
    -   Enhancement: Updated typeshed stubs to the latest.
    -   Bug Fix: Fixed bug in ParamSpec specialization code that can occur when using a generic type alias with a ParamSpec.
    -   Bug Fix: Fixed false positive error when assigning a callable to a callback protocol that includes a ParamSpec.
    -   Bug Fix: Fixed bug that resulted in unbound variable condition not being reported if it was in a loop and was assigned conditionally.
    -   Bug Fix: Fixed bug relating to the use of an `Any` type argument corresponding to a ParamSpec type parameter.
        ([pylance-release#1892](https://github.com/microsoft/pylance-release/issues/1892))
    -   Bug Fix: Fixed a false positive error when using a generic descriptor class that is parameterized by the `self` or `cls` parameter of the class that allocates the descriptor.
    -   Enhancement: Added check for inappropriate use of a field annotated with `InitVar`.
    -   Bug Fix: Fixed bug that resulted in a false positive error when a protocol class used generic type parameters scoped to a method.

## 2021.9.4 (29 September 2021)

Notable changes:

-   Completion is now supported for TypedDict keys and values. Thanks to Robert Cragie for this contribution!
-   Variables captured by lambdas and functions are now narrowed when they are known to not be reassigned.
    ([pylance-release#261](https://github.com/microsoft/pylance-release/issues/261), [pylance-release#1016](https://github.com/microsoft/pylance-release/issues/1016))
-   Auto-imports no longer incorrectly add to `*` import lines.
    ([pylance-release#1679](https://github.com/microsoft/pylance-release/issues/1679))
-   The "Add Optional to Type Annotation" quick fix no longer fails to run.
    ([pylance-release#1873](https://github.com/microsoft/pylance-release/issues/1873))
-   Pylance's copy of typeshed has been updated.
    ([pylance-release#1872](https://github.com/microsoft/pylance-release/issues/1872))

In addition, Pylance's copy of Pyright has been updated from 1.1.170 to 1.1.172, including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: Fixed a false positive error with the new union syntax when the LHS expression is an Any or Unknown type.
        ([pylance-release#1886](https://github.com/microsoft/pylance-release/issues/1886))
    -   Bug Fix: Fixed bug in ParamSpec specialization code that can occur when using a generic type alias with a ParamSpec.
    -   Bug Fix: Fixed false positive error when assigning a callable to a callback protocol that includes a ParamSpec.
-   [1.1.172](https://github.com/microsoft/pyright/releases/tag/1.1.172)
    -   Enhancement: Added completion suggestion support for TypedDict keys and values. Thanks to Robert Cragie for this contribution!
    -   Behavior Change: Changed behavior of reportInvalidTypeVarUse diagnostic check to flag bound type variables used as type arguments within return type annotations.
    -   Enhancement: Implemented code that applies type narrowing to local variables and parameters when they are captured by an inner-scoped lambda or function and the variable or parameter is not reassigned after the lambda or function along any code flow paths.
    -   Enhancement: Updated typeshed stubs to the latest.
    -   Bug Fix: Fixed a bug in ParamSpec handling that resulted in false positives when a callable type containing a ParamSpec was assigned to another callable type containing a ParamSpec.
    -   Enhancement (from pylance): Improved handling of type checking when files are opened in "single file" mode, rather than opening a project root directory.
    -   Enhancement (from pylance): Implemented heuristic for detecting import roots within a project. Previously, these all needed to be specified through "extraPaths" settings, but now pyright is smarter about locating these directories automatically.
    -   Bug Fix: Fixed false positive error when a generic class with a ParamSpec type parameter implements a descriptor protocol.
-   [1.1.171](https://github.com/microsoft/pyright/releases/tag/1.1.171)
    -   Bug Fix: Fixed bug in TypeVarTuple support that prevented the use of an unpacked TypeVarTuple within a type argument list for types other than Tuple or Union.
    -   Bug Fix: Fixed bug in synthesized `__new__` method for NamedTuple class that caused the constructor of subclasses of the NamedTuple to construct the base class.
    -   Bug Fix: Fixed bug where a class whose constructor is unannotated was allowed to have explicit generic type arguments.
    -   Behavior Change: Changed type evaluation behavior for protected instance variables (those that begin with a single underscore) and are assigned a literal value. Previously, the literal type was retained if the `reportPrivateUsage` was enabled. This caused various problems. It was a bad idea because type evaluations should not differ based on diagnostic reporting switches.
    -   Enhancement: Added logic to report a diagnostic if an instance variable is assigned only via an augmented assignment expression.
    -   Bug Fix (from pylance): Fixed bug in parser that resulted in incorrect text range for relative module names in import statements.
    -   Bug Fix: Improved inference of generator statements that involve `await` statements to conform to the runtime behavior of the CPython intepreter.
    -   Bug Fix: Fixed bug that caused inconsistent handling of dataclasses that use the `@dataclass` decorator and derive from abstract base classes.
    -   Bug Fix: Fixed bug that caused yield expression to be evaluated as "unknown" in some cases when it was contained within a loop.
    -   Bug Fix: Fixed bug that resulted in incorrect type evaluation for expressions within an `await` statement under some circumstances.
        ([pylance-release#1869](https://github.com/microsoft/pylance-release/issues/1869))
    -   Behavior Change: Changed code that converts types to textual representation to prepend a tilde ("~") character for the inferred type of a "self" or "cls" parameter.
    -   Enhancement: Updated typeshed stubs to the latest.

## 2021.9.3 (22 September 2021)

Notable changes:

-   A number of IntelliCode bugs have been fixed, including cases where starred entries would disappear when more code is typed.
    ([pylance-release#89](https://github.com/microsoft/pylance-release/issues/89))
-   Signature help should no longer trigger when typing a parenthesis in a string.
    ([pylance-release#1677](https://github.com/microsoft/pylance-release/issues/1677))
-   Pylance's copy of typeshed has been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.169 to 1.1.170, including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: Fixed bug in TypeVarTuple support that prevented the use of an unpacked TypeVarTuple within a type argument list for types other than Tuple or Union.
    -   Bug Fix: Fixed bug in synthesized `__new__` method for NamedTuple class that caused the constructor of subclasses of the NamedTuple to construct the base class.
    -   Bug Fix: Fixed bug where a class whose constructor is unannotated was allowed to have explicit generic type arguments.
        ([pylance-release#1859](https://github.com/microsoft/pylance-release/issues/1859))
    -   Behavior Change: Changed type evaluation behavior for protected instance variables (those that begin with a single underscore) and are assigned a literal value. Previously, the literal type was retained if the `reportPrivateUsage` was enabled. This caused various problems. It was a bad idea because type evaluations should not differ based on diagnostic reporting switches.
    -   Enhancement: Added logic to report a diagnostic if an instance variable is assigned only via an augmented assignment expression.
        ([pylance-release#1858](https://github.com/microsoft/pylance-release/issues/1858))
-   [1.1.170](https://github.com/microsoft/pyright/releases/tag/1.1.170)
    -   Bug Fix (from Pylance): Handle unrooted execution environments (e.g., open file mode), preventing various crashes and oddities.
    -   Bug Fix (from Pylance): Generate default values in method overload signatures. Previously, we didn't include them, which generated the wrong signature.
    -   Bug Fix (from Pylance): Use attribute docstrings for type aliases in completion and hover.
    -   Bug Fix (from Pylance): Modify parser to change the range of parenthesized expressions to their contents. This improves the ranges returned in hovers, document highlight, etc.
    -   Bug Fix: Improved member access logic to more faithfully match the Python interpreter's behavior when the member is assigned through a class, that member is a class itself, and that class has a metaclass that implements a descriptor protocol. It appears that the interpreter does not call through to the metaclass's `__set__` method in this case, even though it does call its `__get__` method when the member is accessed in the same circumstance.
    -   Enhancement: Extended reportCallInDefaultInitializer diagnostic check to disallow list, set or dict expressions in default argument expression.
    -   Bug Fix: Improved `isinstance` and `issubclass` narrowing to handle open-ended tuples passed as the second argument.
    -   Bug Fix: Fixed false positive error when `namedtuple` constructor is called with a list of field names that includes dynamic (non-literal) expressions.
        ([pylance-release#1832](https://github.com/microsoft/pylance-release/issues/1832))
    -   Bug Fix: Fixed false positive error where an exception class (as opposed to an exception object) is used in a "from" clause in a "raise" statement.
    -   Enhancement: Added support for ParamSpec matching when used within a callback protocol. PEP 612 is unclear on whether this should be supported, by pyre (the reference implementation for the PEP) does support it.
    -   Bug Fix: Fixed false negative error in parser where it did not correctly detect a syntax error when a walrus operator was used in a ternary operator condition expression.
        ([pylance-release#1838](https://github.com/microsoft/pylance-release/issues/1838))
    -   Bug Fix: Fixed bug that resulted in false negative when bidirectional type inference involved an "expected type" of Any and the type being evaluated was a call expression that returned a generic object as a return value.
    -   Bug Fix: Fixed infinite recursion bug in hover provider when a symbol referred to both a locally-defined class and an imported symbol.
    -   Bug Fix: Fixed bug that resulted in false positive when using unpack operator with `self` when `self` refers to a named tuple or a tuple with known length.
    -   Behavior Change: Allow symbols that are not explicitly re-exported from a stub to be imported into another stub. This change is required to support recent updates to typeshed.
    -   Enhancement: Updated typeshed stubs to the latest.

## 2021.9.2 (16 September 2021)

Notable changes:

-   Method override completions now correctly include default parameters.
    ([pylance-release#869](https://github.com/microsoft/pylance-release/issues/869))
-   PEP 258 style attribute docstrings now work on type aliases.
    ([pylance-release#1815](https://github.com/microsoft/pylance-release/issues/1815))
-   Parenthesized expressions are now better handled in hover, document highlight, and semantic highlighting.
    ([pylance-release#591](https://github.com/microsoft/pylance-release/issues/591))
-   A number of errors and inconsistencies with unrooted environments (like open file mode) have been fixed.
    ([pylance-release#1586](https://github.com/microsoft/pylance-release/issues/1586))
-   The docstring for `os.path.splitext` is now correctly handled.
    ([pylance-release#1408](https://github.com/microsoft/pylance-release/issues/1408))
-   The bundled stubs for pandas have been updated.
-   Pylance's copy of typeshed has been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.166 to 1.1.169, including the following changes:

-   [1.1.169](https://github.com/microsoft/pyright/releases/tag/1.1.169)
    -   Bug Fix: Improved type narrowing logic for `a is b` pattern where `a` is `self` (or a bound TypeVar) and `b` is an enum literal.
    -   Bug Fix: Updated reportIncompatibleMethodOverride diagnostic check to special-case dict key names that overlap with method names in the `_TypedDict` class.
    -   Bug Fix: Improved handling of attribute accesses for classes that inherit from `Any` or an unknown class.
    -   Enhancement: Added optimization that reduces the time it takes to perform code flow analysis in the presence of if/elf/else statements, try statements, with statements, and ternary expressions.
    -   Bug Fix: Fixed bug that caused false positive when a bound TypeVar is bound to an instantiable class (e.g. `Type[X]`).
        ([pylance-release#1808](https://github.com/microsoft/pylance-release/issues/1808))
-   [1.1.168](https://github.com/microsoft/pyright/releases/tag/1.1.168)
    -   Bug Fix: Fixed inconsistency in the constraint solver with respect to literal types. They were being retained for most classes but not for tuples.
        ([pylance-release#1802](https://github.com/microsoft/pylance-release/issues/1802))
    -   Bug Fix: Fixed bug in parser that resulted in a false negative when a `for` keyword (in either a `for` statement or a list comprehension) was followed immediately by `in` keyword.
        ([pylance-release#1805](https://github.com/microsoft/pylance-release/issues/1805))
    -   Behavior Change: Enforce PEP 484 rules for symbols that are imported by a stub file but are not meant to be re-exported. These symbols are no longer resolved when accessed outside of the module, nor are they included in completion suggestions or other language service providers.
    -   Behavior Change: Modified logic for private symbols (whose names begin with an underscore) exported from a stub file or a py.typed source file; if the symbol is explicitly included in `__all__` it is not considered private.
    -   Enhancement: Added reportPrivateImportUsage diagnostic rule, which reports usage of a symbol from a py.typed library that is not intended to be re-exported by the library's author. The rule is on by default in basic type checking mode but can be disabled. Completion provider no longer offers these symbols as completion suggestions.
    -   Bug Fix: Fixed bug that resulted in incorrect type evaluation when co-dependent variables were assigned in a loop using tuple assignments (e.g. `a, b = b, a + 1`).
    -   Bug Fix: Improved `isinstance` and `issubclass` support to handle the case where the type of the second argument is a union where the subtypes includes both tuples of class types and non-tuples.
        ([pylance-release#1809](https://github.com/microsoft/pylance-release/issues/1809))
    -   Enhancement: Updated typeshed to latest version
-   [1.1.167](https://github.com/microsoft/pyright/releases/tag/1.1.167)
    -   Bug Fix: Fixed regression that caused a false positive error when an overload implementation annotates a parameter with a union that includes a type variable.
    -   Enhancement: Added support for type annotations that are enclosed in triple quotes.
    -   Bug Fix: Fixed false positive error when a class declaration inherits from `Protocol` and `Generic`.
    -   Bug Fix: Fixed bug that resulted in a missed error (false negative) when comparing an overload implementation with an overload signature that uses a generic return type.
    -   Enhancement: Added support for a `super()` call made within a class method or instance method where the `cls` or `self` parameter is explicitly annotated (e.g. with a bound type variable).
    -   Enhancement: Extended isinstance type narrowing logic to support `Callable`.
    -   Enhancement (contribution from Matt Hillsdon): Reduced cascading parser errors when a colon is omitted before an indented code block.
    -   Bug Fix: Fixed incorrect type evaluation for ternary, list and dictionary expressions in certain cases where the expression is within a loop.
    -   Bug Fix: Fixed bug in control flow engine that resulted in incomplete types in certain cases that involved loops and circular type dependencies.

## 2021.9.1 (8 September 2021)

Notable changes:

-   Docstrings are no longer inherited from builtins like `object`.
    ([pylance-release#653](https://github.com/microsoft/pylance-release/issues/653), [pylance-release#1047](https://github.com/microsoft/pylance-release/issues/1047), [pylance-release#1205](https://github.com/microsoft/pylance-release/issues/1205))
-   Builtin module variables (like `__file__` and `__package__`) are now correctly highlighted.
    ([pylance-release#964](https://github.com/microsoft/pylance-release/issues/964))

In addition, Pylance's copy of Pyright has been updated from 1.1.165 to 1.1.166, including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: Fixed false positive error when a class declaration inherits from `Protocol` and `Generic`.
    -   Enhancement: Added support for type annotations that are enclosed in triple quotes.
    -   Bug Fix: Fixed regression that caused a false positive error when an overload implementation annotates a parameter with a union that includes a type variable.
    -   Bug Fix: Fixed bug that resulted in a missed error (false negative) when comparing an overload implementation with an overload signature that uses a generic return type.
        ([pylance-release#1778](https://github.com/microsoft/pylance-release/issues/1778))
    -   Enhancement: Added support for a super() call made within a class method or instance method where the `cls` or `self` parameter is explicitly annotated (e.g. with a bound type variable).
        ([pylance-release#1779](https://github.com/microsoft/pylance-release/issues/1779))
    -   Enhancement: Extended isinstance type narrowing logic to support `Callable`.
-   [1.1.166](https://github.com/microsoft/pyright/releases/tag/1.1.166)
    -   Bug Fix: Fixed a false positive error (and crash) when a walrus operator (assignment expression) is used within a list comprehension which is passed as an argument to a function decorator.
    -   Bug Fix: Fixed stack overflow crash in type analyzer.
        ([pylance-release#1751](https://github.com/microsoft/pylance-release/issues/1751))
    -   Bug Fix: Fixed incorrect evaluation of recursive type alias whose definition uses a `TypeAlias` annotation.
    -   Enhancement: Improved error messages for type argument count mismatch; they were referring to a "class", but sometimes they were used for type aliases as well.
    -   Bug Fix: Fixed bug that resulted in the incorrect specialization of a type alias that includes a ParamSpec.
    -   Bug Fix: Fixed bug in type verifier that resulted in incorrect reporting of an unknown type when a type alias was defined using a `TypeAlias` annotation.
    -   Enhancement: Extended dataclass_transform mechanism to support implicit `init` argument values for field descriptors.
    -   Bug Fix: Fixed false native that incorrectly allowed a union type to be assigned to a constrained TypeVar.
    -   Bug Fix: Improved handling of class properties (i.e. properties that have @classmethod applied to them). The `cls` parameter for the property method is now properly passed the class as an argument.
    -   Enhancement (contribution by Marc Mueller): Adjust auto-import sorting to better match isort.
    -   Bug Fix: Fixed bug in overlapping overload detection logic that resulted in false positives in some cases.
    -   Bug Fix: Fixed a bug that resulted in unsolved TypeVars in certain edge cases involving function type compatibility checks.
    -   Bug Fix: Improved handling of constrained type variables that use a union in one or more constraints.
    -   Bug Fix: Fixed bug that resulted in a false positive error when a call involves overloads and one or more of the arguments involves another call expression whose type is generic, and therefore influenced by bidirectional inference context.

## 2021.9.0 (1 September 2021)

Notable changes:

-   Docstrings for the `decimal` module are now supported.
    ([pylance-release#1350](https://github.com/microsoft/pylance-release/issues/1350))
-   The `None`, `True`, `False`, and `__debug__` builtin constants are now correctly colorized within quoted type annotations.
    ([pylance-release#1039](https://github.com/microsoft/pylance-release/issues/1039))
-   Completions for keywords that aren't available in the currently selected version of Python will no longer be offered.
    ([pylance-release#1724](https://github.com/microsoft/pylance-release/issues/1724))
-   Import completions will no longer include imports which will not resolve if accepted.
    ([pylance-release#1046](https://github.com/microsoft/pylance-release/issues/1046))
-   The bundled stubs for pandas have been updated.
-   Pylance's copy of typeshed has been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.163 to 1.1.165, including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: Fixed a false positive error (and crash) when a walrus operator (assignment expression) is used within a list comprehension which is passed as an argument to a function decorator.
        ([pylance-release#1745](https://github.com/microsoft/pylance-release/issues/1745))
-   [1.1.165](https://github.com/microsoft/pyright/releases/tag/1.1.165)
    -   Bug Fix: Fixed false positive error due to incorrect type of the `__doc__` instance variable. It should be `str | None`, but it was hard-coded to be `str`.
    -   Bug Fix: Fixed a bug that resulted in a false positive type error when an instance variable's type depended on itself in a circular reference within a loop.
    -   Bug Fix: Fixed false positive error when a binary operation uses `None` on the LHS and the RHS is a type that accepts `None` to a reverse operator overload method.
    -   Bug Fix: Improved logic that determines whether a type is iterable. The old logic didn't support unions of iterable types.
    -   Bug Fix: Improved handling of call expressions to functions that return NoReturn.
    -   Bug Fix: Fixed bug in recently-added type check for inherited class variable type. The check was not properly specializing the base class type.
    -   Enhancement: Updated typeshed stubs to the latest version.
    -   Enhancement: Added performance optimization for code flow analysis within loops.
        ([pylance-release#1686](https://github.com/microsoft/pylance-release/issues/1686))
    -   Enhancement (from Pylance): Don't offer keywords as completion suggestions if they are not valid for the currently-selected version of Python.
    -   Enhancement: Added check for subscripted form of `asyncio.Task` when used in certain contexts prior to Python 3.9 that generate runtime exceptions.
-   [1.1.164](https://github.com/microsoft/pyright/releases/tag/1.1.164)
    -   Bug Fix: Fixed false positive error when assigning an `Any` value to a member of an object that has a `__set__` method.
    -   Enhancement: Eliminated confusing error message when nested argument expression contains a type error.
    -   Enhancement: Improved bidirectional inference logic for lambda expressions to better handle the situation where the "expected type" is a union that contains multiple callable types.
    -   Behavior Change: Suppressed the "obscured symbol" diagnostic check when the name of the symbol is `_`. This symbol is used in the single dispatch pattern documented in PEP 443.
    -   Bug Fix (from Pylance): Support eggs that are not in zip files but are instead in folders.
    -   Enhancement (from Pylance): Support pth file in extra paths.
    -   Bug Fix: Fixed false positive error when a constrained TypeVar is used as the second argument to an isinstance or subclass call.
        ([pylance-release#1730](https://github.com/microsoft/pylance-release/issues/1730))
    -   Bug Fix: Fixed false positive error that occurs when a `@final` class derives from an abstract base class that defines no abstract methods.
        ([pylance-release#1732](https://github.com/microsoft/pylance-release/issues/1732))
    -   Bug Fix: Fixed false positive error related to overload implementation checks when the return type of the implementation contains a Tuple annotation with a TypeVar as a type argument.
    -   Enhancement: Added special-case handling for `tuple[()]` type when determining the iterated type. In this case, it can be safely evaluated as `Never`.
        ([pylance-release#1736](https://github.com/microsoft/pylance-release/issues/1736))
    -   Enhancement: Improved error reporting for assignments to class variable assignments within a child class where the assigned value doesn't match the type of the same-named class variable declared in a parent class.
        ([pylance-release#1726](https://github.com/microsoft/pylance-release/issues/1726))

## 2021.8.3 (25 Aug 2021)

Notable changes:

-   A bug that prevented navigation to directory-based eggs has been fixed. ([pylance-release#1685](https://github.com/microsoft/pylance-release/issues/1685))
-   Corrupt eggs and zips will no longer cause a crash. ([pylance-release#1692](https://github.com/microsoft/pylance-release/issues/1692))
-   Triple quote auto-close has been disabled for multi-line selections. ([pylance-release#1716](https://github.com/microsoft/pylance-release/issues/1716))
-   The bundled stubs for django and pandas have been updated.
-   pth files in directories in extraPaths will now be processed for additional paths. ([pylance-release#1709](https://github.com/microsoft/pylance-release/issues/1709))
-   Pylance's copy of typeshed has been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.162 to 1.1.163, including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: Fixed false positive error when assigning an Any value to a member of an object that has a `__set__` method.
    -   Enhancement: Eliminated confusing error message when nested argument expression contains a type error. ([pylance-release#1705](https://github.com/microsoft/pylance-release/issues/1705))
    -   Enhancement: Improved bidirectional inference logic for lambda expressions to better handle the situation where the "expected type" is a union that contains multiple callable types.
    -   Enhancement: Suppressed the "obscured symbol" diagnostic check when the name of the symbol is `_`. This symbol is used in the single dispatch pattern documented in PEP 443.
-   [1.1.163](https://github.com/microsoft/pyright/releases/tag/1.1.163)
    -   Bug Fix: Fixed false positive error relating to the use of a `*P.args` or `**P.kwargs` parameter as an iterable value (where `P` is a `ParamSpec`).
    -   Bug Fix: Fixed false positive error due to incomplete tracking of incomplete types during code flow evaluation.
    -   Bug Fix: Fixed bug with ParamSpec matching in the case where the matched function contains parameters with default values or `*args` / `**kwargs`;
    -   Bug Fix: Fixed false positive error that results when defining a property setter within an abstract base class and the property setter references a type that has a circular reference to the class.
    -   Bug Fix: Fixed a false positive error when handling *args and \*\*kwargs arguments when the function contains *P.args and \*\*P.kwargs parameters.
    -   Behavior Change (from Pylance): When inserting new auto-import symbol, sort by symbol type to match isort default behavior.
    -   Bug Fix: Fixed comparison operators so they use the proper opposite when looking for a type match. For example, the opposite of `__lt__` is `__ge__` rather than `__gt__`.
    -   Bug Fix: Fixed bug that caused inappropriate type narrowing if a comparison operator was used within an argument for a call expression which was, in turn, used within an `if` condition expression.
    -   Behavior Change: Changed the interpretation of a "callback protocol" to encompass protocols that include a `__call__` method in addition to other attributes.
    -   Bug Fix: Fixed false positive error related to `with` statements with an expression enclosed in single parentheses. ([pylance-release#1670](https://github.com/microsoft/pylance-release/issues/1670))
    -   Bug Fix: Fixed bug in type var matching when the a `cls` parameter is annotated with type `Type[T]` and `T` is bound to a protocol class.
    -   Bug Fix: Fixed bug that resulted in `# type: ignore` comments to be ignored in the event that we hit the heap high-water mark and emptied internal caches.
    -   Enhancement: Updated to latest version of typeshed stubs.

## 2021.8.2 (19 Aug 2021)

Notable changes:

-   Attribute doc strings are now supported in hover tooltips.
-   Diagnostics and other language features now work in untitled files and files manually marked as Python.
-   The "remove unused imports" code action now handles multiple statements on the same line properly. ([pylance-release#1547](https://github.com/microsoft/pylance-release/issues/1547))
-   Support for native modules stored in `dist-packages` has been improved, including `numpy` when installed globally on Debian-based Linux distributions.
-   Support for `cv2` has been improved. ([pylance-release#1339](https://github.com/microsoft/pylance-release/issues/1339)), ([pylance-release#1609](https://github.com/microsoft/pylance-release/issues/1609))

In addition, Pylance's copy of Pyright has been updated from 1.1.161 to 1.1.162, including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: Fixed false positive error relating to the use of a `*P.args` or `**P.kwargs` parameter as an iterable value (where `P` is a `ParamSpec`).
    -   Bug Fix: Fixed false positive error due to incomplete tracking of incomplete types during code flow evaluation.
    -   Bug Fix: Fixed bug with ParamSpec matching in the case where the matched function contains parameters with default values or `*args` / `**kwargs`;
    -   Bug Fix: Fixed false positive error that results when defining a property setter within an abstract base class and the property setter references a type that has a circular reference to the class. ([pylance-release#1683](https://github.com/microsoft/pylance-release/issues/1683))
    -   Bug Fix: Fixed a false positive error when handling `*args` and `**kwargs` arguments when the function contains `*P.args` and `**P.kwargs` parameters.
    -   Bug Fix: Fixed comparison operators so they use the proper opposite when looking for a type match. For example, the opposite of `__lt__` is `__ge__` rather than `__gt__`.
    -   Bug Fix: Fixed bug that caused inappropriate type narrowing if a comparison operator was used within an argument for a call expression which was, in turn, used within an `if` condition expression.
    -   Enhancement: Sort imports by import symbol type when auto-imports are applied. ([pylance-release#1675](https://github.com/microsoft/pylance-release/issues/1675))
-   [1.1.162](https://github.com/microsoft/pyright/releases/tag/1.1.162)
    -   Enhancement: Added support for unpacking of objects that derive from known-length tuples. This includes named tuples.
    -   Enhancement: Improved match statement code flow logic to handle the case where a pattern is exhausted prior to the last case statement.
    -   Enhancement: Improved "implied else" code flow logic to handle nested "implied else" constructs.
    -   Bug Fix: Fixed regression that affected type narrowing of subscript expressions for TypedDict objects.
    -   Bug Fix: Fixed false positive error caused by inappropriate method binding for instance methods.
    -   Enhancement (from pylance): Added more support in completion provide for literal expressions.
    -   Bug Fix: Changed registration of language server to allow for URI types other than files. This allows pyright to be activated when an untitled file is identified as a python source file.
    -   Bug Fix: Fixed false positive error when assigning to a subscript expression where the base type is a TypedDict.
    -   Bug Fix: Fixed false positive error when "\*P.args" parameter (where P is a ParamSpec) is passed as an argument to another function that accepts "P.args".
    -   Bug Fix: Added support for member access expressions where the attribute contains a class whose metaclass implements a descriptor protocol.
    -   Bug Fix: Fixed crash due to infinite recursion when a protocol class included a property getter that returned an instance of the same protocol class. ([pylance-release#1671](https://github.com/microsoft/pylance-release/issues/1671))
    -   Enhancement: Improved the readability of error messages related to protocol type mismatches.
    -   Bug Fix (from pylance): Fixed diagnostics for source files that are not on disk (e.g. "untitled" new documents).
    -   Enhancement (from pylance): Added support for attribute docstrings in hover text.

## 2021.8.1 (11 Aug 2021)

Notable changes:

-   More literal completions are now supported. ([pylance-release#1497](https://github.com/microsoft/pylance-release/issues/1497))
-   The bundled pandas stubs have been updated.
-   Pylance's copy of typeshed has been updated.
-   Creating new file in open file mode no longer causes a hang.

In addition, Pylance's copy of Pyright has been updated from 1.1.159 to 1.1.161, including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: Fixed false positive error caused by inappropriate method binding for instance methods.
    -   Bug Fix: Fixed regression that affected type narrowing of subscript expressions for TypedDict objects.
    -   Enhancement: Improved "implied else" code flow logic to handle nested "implied else" constructs.
    -   Enhancement: Improved match statement code flow logic to handle the case where a pattern is exhausted prior to the last case statement.
    -   Enhancement: Added support for unpacking of objects that derive from known-length tuples. This includes named tuples. ([pylance-release#1658](https://github.com/microsoft/pylance-release/issues/1658))
-   [1.1.161](https://github.com/microsoft/pyright/releases/tag/1.1.161)
    -   Bug Fix: Fixed bug in declaration provider that caused declaration not to be found when it referred to a metadata method.
    -   Bug Fix: Fixed bug that resulted in a false when evaluating nested lambdas (i.e. a lambda that returns a lambda).
    -   Enhancement: Added support for bidirectional type inference for assignment expressions where the LHS is an index expression that indexes into a TypedDict instance. ([pylance-release#1645](https://github.com/microsoft/pylance-release/issues/1645))
    -   Enhancement: Added support for new type narrowing pattern for discriminating among tuples. The pattern is `V[I] == L` or `V[I] != L` where `I` is an integer literal, `L` is another literal value, `V` is a tuple with a known length and a type at index `I` that is declared as a literal type.
    -   Enhancement: Improved logging for import failures. The previous code was printing the same log message for both stub and non-stub package resolution attempts which resulted in seemingly redundant messages.
    -   Enhancement: Added heuristic to allow proper inference of list expressions when used as the RHS operand in an expression of the form `my_list + [x]`.
    -   Bug Fix: Fixed a bug that was masking some error messages when multiple errors were reported for the same range and their message started with the same 25 characters.
    -   Enhancement: Changed method and attribute override compatibility checks to check for inappropriate overrides of all base classes in the multi-inheritance case. Previously, this check used MRO, so some override mismatches were left unreported if they were obscured by another base class. The change also affects `@final` checks. ([pylance-release#1495](https://github.com/microsoft/pylance-release/issues/1495))
    -   Enhancement: Added support for descriptor protocols defined on metaclasses.
    -   Bug Fix: Fixed a bug that caused methods in generic classes to be specialized twice when accessed through a member access expression.
    -   Bug Fix: Fixed false positive error when accessing `__name__` instance variable in a class that derives from `type`.
    -   Enhancement: Updated typeshed stubs to the latest version.
-   [1.1.160](https://github.com/microsoft/pyright/releases/tag/1.1.160)
    -   Enhancement: Updated the "type(x) is y" type narrowing logic to handle the negative case when the class type is "final".
    -   Bug Fix: Fixed bug that prevented "rename symbol" from working when in single-file mode. Rather than failing, it will now perform a rename only within a single file.
    -   Enhancement: Updated typeshed stubs to the latest version.
    -   Bug Fix: Fixed false positive that occurs when defining an abstract dataclass and one of its fields refers to the class itself in its type annotation.
    -   Bug Fix: Fixed bug in `x is None` type narrowing logic when `x` was typed as `object`.
    -   Bug Fix: Fixed bug that verified that a protocol class used within an isinstance call is runtime_checkable. It was skipping this check when the first argument to isinstance was an Any or Unknown type.
    -   Bug Fix: Fixed bug where a union of Literal[False] and Literal[True] were being coalesced into bool inappropriately in the case where they were conditional types that came from a constrained TypeVar.
    -   Bug Fix: Removed the assumption that all top-level modules in typeshed third-party stubs are unique. The typeshed folder structure allows multiple packages to have the same top-level module.
    -   Bug Fix: Fixed bug in the handling of generic recursive type aliases.
    -   Enhancement: Implemented support for new Python 3.10 dataclass features: `kw_only` parameter for `dataclass` and `field` and `KW_ONLY` separator. ([pylance-release#1626](https://github.com/microsoft/pylance-release/issues/1626))

## 2021.8.0 (4 Aug 2021)

Notable changes:

-   Performance of completions for huggingface/transformers has been improved by adding partial stubs. ([pylance-release#1258](https://github.com/microsoft/pylance-release/issues/1258))
-   Variable renaming now works in open file mode. ([pylance-release#1300](https://github.com/microsoft/pylance-release/issues/1300))
-   Pylance's copy of typeshed has been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.158 to 1.1.159, including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: Fixed bug in x is None type narrowing logic when x was typed as `object`.
    -   Bug Fix: Fixed false positive that occurs when defining an abstract dataclass and one of its fields refers to the class itself in its type annotation.
    -   Enhancement: Updated typeshed stubs to the latest version.
    -   Bug Fix: Fixed bug that prevented "rename symbol" from working when in single file mode. Rather than failing, it will now perform a rename only within a single file. ([pylance-release#1300](https://github.com/microsoft/pylance-release/issues/1300))
    -   Enhancement: Updated the "type(x) is y" type narrowing logic to handle the negative case when the class type is "final".
-   [1.1.159](https://github.com/microsoft/pyright/releases/tag/1.1.159)
    -   Bug Fix: Fixed bug that could lead to an internal stack overflow when a generic value was used as an argument for a function or class decorator.
    -   Enhancement: Added support in literal comparison type narrowing to filter out comparisons to "None" in positive case.
    -   Bug Fix: Fixed bug in parser where it was too permissive in allowing keywords to be used as identifiers. The Python interpreter is less permissive, so pyright's parser should match.
    -   Bug Fix: Fixed several bugs that caused crashes (dereference of undefined variable) in certain circumstances.
    -   Enhancement: Added a new log error for the case where enumeration of files within the workspace is taking longer than 10 seconds.
    -   Bug Fix: Fixed bug in tokenizer which treated 'constructor' as a keyword.
    -   Bug Fix: Fixed bug in "type(x) is y" type narrowing logic to handle the case where x is an instance of a generic class.
    -   Enhancement: Added check for illegal trailing comma in "from x import y," statement. This generates a syntax error at runtime.
    -   Enhancement: Added check for illegal use of "Protocol" as a type argument.
    -   Enhancement: Implemented new check for a class that is decorated with `@final` but does not implement all abstract methods from abstract classes that it derives from.
    -   Enhancement: Added check for inappropriate use of `ClassVar` that will generate runtime exceptions.
    -   Enhancement: Added logic to enforce protocol mismatches if a member in the protocol is marked "Final" and the class is not (or vice versa).
    -   Behavior Change: Modified assignment type narrowing for index expressions so it applies only to built-in types. This eliminates incorrect type inference when using a class that has assymetric `__setitem__` and `__getitem__` methods.
    -   Enhancement: Fixed false positive error when `@property` is combined with `@functools.cache`.

## 2021.7.7 (28 July 2021)

This is a hotfix release, fixing a tokenizer bug that caused identifiers called "constructor" to be mishandled.
([pylance-release#1618](https://github.com/microsoft/pylance-release/issues/1618))

## 2021.7.6 (28 July 2021)

Notable changes:

-   PEP 258 style "attribute docstrings" are now supported.
    ([pylance-release#1576](https://github.com/microsoft/pylance-release/issues/1576))
-   Attribute assignments that use reserved keywords now correctly cause a parser error.
-   A number of bugs that caused crashes in certain circumstances have been fixed.
    ([pylance-release#1597](https://github.com/microsoft/pylance-release/issues/1597))
-   The bundled stubs for django and pandas have been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.157 to 1.1.158, including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Enhancement: Added a new log error for the case where enumeration of files within the workspace is taking longer than 10 seconds.
    -   Bug Fix: Fixed several bugs that caused crashes (dereference of undefined variable) in certain circumstances.
    -   Bug Fix: Fixed bug in parser where it was too permissive in allowing keywords to be used as identifiers. The Python interpreter is less permissive, so pyright's parser should match.
    -   Enhancement: Added PEP 570 to the list of supported type features.
    -   Enhancement: Added support in literal comparison type narrowing to filter out comparisons to "None" in positive case.
    -   Bug Fix: Fixed bug that could lead to an internal stack overflow when a generic value was used as an argument for a function or class decorator.
        ([pylance-release#1597](https://github.com/microsoft/pylance-release/issues/1597))
-   [1.1.158](https://github.com/microsoft/pyright/releases/tag/1.1.158)
    -   Bug Fix: Fixed handling of generic type aliases with missing type arguments used in type annotations when the type alias itself is a member access expression.
    -   Enhancement: Added new diagnostic check (controlled by the existing "reportUnsupportedDunderAll" config switch) that reports an issue with a name specified in `__all__` if that symbol does not exist at the module level.
    -   Enhancement: Updated typeshed stubs to latest version.
    -   Enhancement: Added support for nested callables that use a ParamSpec at each level.
    -   Bug Fix: Fixed false positive error related to the use of the `Final` keyword when annotating attributes within a dataclass.
    -   Bug Fix: Fixed bug in TypeVar matching logic that allowed Type[T] to be matched against an instance of a type.
    -   Behavior Change: Changed type checking logic for functions to allow a function with a return result of `NoReturn` to match against any other return type.
    -   Bug Fix: Fixed false positive error in parser dealing with f-strings with string literals within the f-string expression that, in turn, have quotes within the string literal.
    -   Enhancement: Added support for "attribute docstrings" (defined in PEP 258) in completion provider.
        ([pylance-release#1576](https://github.com/microsoft/pylance-release/issues/1576))
    -   Bug Fix: Fixed bug in type analyzer related to a TypeVar with a bound type that is a union.

## 2021.7.5 (22 July 2021)

Notable changes:

-   Triple-quote closing now works correctly in LiveShare with multiple cursors.
    ([pylance-release#1583](https://github.com/microsoft/pylance-release/issues/1583))
-   A parser bug with f-strings containing nested strings has been fixed.
    ([pylance-release#1584](https://github.com/microsoft/pylance-release/issues/1584))
-   A new "reportUninitializedInstanceVariable" diagnostic check looks for instance variables that are not initialized in the class body or constructor.
-   The bundled stubs for django and pandas have been updated.
-   Pylance's copy of typeshed has been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.156 to 1.1.157, including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Behavior Change: Changed type checking logic for functions to allow a function with a return result of `NoReturn` to match against any other return type.
    -   Bug Fix: Fixed false positive error in parser dealing with f-strings with string literals within the f-string expression that, in turn, have quotes within the string literal.
    -   Bug Fix: Fixed bug in TypeVar matching logic that allowed `Type[T]` to be matched against an instance of a type.
    -   Bug Fix: Fixed false positive error related to the use of the Final keyword when annotating attributes within a dataclass.
        ([pylance-release#1574](https://github.com/microsoft/pylance-release/issues/1574))
    -   Enhancement: Added support for nested callables that use a ParamSpec at each level.
    -   Enhancement: Updated typeshed stubs to latest version.
    -   Enhancement: Updated docs for reportUnsupportedDunderAll.
    -   Enhancement: Added new diagnostic check (controlled by the existing "reportUnsupportedDunderAll" config switch) that reports an issue with a name specified in `__all__` if that symbol does not exist at the module level.
    -   Bug Fix: Fixed handling of generic type aliases with missing type arguments used in type annotations when the type alias itself is a member access expression.
        ([pylance-release#1565](https://github.com/microsoft/pylance-release/issues/1565))
-   [1.1.157](https://github.com/microsoft/pyright/releases/tag/1.1.157)
    -   Bug Fix: Fixed false positive error when calling an object that has an `Any` in its inheritance chain.
    -   Enhancement: Improved support for `callable` type narrowing in cases where the type is a non-callable instance, but a subtype could be callable.
    -   Enhancement: Improved handling of `callable` type narrowing when the type involves a constrained type variable.
    -   Enhancement: Added support for ParamSpec's within a Protocol, which is supported in Python 3.10.
    -   Enhancement: Improved handling of `isinstance` type narrowing logic when the type being narrowed is a callable.
    -   Bug Fix: Fixed recent regression in type evaluator that occurs when a generic (non-specialized) type is assigned to another generic type and the type parameter(s) for the generic type are invariant.
    -   Bug Fix: Fixed bug that caused diagnostics from an open file not to be cleared after closing that file if it was not saved.
    -   Enhancement (from pylance): Improved completion suggestions for literals when used as dictionary keys.
    -   New Feature: Implemented "reportUninitializedInstanceVariable" diagnostic check that looks for instance variables that are not initialized in the class body or constructor.
    -   Bug Fix: Fixed false positive error due to bug in constraint solver related to the handling of `Type[T]` when `T` is a constrained type variable.
    -   Bug Fix: Fixed false positive error related to the use of a recursive type alias when `from __future__ import annotations` was in effect.
    -   Bug Fix: Fixed false negative related to augmented assignment expressions when operand was a union type and a subset of the union subtypes were not supported for the operation.

## 2021.7.4 (15 July 2021)

This is a hotfix release, fixing an error message that could appear when the "add to extraPaths" code action was used.

## 2021.7.3 (14 July 2021)

Notable changes:

-   Fixed bug that caused diagnostics from an open file not to be cleared after closing that file if it was not saved.
    ([pylance-release#1514](https://github.com/microsoft/pylance-release/issues/1514))
-   Fixed document highlight regression when selecting a class attribute.
    ([pylance-release#1500](https://github.com/microsoft/pylance-release/issues/1500))
-   Dictionary key completions now support non-string literals.
    ([pylance-release#1493](https://github.com/microsoft/pylance-release/issues/1493))
-   The bundled stubs for django and pandas have been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.155 to 1.1.156, including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Bug Fix: Fixed bug that caused diagnostics from an open file not to be cleared after closing that file if it was not saved.
        ([pylance-release#1514](https://github.com/microsoft/pylance-release/issues/1514))
    -   Bug Fix: Fixed recent regression in type evaluator that occurs when a generic (non-specialized) type is assigned to another generic type and the type parameter(s) for the generic type are invariant.
        ([pylance-release#1526](https://github.com/microsoft/pylance-release/issues/1526))
    -   Enhancement: Improved handling of isinstance type narrowing logic when the type being narrowed is a callable
    -   Enhancement: Added support for ParamSpec's within a Protocol, which is supported in Python 3.10.
    -   Enhancement: Improved support for callable type narrowing in cases where the type is a non-callable instance, but a subtype could be callable.
    -   Bug Fix: Fixed false positive error when calling an object that has an Any in its inheritance chain.
-   [1.1.156](https://github.com/microsoft/pyright/releases/tag/1.1.156)
    -   Bug Fix: Fixed false positive error related to member access of optional type.
    -   Bug Fix: Fixed false positive error related to an escape sequence (backslash) used in an f-string format specifier.
    -   Bug Fix: Fixed false positive error with f-string format specifier that contains an expression within braces and also a colon specifier.
    -   Enhancement: Updated typeshed stubs to latest version.
    -   Bug Fix: Fixed false positive error when evaluating a subscript (index) operation with an index value that is a union type and an overloaded `__getitem__` method that requires union expansion.
    -   Enhancement: Added new check for a function overload that contains an implementation.
    -   Enhancement: Added special-case handling for addition of two tuples that have known lengths.
    -   Bug Fix: Fixed bug in check that detects improper variance for type variables used within generic protocols. Class or instance variables within a generic protocol must use invariant type variables.
    -   Enhancement: Improved heuristics for type matching when source and dest types are unions and invariance is being enforced — specifically in the case where the destination union type includes generic types.

## 2021.7.2 (7 July 2021)

This is a hotfix release, fixing a completion regression introduced in 2021.6.3.

## 2021.7.1 (6 July 2021)

Notable changes:

-   The bundled PIL stubs have been removed, as they have been merged into typeshed's Pillow stubs.

## 2021.7.0 (6 July 2021)

Notable changes:

-   An "add to extraPaths" quick fix for unresolved imports has been added, which suggests and adds potential paths `python.analysis.extraPaths`.
-   Support for the undocumented "mspythonconfig.json" config file name has been removed. This was previously available as an alternative to "pyrightconfig.json", but we've decided to standardize on the latter.

In addition, Pylance's copy of Pyright has been updated from 1.1.152 to 1.1.155, including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Enhancement: Updated to the latest version of typeshed
    -   Bug Fix: Fixed false positive error with f-string format specifier that contains an expression within braces and also a colon specifier.
        ([pylance-release#1522](https://github.com/microsoft/pylance-release/issues/1522))
    -   Bug Fix: Fixed false positive error related to an escape sequence (backslash) used in an f-string format specifier.
    -   Bug Fix: Fixed false positive error related to member access of optional type.
-   [1.1.155](https://github.com/microsoft/pyright/releases/tag/1.1.155)
    -   Bug Fix: Fixed recent regression that resulted in false positive errors when a class declaration used both `Type[X]` and `X` in its specialization of base classes.
    -   Bug Fix: Fixed false positive error related to `isinstance` narrowing of a non-constrained TypeVar.
    -   Bug Fix: Changed encoding of literals in error messages to avoid including raw (unescaped) special characters in output.
    -   Behavior Change: Increased maximum source file size from 16MB to 32MB.
        ([pylance-release#1520](https://github.com/microsoft/pylance-release/issues/1520))
    -   Enhancement: Improved formatting of error messages that include expressions — specifically when the expression includes an empty dict ("{}").
    -   Bug Fix: Fixed false positive error for the case where a function with positional/keyword parameters is assigned to a callback protocol that accepts only keyword parameters.
    -   Enhancement: Added support for member access expressions for the `None` object.
    -   Enhancement: Added support for `isinstance` and `issubclass` type narrowing where the variable type and the test type have no apparent relationship. The type evaluator synthesizes a class that is a subclass of both types — effectively an "intersection" of the two.
        ([pylance-release#1499](https://github.com/microsoft/pylance-release/issues/1499))
    -   Behavior Change: Modified `reportUnnecessaryIsInstance` diagnostic to never report always-false conditions because the type checker no longer generates such conditions.
        ([pylance-release#1496](https://github.com/microsoft/pylance-release/issues/1496))
-   [1.1.154](https://github.com/microsoft/pyright/releases/tag/1.1.154)
    -   Removed support for undocumented "mspythonconfig.json" config file name. This was previously available as an alternative to "pyrightconfig.json", but we've decided to standardize on the latter.
    -   Bug Fix: Changed logic for "overload missing implementation" check to not require an implementation within a protocol class.
    -   Enhancement: Updated typeshed stubs to latest version.
    -   Bug Fix: Fixed confusing error message when file or directory is specified on command line but is excluded by the "exclude" section of the config file.
    -   Behavior Change: Exempt classes from `__slots__` check if they explicitly declare an empty slots. This is commonly used for mix-in classes that are compatible with slotted classes.
    -   Internal Change: This version of pyright includes a significant change within the type evaluator that simplifies the code and eliminates a major source of bugs related to the handling of `Type[X]` type annotations.
-   [1.1.153](https://github.com/microsoft/pyright/releases/tag/1.1.153)
    -   Bug Fix: Fixed type evaluation bug where `Callable` is used to annotate an input parameter, and the `Callable` return type is a union that contains a type variable and the type variable is used within a nested function.
    -   Bug Fix: Fixed bug in "isinstance" type narrowing logic and in the "unnecessary isinstance" diagnostic check when the type being narrowed is a runtime-checkable protocol instance.
    -   Bug Fix: Fixed bug in type evaluator that resulted in a false positive error when a `__getattr__` was supplied in a metaclass, and it returned a generic callable type.
        ([pylance-release#1481](https://github.com/microsoft/pylance-release/issues/1481))
    -   Enhancement: Added validation for assignment of instance variables that are not declared in `__slots__`.
    -   Enhancement: Added check for class variables that conflict with an instance variable declared in `__slots__` within a class.
    -   Behavior Change: When displaying overloaded functions in hover text, filter out the implementation signature.
        ([pylance-release#1498](https://github.com/microsoft/pylance-release/issues/1498))
    -   Bug Fix: Fixed bug in code flow engine that caused incorrect type evaluation of complex expression that appears multiple times within a function in contexts where `isinstance` type narrowing generates different types for the same expression.

## 2021.6.3 (23 June 2021)

Notable changes:

-   Absolute imports of local files are now supported in "open file" mode.
-   Extract method/variable will now also trigger a rename on the newly generated symbol.
-   Pylance will now auto-close triple quoted strings.
-   Dictionary key completions that contain non-alpha characters will now work correctly.
    ([pylance-release#1460](https://github.com/microsoft/pylance-release/issues/1460))
-   Completions on nested TypedDicts will now work correctly.
    ([pylance-release#1485](https://github.com/microsoft/pylance-release/issues/1485))
-   The bundled stubs for matplotlib, django, openpyxl, and pandas have been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.149 to 1.1.152, including the following changes:

-   [1.1.152](https://github.com/microsoft/pyright/releases/tag/1.1.152)
    -   Bug Fix: Fixed false positive error involved in the instantiation of `type(self)()` within an abstract class.
    -   Bug Fix: Fixed parser bug that caused completion provider to not work correctly when completing relative imports ending in a dot.
        ([pylance-release#1479](https://github.com/microsoft/pylance-release/issues/1479))
    -   Bug Fix: Fixed bug that led to false positive error related to dictionary unpacking when the argument type is a type variable.
        ([pylance-release#1463](https://github.com/microsoft/pylance-release/issues/1463))
    -   Bug Fix: Fixed false positive error when using `del` keyword with a tuple expression.
        ([pylance-release#1480](https://github.com/microsoft/pylance-release/issues/1480))
    -   Bug Fix: Fixed bug in completion provider where it was interpreting prior quotes incorrectly when completing a typed dictionary key, most easily reproducible when using nested typed dictionaries.([pylance-release#1485](https://github.com/microsoft/pylance-release/issues/1485))
    -   Bug Fix: Eliminated false positive error for `Final` when it doesn't include a type argument.
    -   Bug Fix: Fixed several possible causes of stack overflow crashes in the type evaluator.
        ([pylance-release#1464](https://github.com/microsoft/pylance-release/issues/1464))
    -   Bug Fix (from pylance): Fixed bug in completion provider related to dictionary key completions that contain non-alpha characters.
        ([pylance-release#1460](https://github.com/microsoft/pylance-release/issues/1460))
    -   Bug Fix: Fixed false positive error when `super()` was used in a static or class method and the target function in the base class had an annotated cls parameter.
        ([pylance-release#1488](https://github.com/microsoft/pylance-release/issues/1488))
-   [1.1.151](https://github.com/microsoft/pyright/releases/tag/1.1.151)
    -   Enhancement: Added support for metaclasses that support the `__getitem__`, `__setitem__` and `__delitem__` magic methods, allowing classes that derive from these metaclasses to be used in index expressions.
    -   Bug Fix: Fixed bug that caused dataclass usage to break in Python 3.6 and older when using the polyfill library.
    -   Enhancement: Added conditional type support for `__setitem__` so a value with a type defined by a constrained TypeVar can be assigned to an index expression.
    -   Bug Fix: Fixed bug that caused a crash in the tokenizer when encountering a string literal that is extremely long (>100K in length).
    -   Bug Fix: Fixed bug caused by a variable assignment with a list expression on the RHS that was interpreted temporarily as a type alias declaration. Added more sanity checking on the type of the assigned expression for type aliases.
    -   Bug Fix: Fixed type evaluation bug where `Callable` is used to annotate an input parameter, and the `Callable` return type is a union that contains a type variable.
    -   Bug Fix: Fixed bug in constraint solver relating to replacement of return type of the form T when matching was performed against Type[T].
    -   Enhancement: Added support for `__builtins__` module symbol symbol.
    -   Enhancement: Added support for type narrowing conditional expressions of the form `a is False`, `a is True`, `a is not False` and `a is not True`.
-   [1.1.150](https://github.com/microsoft/pyright/releases/tag/1.1.150)
    -   Enhancement: Avoid completion suggestions when typing an ellipsis. (Thanks to contribution from Marc Mueller.)
    -   Bug Fix: Fixed false positive errors relating to unions created from a `Type[T]` type.
        ([pylance-release#1468]https://github.com/microsoft/pylance-release/issues/1468))
    -   Bug Fix: Fixed bug that caused class docString not to appear in signature help when invoking constructor for classes with synthesized constructor methods (e.g. dataclass or namedtuple).
    -   Behavior Change: Changed `reportPrivateUsage` diagnostic check to suppress the check when method or attribute comes from a type stub file. It is presumably part of the public interface contract in this case and not a private or protected member.
        ([pylance-release#1478](https://github.com/microsoft/pylance-release/issues/1478))
    -   Enhancement: Added completion suggestion support for dictionary key names.
    -   Bug Fix: Fixed bug in type evaluator that resulted in incorrect type in certain cases when evaluating function with declared return type of `Type[T]`.
        ([pylance-release#1462](https://github.com/microsoft/pylance-release/issues/1462))
    -   Bug Fix: Fixed false positive error that occurred when evaluating a binary operation provided by a metaclass when the LHS or RHS type was a `Type[T]`.
    -   Behavior Change: In basic type checking mode, enabled the following diagnostic checks by default: reportOptionalSubscript, reportOptionalMemberAccess, reportOptionalCall, reportOptionalIterable, reportOptionalContextManager, and reportOptionalOperand.
    -   Bug Fix: Fixed crashing bug in document symbol provider when handling import statements.
    -   Bug Fix: Fixed type evaluation bug that affected the specialization of a generic type alias that includes a bound TypeVar.

## 2021.6.2 (16 June 2021)

Notable changes:

-   Pylance will now offer completions inside dictionary key context if that dictionary was defined in the current scope.
-   The bundled stubs now include partial stubs for sympy.
    ([pylance-release#1388](https://github.com/microsoft/pylance-release/issues/1388), [pylance-release#946](https://github.com/microsoft/pylance-release/issues/946))

In addition, Pylance's copy of Pyright has been updated from 1.1.148 to 1.1.149, including the following changes:

-   Unreleased in Pyright, but included in Pylance:
    -   Behavior Change: Changed reportPrivateUsage diagnostic check to suppress the check when method or attribute comes from a type stub file. It is presumably part of the public interface contract in this case and not a private or protected member.
        ([pylance-release#1454](https://github.com/microsoft/pylance-release/issues/1454))
    -   Bug Fix: Fixed bug that caused class docString not to appear in signature help when invoking constructor for classes with synthesized constructor methods (e.g. dataclass or namedtuple).
        ([pylance-release#640](https://github.com/microsoft/pylance-release/issues/640))
    -   Bug Fix: Fixed false positive errors relating to unions created from a `Type[T]` type
        ([pylance-release#1422](https://github.com/microsoft/pylance-release/issues/1422))
    -   Enhancement: Return empty completionList for Ellipsis
-   [1.1.149](https://github.com/microsoft/pyright/releases/tag/1.1.149)
    -   Bug Fix (from pylance): Fixed crash that can occur when a library is installed in the form of a zip file, and that zip file is malformed.
        ([pylance-release#1421](https://github.com/microsoft/pylance-release/issues/1421))
    -   Bug Fix: Fixed bug that caused false positive error when using a generic type alias as a constructor call.
    -   Enhancement: Added check for illegal use of "async" keyword. The Python interpreter generates a syntax error if it is used outside of an async function.
    -   Enhancement: Tweaked heuristics in constraint solver for dealing with matching of TypeVar T for the type expression `Union[T, SomeClass[T]]`. There are two valid solutions if the argument is type `SomeClass-[X]`, but the "simpler" solution (`T = X`) should be preferred over the more complex (`T = SomeClass[X]`).
    -   Bug Fix: Fixed bug in type checker related to the use of a TypeVar or ParamSpec within an inner function when it is already bound to an outer function but used only within that outer function's return type a nnotation.
    -   Bug Fix: Added error handling for very large source files. This situation is now detected earlier so we don't attempt to load the file contents and crash the language server in the process.
        ([pylance-release#1426](https://github.com/microsoft/pylance-release/issues/1426))
    -   Behavior Change: Added logic to convert `Type[A | B]` into `Type[A] | Type[B]`, which avoids violating assumptions elsewhere in the type checker.
    -   Enhancement: Updated to the latest version of typeshed, which includes support for ParamSpec in contextlib's contextmanager function.
        ([pylance-release#516](https://github.com/microsoft/pylance-release/issues/516))
    -   Bug Fix: Fixed bug in type checker that occurred in some cases when a generic function returned `Type[T]`. In some cases where an input parameter also had an annotation of `Type[T]`, the "solved" type was wrapped in `Type` twice (e.g. `Type[Type[int]]`).
        ([pylance-release#1437](https://github.com/microsoft/pylance-release/issues/1437))
    -   Bug Fix: Fixed bug in type evaluator that occurred when calling a constructor of type `Type[T]` where `T` is a constrained TypeVar.
    -   Bug Fix: Fixed bug that resulted in an import being marked as unaccessed if it was accessed within a class declaration but was also redeclared within the class scope.

## 2021.6.1 (9 June 2021)

Notable changes:

-   Search paths returned by the Python interpreter are now normalized according to the case provided by the OS.
    ([pylance-release#1375](https://github.com/microsoft/pylance-release/issues/1375))
-   An error related to file watcher creation will no longer appear.
    ([pylance-release#1392](https://github.com/microsoft/pylance-release/issues/1392))
-   Pylance will no longer crash at startup when an invalid zip or egg file are present in the workspace.
    ([pylance-release#1397](https://github.com/microsoft/pylance-release/issues/1397))
-   Match/case statements will now be checked for exhaustiveness.
    ([pylance-release#1380](https://github.com/microsoft/pylance-release/issues/1380))

In addition, Pylance's copy of Pyright has been updated from 1.1.146 to 1.1.148, including the following changes:

-   [1.1.148](https://github.com/microsoft/pyright/releases/tag/1.1.148)
    -   Enhancement: Improved type narrowing of subject expression in a match statement when none of the case statements match the pattern and the code falls through the bottom of the match.
    -   Enhancement: Added support for pattern matching exhaustion detection in cases where there is not an explicit irrefutable pattern present.
        ([pylance-release#1380](https://github.com/microsoft/pylance-release/issues/1380))
    -   Bug Fix: Fixed recent regression that resulted in false positive errors when attempting to instantiate `tuple` or `type` directly.
    -   Enhancement: Improved type checking for classes that are assigned to `Callable` types. Previously, type incompatibilities were not reported if the `__init__` or `__new__` methods were overloaded within the class.
        ([pylance-release#1400](https://github.com/microsoft/pylance-release/issues/1400))
    -   Bug Fix: Fixed bug that caused parser error when handling a carriage return within a triple-quoted inner string within an outer triple-quoted f-string.
        ([pylance-release#1401](https://github.com/microsoft/pylance-release/issues/1401))
    -   Bug Fix: Fixed bug that resulted in false positive error when second argument to `NewType` call contained a `Type` object.
        ([pylance-release#1406](https://github.com/microsoft/pylance-release/issues/1406))
    -   Bug Fix: Fixed recent regression that resulted in a false positive error when instantiating a variable of type `Type[T]` where `T` was a protocol class.
    -   Bug Fix: Fixed bug in type printer that resulted in double parentheses around return type expressions when they involved unions.
    -   Bug Fix: Fixed bug that resulted in a false positive error when using generic `Type[T]` in a function parameter in overload validation.
        ([pylance-release#1407](https://github.com/microsoft/pylance-release/issues/1407))
    -   Bug Fix: Fixed bug in type checker relating to constrained type variables that combine non-union and union constraints.
        ([pylance-release#1412](https://github.com/microsoft/pylance-release/issues/1412))
    -   Bug Fix: Fixed bug in type checker when handling Final variables assigned at the class level. PEP 591 indicates that they should be treated as though they are annotated as ClassVar even though they are not.
    -   Bug Fix: Fixed a bug in the type checker relating to the use of a specialized generic class that is parameterized by a ParamSpec.
-   [1.1.147](https://github.com/microsoft/pyright/releases/tag/1.1.147)
    -   Enhancement: Added check for an attempt to instantiate a protocol class. This causes a runtime error.
    -   Behavior Change: Closed a hole in type narrowing for "in" operator when used with TypedDict. It can eliminate types from a union only if the type is marked final.
    -   Enhancement: Changed type printer to handle recursion differently — most notably when dealing with recursive type aliases. If it is asked to expand type aliases, it now expands only the first level of a given type alias, so if there's recursion, it will use the type alias name the second time it is encountered rather than continuing to expand it.
    -   Enhancement: Changed `reveal_type` and `reveal_locals` to expand type aliases in their output.
    -   Bug Fix: Fixed bug that resulted in incorrect type checking behavior when a type annotation involved a tuple with literal elements.
    -   Bug Fix: Fixed bug that affected the handling of a function decorator that uses ParamSpec when applied to a classmethod or staticmethod.
    -   Enhancement: Added diagnostic for an attempt to instantiate a special type like a Union, Callable, or Optional.
    -   Bug Fix: Improved support for generic functions that annotate a parameter and a return type with a union that includes a TypeVar. In such cases, the TypeVar may not be matched during constraint solving.
    -   Enhancement: Improved hover text for type variables and param specs by updating the label so they are not shown simply as type aliases.
    -   Enhancement: Updated to the latest typeshed stubs.

## 2021.6.0 (2 June 2021)

Notable changes:

-   Libraries installed via egg/zip files are now supported (including `transformers` installed via `conda`).
    ([pylance-release#1260](https://github.com/microsoft/pylance-release/issues/1260))
-   Unannotated decorators are now treated as no-ops, rather than using type inference and potentially obscuring the signature of the function they decorate.
-   Files that were referenced but unopened will no longer be mistakenly reanalyzed when opened.
-   Tables in docstrings are now better spaced.
-   The bundled stubs for django have been updated.
-   Pylance's copy of typeshed has been updated.

In addition, Pylance's copy of Pyright has been updated from 1.1.144 to 1.1.146, including the following changes:

-   [1.1.146](https://github.com/microsoft/pyright/releases/tag/1.1.146)
    -   Enhancement: Updated to the latest version of typeshed stubs.
    -   Behavior Change: Updated `reportIncompatibleVariableOverride` to avoid reporting an error when a class variable is reassigned a value in a base class without declaring its type.
    -   Bug Fix: Fixed false positive error indicating that a type alias is a variable. This results when a type alias refers to a union and that union is reformed when losing the original type alias.
    -   Enhancement: Added optimization for union creation where all subtypes are the same. This optimization commonly reduces the need to create new types during code flow operations. It also retains type alias info more faithfully.
    -   Enhancement: Added support for `__qualname__` and `__module__` attributes within a class body.
        ([pylance-release#1376](https://github.com/microsoft/pylance-release/issues/1376))
    -   Behavior Change: Changed call expression evaluation logic to not skip return type inference when there are errors detected during argument expression evaluation. This was previously added as an optimization, but it was leading to confusing results in some cases.
    -   Enhancement: Enhanced logic to detect unannotated decorator functions and treat them as no-ops rather than using return type inference, which often leads to incorrect and confusing results for decorators.
    -   Bug Fix: Fixed bug in pattern matching logic for class patterns where the class uses properties or descriptors for the targeted attributes.
    -   Enhancement (from pylance): Added support for libraries packages as zip/egg containers.
-   [1.1.145](https://github.com/microsoft/pyright/releases/tag/1.1.145)
    -   Bug Fix: Fixed bug that resulted in the incorrect type when bidirectional type inference (an "expected type") was used in conjunction with the `tuple()` constructor.
        ([pylance-release#1359](https://github.com/microsoft/pylance-release/issues/1359))
    -   Behavior Change: Changed logic to avoid reanalyzing a file when it is opened in the editor if we have already analyzed it and the file contents are the same as before.
    -   Bug Fix: Improved handling of call expressions where the call is a union and some of the subtypes return NoReturn and others do not.
    -   Behavior Change: Changed the logic that validates the assignment to instance variables that are marked `Final`. Previously, only one such assignment was allowed even if it was within an `__init__` method. It now allows an arbitrary number of assignments (conditional or otherwise) as long as they occur within an `__init__` method.
    -   Enhancement: Enhanced "reportIncompatibleVariableOverride" diagnostic check to detect the case where a base class declares a class variable and a child class tries to override it with an instance variable or vice versa.
    -   Bug Fix: Added logic to handle the case where a dataclass subclass overrides a member of its parent class with a ClassVar and another dataclass then subclasses from the child.
    -   Enhancement: Enhanced type stub generator so it doesn't emit "object" as base class, since that's implied in Python 3.x.
    -   Enhancement: Enhanced type stub generator to emit inferred function and method return types as comments.
    -   Behavior Change: Removed false positive error reported for a "bare" `raise` statement outside of an `except` clause.
        ([pylance-release#1365](https://github.com/microsoft/pylance-release/issues/1365))
    -   Bug Fix: Changed type variable constraint solver to preserve literal types when matching type arguments from other class types. In other cases, it typically "strips" the literal, widening the type to a str, int, etc. This change allows proper type evaluation in certain cases where a literal type is specified in a type annotation, such as with `Set[Literal["foo"]]`.
    -   Bug Fix: Fixed bug in code flow engine where it was sometimes evaluating the wrong type when cycles occurred in type dependencies.
        ([pylance-release#1356](https://github.com/microsoft/pylance-release/issues/1356))
    -   Bug Fix: Fixed bug that can result in a crash when indexing a file that includes a nested function or lambda that is used for type inference.
    -   Enhancement: Improved detection and reporting of illegal type alias recursion cases — e.g. when a possible type alias refers to a function that uses the type alias in parameter or return type annotations.
    -   Enhancement: Changed type printer to include a "\*" after a type if it is conditionally associated with a TypeVar constraint.
    -   Bug Fix: Augmented type checking logic for generator expressions to allow `await` keyword even though enclosing function isn't async. Also allowed generator expression to be evaluated as `AsyncGenerator` rather normal `Generator`.
        ([pylance-release#1348](https://github.com/microsoft/pylance-release/issues/1348))
    -   Enhancement: Changed the way conditional constraints are tracked in the type evaluator. This is a significant change that simplifies the logic and handles some cases that the old approach did not.

## 2021.5.4 (26 May 2021)

Notable changes:

-   Auto-import quick fixes now more closely match auto-import completions.
    ([pylance-release#1250](https://github.com/microsoft/pylance-release/issues/1250))
-   TypedDict support has been improved, supporting `**kwargs` unpacking checks and tagged union narrowing.
    ([pylance-release#374](https://github.com/microsoft/pylance-release/issues/374), [pylance-release#1328](https://github.com/microsoft/pylance-release/issues/1328), [pylance-release#1240](https://github.com/microsoft/pylance-release/issues/1240))
-   A bug that led to infinite recursion has been fixed.
    ([pylance-release#1315](https://github.com/microsoft/pylance-release/issues/1315))
-   Memory usage when indexing is enabled has been improved.
-   The bundled stubs for pandas have been updated.
-   The bundled stubs now include partial stubs for `gym`.

In addition, Pylance's copy of Pyright has been updated from 1.1.141 to 1.1.144, including the following changes:

-   [1.1.144](https://github.com/microsoft/pyright/releases/tag/1.1.144)
    -   Bug Fix: Changed CLI to not use process.exit() but instead return normally. The previous code sometimes resulted in truncated output.
    -   Enhancement: Added error for keyword-only parameter separator or position-only parameter separator appearing in a function signature after an "\*args" parameter. This will result in a runtime error.
        ([pylance-release#1341](https://github.com/microsoft/pylance-release/issues/1341))
    -   Enhancement: Improved error message for missing \*\*kwargs parameter when assigning one function to another.
